#include "mruby.h"
#include "irep.h"
#include "mstring.h"
#include "mproc.h"

static mrb_code iseq_0[] = {
  0x02800011,
  0x03000005,
  0x0280401e,
  0x00814001,
  0x02800007,
  0x02c00719,
  0x01401883,
  0x02804001,
  0x03000005,
  0x0280801e,
  0x03412b83,
  0x03800005,
  0x0280c0ac,
  0x01814001,
  0x02804001,
  0x03008001,
  0x0380c001,
  0x04000005,
  0x0281011e,
  0x003ff817,
  0x00000048,
};

void
balancer(mrb_state *mrb)
{
  int n = mrb->irep_len;
  int idx = n;
  mrb_irep *irep;

  mrb_add_irep(mrb, idx+1);

  irep = mrb->irep[idx] = mrb_malloc(mrb, sizeof(mrb_irep));
  irep->idx = idx++;
  irep->flags = 0;
  irep->nlocals = 5;
  irep->nregs = 8;
  irep->ilen = 21;
  irep->iseq = iseq_0;
  irep->slen = 5;
  irep->syms = mrb_malloc(mrb, sizeof(mrb_sym)*5);
  irep->syms[0] = mrb_intern(mrb, "ECRobot");
  irep->syms[1] = mrb_intern(mrb, "new");
  irep->syms[2] = mrb_intern(mrb, "light");
  irep->syms[3] = mrb_intern(mrb, "-");
  irep->syms[4] = mrb_intern(mrb, "run");
  irep->plen = 0;
  irep->pool = NULL;

  mrb->irep_len = idx;

  extern mrb_value mrb_top_self(mrb_state *mrb);
  mrb_run(mrb, mrb_proc_new(mrb, mrb->irep[n]), mrb_top_self(mrb), 0, 0);
}
