#ifndef MRUBY_ERROR_H
#define MRUBY_ERROR_H

struct RRescue {
  MRUBY_OBJECT_HEADER;
  struct RRescue *next;
  mrb_code *pc;
};

struct RException {
  MRUBY_OBJECT_HEADER;
};

void mrb_sys_fail(const char *mesg);
void mrb_exc_raise(mrb_state *mrb, mrb_value mesg);
void mrb_bug_errno(const char*, int);
void error_print(void);
int sysexit_status(mrb_state *mrb, mrb_value err);
void error_pos(void);
mrb_value mrb_exc_new3(mrb_state *mrb, struct RClass* c, mrb_value str);
mrb_value make_exception(mrb_state *mrb, int argc, mrb_value *argv, int isstr);
mrb_value mrb_exc_new(mrb_state *mrb, struct RClass *c, const char *ptr, long len);
mrb_value mrb_make_exception(mrb_state *mrb, int argc, mrb_value *argv);
mrb_value mrb_sprintf(mrb_state *mrb, const char *fmt, ...);
void mrb_name_error(mrb_state *mrb, mrb_sym id, const char *fmt, ...);

extern mrb_value exception_error;

#endif  /* MRUBY_ERROR_H */
