#include "../../mruby.h"
#include "readable_io.h"

// ReadableIO

mrb_value
rio_read_byte(mrb_state *mrb, mrb_value self)
{
  unsigned char *port;

  mrb_get_args(mrb, "i", &port);

  return mrb_fixnum_value(*port);
}

mrb_value
rio_read_word(mrb_state *mrb, mrb_value self)
{
  unsigned short *port;

  mrb_get_args(mrb, "i", &port);

  return mrb_fixnum_value(*port);
}

mrb_value
rio_read_dword(mrb_state *mrb, mrb_value self)
{
  unsigned long *port;

  mrb_get_args(mrb, "i", &port);

  return mrb_fixnum_value(*port);
}


void
mrb_init_readableIO(mrb_state *mrb)
{
  struct RClass *rio;

  rio = mrb_define_module(mrb, "ReadableIO");

  mrb_define_method(mrb, rio, "read_byte", rio_read_byte, ARGS_REQ(1));
  mrb_define_method(mrb, rio, "read_word", rio_read_word, ARGS_REQ(1));
  mrb_define_method(mrb, rio, "read_dword", rio_read_dword, ARGS_REQ(1));

  mrb_include_module(mrb, mrb->object_class, rio);
}
