#include "../../mruby.h"
#include "writable_io.h"

// WritableIO

mrb_value
wio_write_byte(mrb_state *mrb, mrb_value self)
{
  unsigned char *port;
  mrb_int value;

  mrb_get_args(mrb, "ii", &port, &value);

  *port = (unsigned char)value;

  return mrb_fixnum_value((unsigned char)value);
}

mrb_value
wio_write_word(mrb_state *mrb, mrb_value self)
{
  unsigned short *port;
  mrb_int value;

  mrb_get_args(mrb, "ii", &port, &value);

  *port = (unsigned short)value;

  return mrb_fixnum_value((unsigned short)value);
}

mrb_value
wio_write_dword(mrb_state *mrb, mrb_value self)
{
  unsigned long *port;
  mrb_int value;

  mrb_get_args(mrb, "ii", &port, &value);

  *port = (unsigned long)value;

  return mrb_fixnum_value((unsigned long)value);
}


void
mrb_init_writableIO(mrb_state *mrb)
{
  struct RClass *wio;

  wio = mrb_define_module(mrb, "WriteableIO");

  mrb_define_method(mrb, wio, "write_byte", wio_write_byte, ARGS_REQ(2));
  mrb_define_method(mrb, wio, "write_word", wio_write_word, ARGS_REQ(2));
  mrb_define_method(mrb, wio, "write_dword", wio_write_dword, ARGS_REQ(2));

  mrb_include_module(mrb, mrb->object_class, wio);
}
