#ifndef	_RTOS_H_
#define	_RTOS_H_

// Task
int rtos_tsk_create_auto_id(void*, int, long, int, int[]);
int rtos_tsk_create_spec_id(int, void*, int, long, int, int[]);
int rtos_tsk_sleep(long);
int rtos_tsk_lock();
int rtos_tsk_unlock();
int rtos_tsk_activate(int);
int rtos_tsk_suspend(int);
int rtos_tsk_resume(int);
int rtos_tsk_restart();
int rtos_tsk_delete(int);

// EventFlag
int rtos_evt_create_auto_id(int, int);
int rtos_evt_create_spec_id(int, int, int);
int rtos_evt_wait(int, long, int, int);
int rtos_evt_set(int, int);
int rtos_evt_reset(int, int);

// Mutex
int rtos_mut_create_auto_id(int);
int rtos_mut_create_spec_id(int, int);
int rtos_mut_wait(int, long);
int rtos_mut_release(int);

// Semaphore
int rtos_sem_create_auto_id(int, int);
int rtos_sem_create_spec_id(int, int, int);
int rtos_sem_wait(int, long, int);
int rtos_sem_release(int, int);

// MailBox
int rtos_mbx_create_auto_id(int, int, int);
int rtos_mbx_create_spec_id(int, int, int, int);
int rtos_mbx_wait(int, long, char*, size_t);
int rtos_mbx_send(int, char*);

// WatchdogTimer
int rtos_wdt_create_auto_id();
int rtos_wdt_create_spec_id(int);
int rtos_wdt_start(int, long, void*, int);
int rtos_wdt_cancel(int);

// Others
int rtos_tick_get();

#endif	//_RTOS_H_
