#ifndef RUBY_TIMEV_H
#define RUBY_TIMEV_H

struct vtm {
    mrb_value year; /* 2000 for example.  Integer. */
    int mon; /* 1..12 */
    int mday; /* 1..31 */
    int hour; /* 0..23 */
    int min; /* 0..59 */
    int sec; /* 0..60 */
    int subsecx; /* 0 <= subsecx < TIME_SCALE.  possibly Rational. */
    mrb_value utc_offset; /* -3600 as -01:00 for example.  possibly Rational. */
    int wday; /* 0:Sunday, 1:Monday, ..., 6:Saturday */
    int yday; /* 1..366 */
    int isdst; /* 0:StandardTime 1:DayLightSavingTime */
    const char *zone; /* "JST", "EST", "EDT", etc. */
};

struct time_object {
    long long timew; /* time_t value * TIME_SCALE.  possibly Rational. */
    struct vtm vtm;
    int gmt;
    int tm_got;
};

#define TIME_SCALE 1000000000

int int_time_year(mrb_state *mrb, mrb_value time);
int int_time_month(mrb_state *mrb, mrb_value time);
int int_time_mday(mrb_state *mrb, mrb_value time);
int int_time_hour(mrb_state *mrb, mrb_value time);
int int_time_min(mrb_state *mrb, mrb_value time);
int int_time_sec(mrb_state *mrb, mrb_value time);
int int_time_utc_offset(mrb_state *mrb, mrb_value time);
mrb_value glb_time_localtime(mrb_state *mrb, mrb_value time);
#endif
