#
#  IO
#
class IO
  # 15.2.20.4.1
  def self.open(*args, &block)
    io = self.new(*args)
    return io unless block
    begin
      block.call(io)  # return the result
    ensure
      io.close
    end
  end

  # 15.2.20.5.3
  def each(&block)
    return self if self.eof?
    while(line = self.gets)
      block.call(line)
    end
    self
  end

  # 15.2.20.5.4
  def each_byte(&block)
    # expect that IO#getc returns Integer value of the byte
    while(byte = self.getc)
      block.call(byte)
    end
    self
  end

  # 15.2.20.5.5
  # each_line(&block)
  alias each_line each
end
