/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "../parse.y"

#undef PARSER_TEST
#undef PARSER_DEBUG

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
#define YYSTACK_USE_ALLOCA 0

#include "mruby.h"
#include "st.h"
#include "compile.h"
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

#define YYLEX_PARAM p

typedef mrb_ast_node node;
typedef struct mrb_parser_state parser_state;

static int yylex(void *lval, parser_state *p);
static void yyerror(parser_state *p, const char *s);
static void yywarn(parser_state *p, const char *s);
static void yywarning(parser_state *p, const char *s);
static void backref_error(parser_state *p, node *n);

#define identchar(c) (isalnum(c) || (c) == '_' || !isascii(c))

#define TRUE  1
#define FALSE 0

typedef unsigned int stack_type;

#define BITSTACK_PUSH(stack, n)	((stack) = ((stack)<<1)|((n)&1))
#define BITSTACK_POP(stack)	((stack) = (stack) >> 1)
#define BITSTACK_LEXPOP(stack)	((stack) = ((stack) >> 1) | ((stack) & 1))
#define BITSTACK_SET_P(stack)	((stack)&1)

#define COND_PUSH(n)	BITSTACK_PUSH(p->cond_stack, (n))
#define COND_POP()	BITSTACK_POP(p->cond_stack)
#define COND_LEXPOP()	BITSTACK_LEXPOP(p->cond_stack)
#define COND_P()	BITSTACK_SET_P(p->cond_stack)

#define CMDARG_PUSH(n)	BITSTACK_PUSH(p->cmdarg_stack, (n))
#define CMDARG_POP()	BITSTACK_POP(p->cmdarg_stack)
#define CMDARG_LEXPOP()	BITSTACK_LEXPOP(p->cmdarg_stack)
#define CMDARG_P()	BITSTACK_SET_P(p->cmdarg_stack)

static mrb_sym
intern_gen(parser_state *p, const char *s)
{
  return mrb_intern(p->mrb, s);
}
#define intern(s) intern_gen(p,(s))

static void
cons_free_gen(parser_state *p, node *cons)
{
  cons->cdr = p->cells;
  p->cells = cons;
}
#define cons_free(c) cons_free_gen(p, (c))

static void*
parser_palloc(parser_state *p, size_t size)
{
  void *m = mrb_pool_alloc(p->pool, size);

  if (!m) {
    longjmp(p->jmp, 1);
  }
  return m;
}

static node*
cons_gen(parser_state *p, node *car, node *cdr)
{
  node *c;

  if (p->cells) {
    c = p->cells;
    p->cells = p->cells->cdr;
  }
  else {
    c = parser_palloc(p, sizeof(mrb_ast_node));
  }

  c->car = car;
  c->cdr = cdr;
  return c;
}
#define cons(a,b) cons_gen(p,(a),(b))

static node*
list1_gen(parser_state *p, node *a)
{
  return cons(a, 0);
}
#define list1(a) list1_gen(p, (a))

static node*
list2_gen(parser_state *p, node *a, node *b)
{
  return cons(a, cons(b,0));
}
#define list2(a,b) list2_gen(p, (a),(b))

static node*
list3_gen(parser_state *p, node *a, node *b, node *c)
{
  return cons(a, cons(b, cons(c,0)));
}
#define list3(a,b,c) list3_gen(p, (a),(b),(c))

static node*
list4_gen(parser_state *p, node *a, node *b, node *c, node *d)
{
  return cons(a, cons(b, cons(c, cons(d, 0))));
}
#define list4(a,b,c,d) list4_gen(p, (a),(b),(c),(d))

static node*
list5_gen(parser_state *p, node *a, node *b, node *c, node *d, node *e)
{
  return cons(a, cons(b, cons(c, cons(d, cons(e, 0)))));
}
#define list5(a,b,c,d,e) list5_gen(p, (a),(b),(c),(d),(e))

static node*
list6_gen(parser_state *p, node *a, node *b, node *c, node *d, node *e, node *f)
{
  return cons(a, cons(b, cons(c, cons(d, cons(e, cons(f, 0))))));
}
#define list6(a,b,c,d,e,f) list6_gen(p, (a),(b),(c),(d),(e),(f))

static node*
append_gen(parser_state *p, node *a, node *b)
{
  node *c = a;

  if (!a) return list1(b);
  while (c->cdr) {
    c = c->cdr;
  }
  if (b) {
    c->cdr = list1(b);
  }
  return a;
}
#define append(a,b) append_gen(p,(a),(b))

static char*
parser_strndup(parser_state *p, const char *s, size_t len)
{
  char *b = parser_palloc(p, len+1);

  memcpy(b, s, len);
  b[len] = '\0';
  return b;
}
#define strndup(s,len) parser_strndup(p, s, len)

static char*
parser_strdup(parser_state *p, const char *s)
{
  return parser_strndup(p, s, strlen(s));
}
#undef strdup
#define strdup(s) parser_strdup(p, s)

// xxx -----------------------------

static node*
local_switch(parser_state *p)
{
  node *prev = p->locals;

  p->locals = cons(0, 0);
  return prev;
}

static void
local_resume(parser_state *p, node *prev)
{
  p->locals = prev;
}

static void
local_nest(parser_state *p)
{
  p->locals = cons(0, p->locals);
}

static void
local_unnest(parser_state *p)
{
  p->locals = p->locals->cdr;
}

static int
local_var_p(parser_state *p, mrb_sym sym)
{
  node *l = p->locals;

  while (l) {
    node *n = l->car;
    while (n) {
      if ((mrb_sym)n->car == sym) return 1;
      n = n->cdr;
    }
    l = l->cdr;
  }
  return 0;
}

static void
local_add_f(parser_state *p, mrb_sym sym)
{
  p->locals->car = append(p->locals->car, (node*)sym);
}

static void
local_add(parser_state *p, mrb_sym sym)
{
  if (!local_var_p(p, sym)) {
    local_add_f(p, sym);
  }
}

// (:scope (vars..) (prog...))
static node*
new_scope(parser_state *p, node *body)
{
  return cons((node*)NODE_SCOPE, cons(p->locals->car, body));
}

// (:begin prog...)
static node*
new_begin(parser_state *p, node *body)
{
  if (body) 
    return list2((node*)NODE_BEGIN, body);
  return cons((node*)NODE_BEGIN, 0);
}

#define newline_node(n) (n)

// (:rescue body rescue else)
static node*
new_rescue(parser_state *p, node *body, node *resq, node *els)
{
  return list4((node*)NODE_RESCUE, body, resq, els);
}

// (:ensure body ensure)
static node*
new_ensure(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_ENSURE, cons(a, b));
}

// (:nil)
static node*
new_nil(parser_state *p)
{
  return list1((node*)NODE_NIL);
}

// (:true)
static node*
new_true(parser_state *p)
{
  return list1((node*)NODE_TRUE);
}

// (:true)
static node*
new_false(parser_state *p)
{
  return list1((node*)NODE_FALSE);
}

// (:alias new old)
static node*
new_alias(parser_state *p, mrb_sym a, mrb_sym b)
{
  return cons((node*)NODE_ALIAS, cons((node*)a, (node*)b));
}

// (:if cond then else)
static node*
new_if(parser_state *p, node *a, node *b, node *c)
{
  return list4((node*)NODE_IF, a, b, c);
}

// (:unless cond then else)
static node*
new_unless(parser_state *p, node *a, node *b, node *c)
{
  return list4((node*)NODE_IF, a, c, b);
}

// (:while cond body)
static node*
new_while(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_WHILE, cons(a, b));
}

// (:until cond body)
static node*
new_until(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_UNTIL, cons(a, b));
}

// (:for var obj body)
static node*
new_for(parser_state *p, node *v, node *o, node *b)
{
  return list4((node*)NODE_FOR, v, o, b);
}

// (:case a ((when ...) body) ((when...) body))
static node*
new_case(parser_state *p, node *a, node *b)
{
  node *n = list2((node*)NODE_CASE, a);
  node *n2 = n;

  while (n2->cdr) {
    n2 = n2->cdr;
  }
  n2->cdr = b;
  return n;
}

// (:postexe a)
static node*
new_postexe(parser_state *p, node *a)
{
  return cons((node*)NODE_POSTEXE, a);
}

// (:self)
static node*
new_self(parser_state *p)
{
  return list1((node*)NODE_SELF);
}

// (:call a b c)
static node*
new_call(parser_state *p, node *a, mrb_sym b, node *c)
{
  return list4((node*)NODE_CALL, a, (node*)b, c);
}

// (:fcall self mid args)
static node*
new_fcall(parser_state *p, mrb_sym b, node *c)
{
  return list4((node*)NODE_FCALL, new_self(p), (node*)b, c);
}

#if 0
// (:vcall self mid)
static node*
new_vcall(parser_state *p, mrb_sym b)
{
  return list3((node*)NODE_VCALL, new_self(p), (node*)b);
}
#endif

// (:super . c)
static node*
new_super(parser_state *p, node *c)
{
  return cons((node*)NODE_SUPER, c);
}

// (:zsuper)
static node*
new_zsuper(parser_state *p)
{
  return list1((node*)NODE_ZSUPER);
}

// (:yield . c)
static node*
new_yield(parser_state *p, node *c)
{
  if (c) {
    if (c->cdr) {
      yyerror(p, "both block arg and actual block given");
    }
    return cons((node*)NODE_YIELD, c->car);
  }
  return cons((node*)NODE_YIELD, 0);
}

// (:return . c)
static node*
new_return(parser_state *p, node *c)
{
  return cons((node*)NODE_RETURN, c);
}

// (:break . c)
static node*
new_break(parser_state *p, node *c)
{
  return cons((node*)NODE_BREAK, c);
}

// (:next . c)
static node*
new_next(parser_state *p, node *c)
{
  return cons((node*)NODE_NEXT, c);
}

// (:redo)
static node*
new_redo(parser_state *p)
{
  return list1((node*)NODE_REDO);
}

// (:retry)
static node*
new_retry(parser_state *p)
{
  return list1((node*)NODE_RETRY);
}

// (:dot2 a b)
static node*
new_dot2(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_DOT2, cons(a, b));
}

// (:dot3 a b)
static node*
new_dot3(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_DOT3, cons(a, b));
}

// (:colon2 b c)
static node*
new_colon2(parser_state *p, node *b, mrb_sym c)
{
  return cons((node*)NODE_COLON2, cons(b, (node*)c));
}

// (:colon3 . c)
static node*
new_colon3(parser_state *p, mrb_sym c)
{
  return cons((node*)NODE_COLON3, (node*)c);
}

// (:and a b)
static node*
new_and(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_AND, cons(a, b));
}

// (:or a b)
static node*
new_or(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_OR, cons(a, b));
}

// (:array a...)
static node*
new_array(parser_state *p, node *a)
{
  return cons((node*)NODE_ARRAY, a);
}

// (:splat . a)
static node*
new_splat(parser_state *p, node *a)
{
  return cons((node*)NODE_SPLAT, a);
}

// (:hash (k . v) (k . v)...)
static node*
new_hash(parser_state *p, node *a)
{
  return cons((node*)NODE_HASH, a);
}

// (:sym . a)
static node*
new_sym(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_SYM, (node*)sym);
}

// (:lvar . a)
static node*
new_lvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_LVAR, (node*)sym);
}

// (:gvar . a)
static node*
new_gvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_GVAR, (node*)sym);
}

// (:ivar . a)
static node*
new_ivar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_IVAR, (node*)sym);
}

// (:cvar . a)
static node*
new_cvar(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_CVAR, (node*)sym);
}

// (:const . a)
static node*
new_const(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_CONST, (node*)sym);
}

// (:undef a...)
static node*
new_undef(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_UNDEF, (node*)sym);
}

// (:class class super body)
static node*
new_class(parser_state *p, node *c, node *s, node *b)
{
  return list4((node*)NODE_CLASS, c, s, cons(p->locals->car, b));
}

// (:sclass obj body)
static node*
new_sclass(parser_state *p, node *o, node *b)
{
  return list3((node*)NODE_SCLASS, o, cons(p->locals->car, b));
}

// (:module module body)
static node*
new_module(parser_state *p, node *m, node *b)
{
  return list3((node*)NODE_MODULE, m, cons(p->locals->car, b));
}

// (:def m lv (arg . body))
static node*
new_def(parser_state *p, mrb_sym m, node *a, node *b)
{
  return list5((node*)NODE_DEF, (node*)m, p->locals->car, a, b);
}

// (:sdef obj m lv (arg . body))
static node*
new_sdef(parser_state *p, node *o, mrb_sym m, node *a, node *b)
{
  return list6((node*)NODE_SDEF, o, (node*)m, p->locals->car, a, b);
}

// (:arg . sym)
static node*
new_arg(parser_state *p, mrb_sym sym)
{
  return cons((node*)NODE_ARG, (node*)sym);
}

// (m o r m2 b)
// m: (a b c)
// o: ((a . e1) (b . e2))
// r: a
// m2: (a b c)
// b: a
static node*
new_args(parser_state *p, node *m, node *opt, mrb_sym rest, node *m2, mrb_sym blk)
{
  node *n;

  n = cons(m2, (node*)blk);
  n = cons((node*)rest, n);
  n = cons(opt, n);
  return cons(m, n);
}

// (:block_arg . a)
static node*
new_block_arg(parser_state *p, node *a)
{
  return cons((node*)NODE_BLOCK_ARG, a);
}

// (:block arg body)
static node*
new_block(parser_state *p, node *a, node *b)
{
  return list4((node*)NODE_BLOCK, p->locals->car, a, b);
}

// (:lambda arg body)
static node*
new_lambda(parser_state *p, node *a, node *b)
{
  return list4((node*)NODE_LAMBDA, p->locals->car, a, b);
}

// (:asgn lhs rhs)
static node*
new_asgn(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_ASGN, cons(a, b));
}

// (:masgn mlhs=(pre rest post)  mrhs)
static node*
new_masgn(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_MASGN, cons(a, b));
}

// (:asgn lhs rhs)
static node*
new_op_asgn(parser_state *p, node *a, mrb_sym op, node *b)
{
  return list4((node*)NODE_OP_ASGN, a, (node*)op, b);
}

// (:int . i)
static node*
new_int(parser_state *p, const char *s, int base)
{
  return list3((node*)NODE_INT, (node*)strdup(s), (node*)base);
}

// (:float . i)
static node*
new_float(parser_state *p, const char *s)
{
  return cons((node*)NODE_FLOAT, (node*)strdup(s));
}

// (:str . (s . len))
static node*
new_str(parser_state *p, const char *s, size_t len)
{
  return cons((node*)NODE_STR, cons((node*)strndup(s, len), (node*)len));
}

// (:backref . n)
static node*
new_back_ref(parser_state *p, int n)
{
  return cons((node*)NODE_BACK_REF, (node*)n);
}

// (:nthref . n)
static node*
new_nth_ref(parser_state *p, int n)
{
  return cons((node*)NODE_NTH_REF, (node*)n);
}

static void
new_bv(parser_state *p, mrb_sym id)
{
}

// xxx -----------------------------

// (:call a op)
static node*
call_uni_op(parser_state *p, node *recv, char *m)
{
  return new_call(p, recv, intern(m), 0);
}

// (:call a op b)
static node*
call_bin_op(parser_state *p, node *recv, char *m, node *arg1)
{
  return new_call(p, recv, intern(m), list1(list1(arg1)));
}

// (:match (a . b))
static node*
match_op(parser_state *p, node *a, node *b)
{
  return cons((node*)NODE_MATCH, cons((node*)a, (node*)b));
}


static void
args_with_block(parser_state *p, node *a, node *b)
{
  if (b) {
    if (a->cdr) {
      yyerror(p, "both block arg and actual block given");
    }
    a->cdr = b;
  }
}

static void
call_with_block(parser_state *p, node *a, node *b)
{
  node *n = a->cdr->cdr->cdr;

  if (!n->car) n->car = cons(0, b);
  else {
    args_with_block(p, n->car, b);
  }
}

static node*
negate_lit(parser_state *p, node *n)
{
  return cons((node*)NODE_NEGATE, n);
}

static node*
cond(node *n)
{
  return n;
}

static node*
ret_args(parser_state *p, node *n)
{
  if (n->cdr) {
    yyerror(p, "block argument should not be given");
  }
  if (!n->car->cdr) return n->car->car;
  return new_array(p, n->car);
}

static void
assignable(parser_state *p, node *lhs)
{
  switch ((int)lhs->car) {
  case NODE_LVAR:
    local_add(p, (mrb_sym)lhs->cdr);
    break;
  default:
    break;
  }
}

static node*
var_reference(parser_state *p, node *lhs)
{
  node *n;

  switch ((int)lhs->car) {
  case NODE_LVAR:
    if (!local_var_p(p, (mrb_sym)lhs->cdr)) {
      n = new_fcall(p, (mrb_sym)lhs->cdr, 0);
      cons_free(lhs);
      return n;
    }
    break;
  default:
    break;
  }
  return lhs;
}

// xxx -----------------------------



/* Line 189 of yacc.c  */
#line 867 "../y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     keyword_class = 258,
     keyword_module = 259,
     keyword_def = 260,
     keyword_undef = 261,
     keyword_begin = 262,
     keyword_rescue = 263,
     keyword_ensure = 264,
     keyword_end = 265,
     keyword_if = 266,
     keyword_unless = 267,
     keyword_then = 268,
     keyword_elsif = 269,
     keyword_else = 270,
     keyword_case = 271,
     keyword_when = 272,
     keyword_while = 273,
     keyword_until = 274,
     keyword_for = 275,
     keyword_break = 276,
     keyword_next = 277,
     keyword_redo = 278,
     keyword_retry = 279,
     keyword_in = 280,
     keyword_do = 281,
     keyword_do_cond = 282,
     keyword_do_block = 283,
     keyword_do_LAMBDA = 284,
     keyword_return = 285,
     keyword_yield = 286,
     keyword_super = 287,
     keyword_self = 288,
     keyword_nil = 289,
     keyword_true = 290,
     keyword_false = 291,
     keyword_and = 292,
     keyword_or = 293,
     keyword_not = 294,
     modifier_if = 295,
     modifier_unless = 296,
     modifier_while = 297,
     modifier_until = 298,
     modifier_rescue = 299,
     keyword_alias = 300,
     keyword_BEGIN = 301,
     keyword_END = 302,
     keyword__LINE__ = 303,
     keyword__FILE__ = 304,
     keyword__ENCODING__ = 305,
     tIDENTIFIER = 306,
     tFID = 307,
     tGVAR = 308,
     tIVAR = 309,
     tCONSTANT = 310,
     tCVAR = 311,
     tLABEL = 312,
     tINTEGER = 313,
     tFLOAT = 314,
     tSTRING = 315,
     tXSTRING = 316,
     tCHAR = 317,
     tREGEXP = 318,
     tNTH_REF = 319,
     tBACK_REF = 320,
     tREGEXP_END = 321,
     tUPLUS = 322,
     tUMINUS = 323,
     tPOW = 324,
     tCMP = 325,
     tEQ = 326,
     tEQQ = 327,
     tNEQ = 328,
     tGEQ = 329,
     tLEQ = 330,
     tANDOP = 331,
     tOROP = 332,
     tMATCH = 333,
     tNMATCH = 334,
     tDOT2 = 335,
     tDOT3 = 336,
     tAREF = 337,
     tASET = 338,
     tLSHFT = 339,
     tRSHFT = 340,
     tCOLON2 = 341,
     tCOLON3 = 342,
     tOP_ASGN = 343,
     tASSOC = 344,
     tLPAREN = 345,
     tLPAREN_ARG = 346,
     tRPAREN = 347,
     tLBRACK = 348,
     tLBRACE = 349,
     tLBRACE_ARG = 350,
     tSTAR = 351,
     tAMPER = 352,
     tLAMBDA = 353,
     tSYMBEG = 354,
     tSTRING_BEG = 355,
     tXSTRING_BEG = 356,
     tREGEXP_BEG = 357,
     tWORDS_BEG = 358,
     tQWORDS_BEG = 359,
     tSTRING_DBEG = 360,
     tSTRING_DVAR = 361,
     tSTRING_END = 362,
     tLAMBEG = 363,
     tLOWEST = 364,
     tUMINUS_NUM = 365,
     idNULL = 366,
     idRespond_to = 367,
     idIFUNC = 368,
     idCFUNC = 369,
     id_core_set_method_alias = 370,
     id_core_set_variable_alias = 371,
     id_core_undef_method = 372,
     id_core_define_method = 373,
     id_core_define_singleton_method = 374,
     id_core_set_postexe = 375,
     tLAST_TOKEN = 376
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 799 "../parse.y"

    node *node;
    mrb_sym id;
    int num;
    const struct vtable *vars;



/* Line 214 of yacc.c  */
#line 1033 "../y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1045 "../y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   9868

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  148
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  141
/* YYNRULES -- Number of rules.  */
#define YYNRULES  512
/* YYNRULES -- Number of states.  */
#define YYNSTATES  907

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   376

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     147,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   124,     2,     2,     2,   122,   117,     2,
     143,   144,   120,   118,   141,   119,   140,   121,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   112,   146,
     114,   110,   113,   111,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   139,     2,   145,   116,     2,   142,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   137,   115,   138,   125,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   123,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    12,    14,    18,    21,
      23,    24,    30,    35,    38,    40,    42,    46,    49,    50,
      55,    58,    62,    66,    70,    74,    78,    83,    85,    89,
      93,   100,   106,   112,   118,   124,   128,   132,   136,   140,
     142,   146,   150,   152,   156,   160,   164,   167,   169,   171,
     173,   175,   177,   182,   187,   188,   194,   197,   201,   206,
     212,   217,   223,   226,   229,   232,   235,   238,   240,   244,
     246,   250,   252,   255,   259,   265,   268,   273,   276,   281,
     283,   287,   289,   293,   296,   300,   302,   305,   307,   312,
     316,   320,   324,   328,   331,   333,   335,   340,   344,   348,
     352,   356,   359,   361,   363,   365,   368,   370,   374,   376,
     378,   380,   382,   384,   386,   388,   390,   392,   393,   398,
     400,   402,   404,   406,   408,   410,   412,   414,   416,   418,
     420,   422,   424,   426,   428,   430,   432,   434,   436,   438,
     440,   442,   444,   446,   448,   450,   452,   454,   456,   458,
     460,   462,   464,   466,   468,   470,   472,   474,   476,   478,
     480,   482,   484,   486,   488,   490,   492,   494,   496,   498,
     500,   502,   504,   506,   508,   510,   512,   514,   516,   518,
     520,   522,   524,   526,   528,   530,   532,   534,   536,   540,
     546,   550,   556,   563,   569,   575,   581,   587,   592,   596,
     600,   604,   608,   612,   616,   620,   624,   628,   633,   638,
     641,   644,   648,   652,   656,   660,   664,   668,   672,   676,
     680,   684,   688,   692,   696,   699,   702,   706,   710,   714,
     718,   725,   727,   729,   731,   734,   739,   742,   746,   748,
     750,   752,   754,   757,   762,   765,   767,   770,   773,   778,
     780,   781,   784,   787,   790,   792,   794,   797,   801,   806,
     810,   815,   818,   820,   822,   824,   826,   828,   830,   832,
     836,   837,   842,   846,   850,   853,   857,   861,   863,   868,
     872,   874,   879,   883,   886,   888,   891,   892,   897,   904,
     911,   912,   913,   921,   922,   923,   931,   937,   942,   943,
     944,   954,   955,   962,   963,   964,   973,   974,   980,   981,
     988,   989,   990,  1000,  1002,  1004,  1006,  1008,  1010,  1012,
    1014,  1017,  1019,  1021,  1023,  1029,  1031,  1034,  1036,  1038,
    1040,  1044,  1046,  1050,  1052,  1057,  1064,  1068,  1074,  1077,
    1082,  1084,  1088,  1095,  1104,  1109,  1116,  1121,  1124,  1131,
    1134,  1139,  1146,  1149,  1154,  1157,  1162,  1164,  1166,  1168,
    1172,  1174,  1179,  1181,  1184,  1186,  1190,  1192,  1194,  1199,
    1201,  1205,  1209,  1210,  1216,  1219,  1224,  1229,  1232,  1237,
    1242,  1246,  1250,  1254,  1257,  1259,  1264,  1265,  1271,  1272,
    1278,  1284,  1286,  1288,  1295,  1297,  1299,  1301,  1303,  1306,
    1308,  1311,  1313,  1315,  1317,  1319,  1321,  1323,  1325,  1328,
    1330,  1332,  1334,  1336,  1338,  1340,  1343,  1346,  1348,  1350,
    1352,  1354,  1356,  1358,  1360,  1362,  1364,  1366,  1368,  1370,
    1372,  1374,  1376,  1378,  1379,  1384,  1387,  1391,  1394,  1401,
    1410,  1415,  1422,  1427,  1434,  1437,  1442,  1449,  1452,  1457,
    1460,  1465,  1467,  1468,  1470,  1472,  1474,  1476,  1478,  1480,
    1482,  1486,  1488,  1492,  1496,  1500,  1502,  1506,  1508,  1512,
    1514,  1516,  1519,  1521,  1523,  1525,  1528,  1531,  1533,  1535,
    1536,  1541,  1543,  1546,  1548,  1552,  1556,  1559,  1561,  1563,
    1565,  1567,  1569,  1571,  1573,  1575,  1577,  1579,  1581,  1583,
    1584,  1586,  1587,  1589,  1592,  1595,  1596,  1598,  1600,  1602,
    1604,  1606,  1609
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     149,     0,    -1,    -1,   150,   151,    -1,   152,   281,    -1,
     288,    -1,   153,    -1,   152,   287,   153,    -1,     1,   153,
      -1,   158,    -1,    -1,    46,   154,   137,   151,   138,    -1,
     156,   240,   218,   243,    -1,   157,   281,    -1,   288,    -1,
     158,    -1,   157,   287,   158,    -1,     1,   158,    -1,    -1,
      45,   179,   159,   179,    -1,     6,   181,    -1,   158,    40,
     162,    -1,   158,    41,   162,    -1,   158,    42,   162,    -1,
     158,    43,   162,    -1,   158,    44,   158,    -1,    47,   137,
     156,   138,    -1,   160,    -1,   168,   110,   163,    -1,   252,
      88,   163,    -1,   214,   139,   190,   284,    88,   163,    -1,
     214,   140,    51,    88,   163,    -1,   214,   140,    55,    88,
     163,    -1,   214,    86,    55,    88,   163,    -1,   214,    86,
      51,    88,   163,    -1,   254,    88,   163,    -1,   175,   110,
     197,    -1,   168,   110,   186,    -1,   168,   110,   197,    -1,
     161,    -1,   175,   110,   163,    -1,   175,   110,   160,    -1,
     163,    -1,   161,    37,   161,    -1,   161,    38,   161,    -1,
      39,   282,   161,    -1,   124,   163,    -1,   185,    -1,   161,
      -1,   167,    -1,   164,    -1,   233,    -1,   233,   140,   278,
     192,    -1,   233,    86,   278,   192,    -1,    -1,    95,   166,
     224,   156,   138,    -1,   277,   192,    -1,   277,   192,   165,
      -1,   214,   140,   278,   192,    -1,   214,   140,   278,   192,
     165,    -1,   214,    86,   278,   192,    -1,   214,    86,   278,
     192,   165,    -1,    32,   192,    -1,    31,   192,    -1,    30,
     191,    -1,    21,   191,    -1,    22,   191,    -1,   170,    -1,
      90,   169,   283,    -1,   170,    -1,    90,   169,   283,    -1,
     172,    -1,   172,   171,    -1,   172,    96,   174,    -1,   172,
      96,   174,   141,   173,    -1,   172,    96,    -1,   172,    96,
     141,   173,    -1,    96,   174,    -1,    96,   174,   141,   173,
      -1,    96,    -1,    96,   141,   173,    -1,   174,    -1,    90,
     169,   283,    -1,   171,   141,    -1,   172,   171,   141,    -1,
     171,    -1,   172,   171,    -1,   251,    -1,   214,   139,   190,
     284,    -1,   214,   140,    51,    -1,   214,    86,    51,    -1,
     214,   140,    55,    -1,   214,    86,    55,    -1,    87,    55,
      -1,   254,    -1,   251,    -1,   214,   139,   190,   284,    -1,
     214,   140,    51,    -1,   214,    86,    51,    -1,   214,   140,
      55,    -1,   214,    86,    55,    -1,    87,    55,    -1,   254,
      -1,    51,    -1,    55,    -1,    87,   176,    -1,   176,    -1,
     214,    86,   176,    -1,    51,    -1,    55,    -1,    52,    -1,
     183,    -1,   184,    -1,   178,    -1,   248,    -1,   179,    -1,
     179,    -1,    -1,   181,   141,   182,   180,    -1,   115,    -1,
     116,    -1,   117,    -1,    70,    -1,    71,    -1,    72,    -1,
      78,    -1,    79,    -1,   113,    -1,    74,    -1,   114,    -1,
      75,    -1,    73,    -1,    84,    -1,    85,    -1,   118,    -1,
     119,    -1,   120,    -1,    96,    -1,   121,    -1,   122,    -1,
      69,    -1,   124,    -1,   125,    -1,    67,    -1,    68,    -1,
      82,    -1,    83,    -1,   142,    -1,    48,    -1,    49,    -1,
      50,    -1,    46,    -1,    47,    -1,    45,    -1,    37,    -1,
       7,    -1,    21,    -1,    16,    -1,     3,    -1,     5,    -1,
      26,    -1,    15,    -1,    14,    -1,    10,    -1,     9,    -1,
      36,    -1,    20,    -1,    25,    -1,     4,    -1,    22,    -1,
      34,    -1,    39,    -1,    38,    -1,    23,    -1,     8,    -1,
      24,    -1,    30,    -1,    33,    -1,    32,    -1,    13,    -1,
      35,    -1,     6,    -1,    17,    -1,    31,    -1,    11,    -1,
      12,    -1,    18,    -1,    19,    -1,   175,   110,   185,    -1,
     175,   110,   185,    44,   185,    -1,   252,    88,   185,    -1,
     252,    88,   185,    44,   185,    -1,   214,   139,   190,   284,
      88,   185,    -1,   214,   140,    51,    88,   185,    -1,   214,
     140,    55,    88,   185,    -1,   214,    86,    51,    88,   185,
      -1,   214,    86,    55,    88,   185,    -1,    87,    55,    88,
     185,    -1,   254,    88,   185,    -1,   185,    80,   185,    -1,
     185,    81,   185,    -1,   185,   118,   185,    -1,   185,   119,
     185,    -1,   185,   120,   185,    -1,   185,   121,   185,    -1,
     185,   122,   185,    -1,   185,    69,   185,    -1,   123,    58,
      69,   185,    -1,   123,    59,    69,   185,    -1,    67,   185,
      -1,    68,   185,    -1,   185,   115,   185,    -1,   185,   116,
     185,    -1,   185,   117,   185,    -1,   185,    70,   185,    -1,
     185,   113,   185,    -1,   185,    74,   185,    -1,   185,   114,
     185,    -1,   185,    75,   185,    -1,   185,    71,   185,    -1,
     185,    72,   185,    -1,   185,    73,   185,    -1,   185,    78,
     185,    -1,   185,    79,   185,    -1,   124,   185,    -1,   125,
     185,    -1,   185,    84,   185,    -1,   185,    85,   185,    -1,
     185,    76,   185,    -1,   185,    77,   185,    -1,   185,   111,
     185,   282,   112,   185,    -1,   198,    -1,   185,    -1,   288,
      -1,   196,   285,    -1,   196,   141,   275,   285,    -1,   275,
     285,    -1,   143,   190,   283,    -1,   288,    -1,   188,    -1,
     288,    -1,   191,    -1,   196,   141,    -1,   196,   141,   275,
     141,    -1,   275,   141,    -1,   167,    -1,   196,   195,    -1,
     275,   195,    -1,   196,   141,   275,   195,    -1,   194,    -1,
      -1,   193,   191,    -1,    97,   186,    -1,   141,   194,    -1,
     288,    -1,   186,    -1,    96,   186,    -1,   196,   141,   186,
      -1,   196,   141,    96,   186,    -1,   196,   141,   186,    -1,
     196,   141,    96,   186,    -1,    96,   186,    -1,   244,    -1,
     245,    -1,   246,    -1,   247,    -1,   253,    -1,   254,    -1,
      52,    -1,     7,   155,    10,    -1,    -1,    91,   161,   199,
     283,    -1,    90,   156,   144,    -1,   214,    86,    55,    -1,
      87,    55,    -1,    93,   187,   145,    -1,    94,   274,   138,
      -1,    30,    -1,    31,   143,   191,   283,    -1,    31,   143,
     283,    -1,    31,    -1,    39,   143,   161,   283,    -1,    39,
     143,   283,    -1,   277,   235,    -1,   234,    -1,   234,   235,
      -1,    -1,    98,   200,   229,   230,    -1,    11,   162,   215,
     156,   217,    10,    -1,    12,   162,   215,   156,   218,    10,
      -1,    -1,    -1,    18,   201,   162,   216,   202,   156,    10,
      -1,    -1,    -1,    19,   203,   162,   216,   204,   156,    10,
      -1,    16,   162,   281,   238,    10,    -1,    16,   281,   238,
      10,    -1,    -1,    -1,    20,   219,    25,   205,   162,   216,
     206,   156,    10,    -1,    -1,     3,   177,   255,   207,   155,
      10,    -1,    -1,    -1,     3,    84,   161,   208,   286,   209,
     155,    10,    -1,    -1,     4,   177,   210,   155,    10,    -1,
      -1,     5,   178,   211,   257,   155,    10,    -1,    -1,    -1,
       5,   272,   280,   212,   178,   213,   257,   155,    10,    -1,
      21,    -1,    22,    -1,    23,    -1,    24,    -1,   198,    -1,
     286,    -1,    13,    -1,   286,    13,    -1,   286,    -1,    27,
      -1,   218,    -1,    14,   162,   215,   156,   217,    -1,   288,
      -1,    15,   156,    -1,   175,    -1,   168,    -1,   260,    -1,
      90,   222,   283,    -1,   220,    -1,   221,   141,   220,    -1,
     221,    -1,   221,   141,    96,   260,    -1,   221,   141,    96,
     260,   141,   221,    -1,   221,   141,    96,    -1,   221,   141,
      96,   141,   221,    -1,    96,   260,    -1,    96,   260,   141,
     221,    -1,    96,    -1,    96,   141,   221,    -1,   262,   141,
     265,   141,   268,   271,    -1,   262,   141,   265,   141,   268,
     141,   262,   271,    -1,   262,   141,   265,   271,    -1,   262,
     141,   265,   141,   262,   271,    -1,   262,   141,   268,   271,
      -1,   262,   141,    -1,   262,   141,   268,   141,   262,   271,
      -1,   262,   271,    -1,   265,   141,   268,   271,    -1,   265,
     141,   268,   141,   262,   271,    -1,   265,   271,    -1,   265,
     141,   262,   271,    -1,   268,   271,    -1,   268,   141,   262,
     271,    -1,   270,    -1,   288,    -1,   225,    -1,   115,   226,
     115,    -1,    77,    -1,   115,   223,   226,   115,    -1,   288,
      -1,   146,   227,    -1,   228,    -1,   227,   141,   228,    -1,
      51,    -1,   259,    -1,   143,   258,   226,   283,    -1,   258,
      -1,   108,   156,   138,    -1,    29,   156,    10,    -1,    -1,
      28,   232,   224,   156,    10,    -1,   167,   231,    -1,   233,
     140,   278,   189,    -1,   233,    86,   278,   189,    -1,   277,
     188,    -1,   214,   140,   278,   189,    -1,   214,    86,   278,
     188,    -1,   214,    86,   279,    -1,   214,   140,   188,    -1,
     214,    86,   188,    -1,    32,   188,    -1,    32,    -1,   214,
     139,   190,   284,    -1,    -1,   137,   236,   224,   156,   138,
      -1,    -1,    26,   237,   224,   156,    10,    -1,    17,   196,
     215,   156,   239,    -1,   218,    -1,   238,    -1,     8,   241,
     242,   215,   156,   240,    -1,   288,    -1,   186,    -1,   197,
      -1,   288,    -1,    89,   175,    -1,   288,    -1,     9,   156,
      -1,   288,    -1,   250,    -1,   248,    -1,    62,    -1,    60,
      -1,    61,    -1,    63,    -1,    99,   249,    -1,   178,    -1,
      54,    -1,    53,    -1,    56,    -1,    58,    -1,    59,    -1,
     123,    58,    -1,   123,    59,    -1,    51,    -1,    54,    -1,
      53,    -1,    56,    -1,    55,    -1,   251,    -1,   251,    -1,
      34,    -1,    33,    -1,    35,    -1,    36,    -1,    49,    -1,
      48,    -1,    64,    -1,    65,    -1,   286,    -1,    -1,   114,
     256,   162,   286,    -1,     1,   286,    -1,   143,   258,   283,
      -1,   258,   286,    -1,   262,   141,   266,   141,   268,   271,
      -1,   262,   141,   266,   141,   268,   141,   262,   271,    -1,
     262,   141,   266,   271,    -1,   262,   141,   266,   141,   262,
     271,    -1,   262,   141,   268,   271,    -1,   262,   141,   268,
     141,   262,   271,    -1,   262,   271,    -1,   266,   141,   268,
     271,    -1,   266,   141,   268,   141,   262,   271,    -1,   266,
     271,    -1,   266,   141,   262,   271,    -1,   268,   271,    -1,
     268,   141,   262,   271,    -1,   270,    -1,    -1,    55,    -1,
      54,    -1,    53,    -1,    56,    -1,   259,    -1,    51,    -1,
     260,    -1,    90,   222,   283,    -1,   261,    -1,   262,   141,
     261,    -1,    51,   110,   186,    -1,    51,   110,   214,    -1,
     264,    -1,   265,   141,   264,    -1,   263,    -1,   266,   141,
     263,    -1,   120,    -1,    96,    -1,   267,    51,    -1,   267,
      -1,   117,    -1,    97,    -1,   269,    51,    -1,   141,   270,
      -1,   288,    -1,   253,    -1,    -1,   143,   273,   161,   283,
      -1,   288,    -1,   275,   285,    -1,   276,    -1,   275,   141,
     276,    -1,   186,    89,   186,    -1,    57,   186,    -1,    51,
      -1,    55,    -1,    52,    -1,    51,    -1,    55,    -1,    52,
      -1,   183,    -1,    51,    -1,    52,    -1,   183,    -1,   140,
      -1,    86,    -1,    -1,   287,    -1,    -1,   147,    -1,   282,
     144,    -1,   282,   145,    -1,    -1,   147,    -1,   141,    -1,
     146,    -1,   147,    -1,   286,    -1,   287,   146,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   952,   952,   952,   963,   969,   973,   977,   981,   987,
     989,   988,  1003,  1029,  1035,  1039,  1043,  1047,  1053,  1053,
    1057,  1061,  1065,  1069,  1073,  1077,  1081,  1088,  1089,  1093,
    1097,  1101,  1105,  1109,  1114,  1118,  1123,  1127,  1131,  1135,
    1138,  1142,  1149,  1150,  1154,  1158,  1162,  1166,  1169,  1176,
    1177,  1180,  1181,  1185,  1192,  1191,  1204,  1208,  1213,  1217,
    1222,  1226,  1231,  1235,  1239,  1243,  1247,  1253,  1257,  1263,
    1264,  1270,  1274,  1278,  1282,  1286,  1290,  1294,  1298,  1302,
    1306,  1312,  1313,  1319,  1323,  1329,  1333,  1339,  1343,  1347,
    1351,  1355,  1359,  1365,  1371,  1378,  1382,  1386,  1390,  1394,
    1398,  1404,  1410,  1417,  1421,  1424,  1428,  1432,  1438,  1439,
    1440,  1441,  1446,  1453,  1454,  1457,  1463,  1467,  1467,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,  1482,  1483,
    1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,  1493,
    1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,  1504,  1504,
    1504,  1505,  1505,  1506,  1506,  1506,  1507,  1507,  1507,  1507,
    1508,  1508,  1508,  1509,  1509,  1509,  1510,  1510,  1510,  1510,
    1511,  1511,  1511,  1511,  1512,  1512,  1512,  1512,  1513,  1513,
    1513,  1513,  1514,  1514,  1514,  1514,  1515,  1515,  1518,  1522,
    1526,  1530,  1534,  1538,  1542,  1546,  1550,  1555,  1560,  1565,
    1569,  1573,  1577,  1581,  1585,  1589,  1593,  1597,  1601,  1605,
    1609,  1613,  1617,  1621,  1625,  1629,  1633,  1637,  1641,  1645,
    1649,  1653,  1657,  1666,  1670,  1674,  1678,  1682,  1686,  1690,
    1694,  1698,  1704,  1711,  1712,  1716,  1720,  1726,  1732,  1733,
    1736,  1737,  1738,  1742,  1746,  1752,  1756,  1760,  1764,  1768,
    1774,  1774,  1786,  1792,  1796,  1802,  1806,  1810,  1814,  1820,
    1824,  1828,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1844,
    1850,  1850,  1855,  1859,  1863,  1867,  1871,  1875,  1879,  1883,
    1887,  1891,  1895,  1899,  1903,  1904,  1910,  1909,  1922,  1929,
    1936,  1936,  1936,  1942,  1942,  1942,  1948,  1954,  1959,  1961,
    1958,  1968,  1967,  1980,  1985,  1979,  1998,  1997,  2010,  2009,
    2022,  2023,  2022,  2036,  2040,  2044,  2048,  2054,  2061,  2062,
    2063,  2066,  2067,  2070,  2071,  2079,  2080,  2086,  2090,  2093,
    2097,  2103,  2107,  2113,  2117,  2121,  2125,  2129,  2133,  2137,
    2141,  2145,  2151,  2155,  2159,  2163,  2167,  2171,  2175,  2179,
    2183,  2187,  2191,  2195,  2199,  2203,  2207,  2213,  2214,  2221,
    2226,  2231,  2238,  2239,  2245,  2246,  2249,  2254,  2257,  2261,
    2267,  2271,  2278,  2277,  2290,  2300,  2304,  2310,  2314,  2318,
    2322,  2326,  2330,  2334,  2338,  2342,  2349,  2348,  2359,  2358,
    2370,  2378,  2387,  2390,  2397,  2400,  2404,  2405,  2408,  2412,
    2415,  2419,  2422,  2423,  2429,  2430,  2433,  2436,  2439,  2446,
    2447,  2448,  2449,  2452,  2453,  2454,  2458,  2464,  2468,  2472,
    2476,  2480,  2486,  2492,  2496,  2500,  2504,  2508,  2512,  2519,
    2528,  2529,  2532,  2537,  2536,  2544,  2551,  2557,  2563,  2567,
    2571,  2575,  2579,  2583,  2587,  2591,  2595,  2599,  2603,  2607,
    2611,  2615,  2620,  2626,  2631,  2636,  2641,  2648,  2652,  2659,
    2663,  2669,  2673,  2679,  2686,  2693,  2697,  2703,  2707,  2713,
    2714,  2717,  2722,  2728,  2729,  2732,  2739,  2743,  2750,  2755,
    2755,  2779,  2780,  2786,  2790,  2796,  2800,  2806,  2807,  2808,
    2811,  2812,  2813,  2814,  2817,  2818,  2819,  2822,  2823,  2826,
    2827,  2830,  2831,  2834,  2837,  2840,  2841,  2842,  2845,  2846,
    2849,  2850,  2854
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "keyword_class", "keyword_module",
  "keyword_def", "keyword_undef", "keyword_begin", "keyword_rescue",
  "keyword_ensure", "keyword_end", "keyword_if", "keyword_unless",
  "keyword_then", "keyword_elsif", "keyword_else", "keyword_case",
  "keyword_when", "keyword_while", "keyword_until", "keyword_for",
  "keyword_break", "keyword_next", "keyword_redo", "keyword_retry",
  "keyword_in", "keyword_do", "keyword_do_cond", "keyword_do_block",
  "keyword_do_LAMBDA", "keyword_return", "keyword_yield", "keyword_super",
  "keyword_self", "keyword_nil", "keyword_true", "keyword_false",
  "keyword_and", "keyword_or", "keyword_not", "modifier_if",
  "modifier_unless", "modifier_while", "modifier_until", "modifier_rescue",
  "keyword_alias", "keyword_BEGIN", "keyword_END", "keyword__LINE__",
  "keyword__FILE__", "keyword__ENCODING__", "tIDENTIFIER", "tFID", "tGVAR",
  "tIVAR", "tCONSTANT", "tCVAR", "tLABEL", "tINTEGER", "tFLOAT", "tSTRING",
  "tXSTRING", "tCHAR", "tREGEXP", "tNTH_REF", "tBACK_REF", "tREGEXP_END",
  "tUPLUS", "tUMINUS", "tPOW", "tCMP", "tEQ", "tEQQ", "tNEQ", "tGEQ",
  "tLEQ", "tANDOP", "tOROP", "tMATCH", "tNMATCH", "tDOT2", "tDOT3",
  "tAREF", "tASET", "tLSHFT", "tRSHFT", "tCOLON2", "tCOLON3", "tOP_ASGN",
  "tASSOC", "tLPAREN", "tLPAREN_ARG", "tRPAREN", "tLBRACK", "tLBRACE",
  "tLBRACE_ARG", "tSTAR", "tAMPER", "tLAMBDA", "tSYMBEG", "tSTRING_BEG",
  "tXSTRING_BEG", "tREGEXP_BEG", "tWORDS_BEG", "tQWORDS_BEG",
  "tSTRING_DBEG", "tSTRING_DVAR", "tSTRING_END", "tLAMBEG", "tLOWEST",
  "'='", "'?'", "':'", "'>'", "'<'", "'|'", "'^'", "'&'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "tUMINUS_NUM", "'!'", "'~'", "idNULL",
  "idRespond_to", "idIFUNC", "idCFUNC", "id_core_set_method_alias",
  "id_core_set_variable_alias", "id_core_undef_method",
  "id_core_define_method", "id_core_define_singleton_method",
  "id_core_set_postexe", "tLAST_TOKEN", "'{'", "'}'", "'['", "'.'", "','",
  "'`'", "'('", "')'", "']'", "';'", "'\\n'", "$accept", "program", "$@1",
  "top_compstmt", "top_stmts", "top_stmt", "@2", "bodystmt", "compstmt",
  "stmts", "stmt", "$@3", "command_asgn", "expr", "expr_value",
  "command_call", "block_command", "cmd_brace_block", "$@4", "command",
  "mlhs", "mlhs_inner", "mlhs_basic", "mlhs_item", "mlhs_list",
  "mlhs_post", "mlhs_node", "lhs", "cname", "cpath", "fname", "fsym",
  "fitem", "undef_list", "$@5", "op", "reswords", "arg", "arg_value",
  "aref_args", "paren_args", "opt_paren_args", "opt_call_args",
  "call_args", "command_args", "@6", "block_arg", "opt_block_arg", "args",
  "mrhs", "primary", "$@7", "@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "@15", "@16", "@17", "@18", "@19", "$@20", "@21",
  "primary_value", "then", "do", "if_tail", "opt_else", "for_var",
  "f_marg", "f_marg_list", "f_margs", "block_param", "opt_block_param",
  "block_param_def", "opt_bv_decl", "bv_decls", "bvar", "f_larglist",
  "lambda_body", "do_block", "$@22", "block_call", "method_call",
  "brace_block", "$@23", "$@24", "case_body", "cases", "opt_rescue",
  "exc_list", "exc_var", "opt_ensure", "literal", "string", "xstring",
  "regexp", "symbol", "sym", "numeric", "variable", "var_lhs", "var_ref",
  "backref", "superclass", "$@25", "f_arglist", "f_args", "f_bad_arg",
  "f_norm_arg", "f_arg_item", "f_arg", "f_opt", "f_block_opt",
  "f_block_optarg", "f_optarg", "restarg_mark", "f_rest_arg",
  "blkarg_mark", "f_block_arg", "opt_f_block_arg", "singleton", "$@26",
  "assoc_list", "assocs", "assoc", "operation", "operation2", "operation3",
  "dot_or_colon", "opt_terms", "opt_nl", "rparen", "rbracket", "trailer",
  "term", "terms", "none", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      61,    63,    58,    62,    60,   124,    94,    38,    43,    45,
      42,    47,    37,   365,    33,   126,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   123,   125,    91,
      46,    44,    96,    40,    41,    93,    59,    10
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   148,   150,   149,   151,   152,   152,   152,   152,   153,
     154,   153,   155,   156,   157,   157,   157,   157,   159,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     160,   160,   161,   161,   161,   161,   161,   161,   162,   163,
     163,   164,   164,   164,   166,   165,   167,   167,   167,   167,
     167,   167,   167,   167,   167,   167,   167,   168,   168,   169,
     169,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   171,   171,   172,   172,   173,   173,   174,   174,   174,
     174,   174,   174,   174,   174,   175,   175,   175,   175,   175,
     175,   175,   175,   176,   176,   177,   177,   177,   178,   178,
     178,   178,   178,   179,   179,   180,   181,   182,   181,   183,
     183,   183,   183,   183,   183,   183,   183,   183,   183,   183,
     183,   183,   183,   183,   183,   183,   183,   183,   183,   183,
     183,   183,   183,   183,   183,   183,   183,   183,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   184,   184,
     184,   184,   184,   184,   184,   184,   184,   184,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   186,   187,   187,   187,   187,   188,   189,   189,
     190,   190,   190,   190,   190,   191,   191,   191,   191,   191,
     193,   192,   194,   195,   195,   196,   196,   196,   196,   197,
     197,   197,   198,   198,   198,   198,   198,   198,   198,   198,
     199,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   200,   198,   198,   198,
     201,   202,   198,   203,   204,   198,   198,   198,   205,   206,
     198,   207,   198,   208,   209,   198,   210,   198,   211,   198,
     212,   213,   198,   198,   198,   198,   198,   214,   215,   215,
     215,   216,   216,   217,   217,   218,   218,   219,   219,   220,
     220,   221,   221,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   224,   224,   225,
     225,   225,   226,   226,   227,   227,   228,   228,   229,   229,
     230,   230,   232,   231,   233,   233,   233,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   236,   235,   237,   235,
     238,   239,   239,   240,   240,   241,   241,   241,   242,   242,
     243,   243,   244,   244,   245,   245,   246,   247,   248,   249,
     249,   249,   249,   250,   250,   250,   250,   251,   251,   251,
     251,   251,   252,   253,   253,   253,   253,   253,   253,   253,
     254,   254,   255,   256,   255,   255,   257,   257,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   259,   259,   259,   259,   260,   260,   261,
     261,   262,   262,   263,   264,   265,   265,   266,   266,   267,
     267,   268,   268,   269,   269,   270,   271,   271,   272,   273,
     272,   274,   274,   275,   275,   276,   276,   277,   277,   277,
     278,   278,   278,   278,   279,   279,   279,   280,   280,   281,
     281,   282,   282,   283,   284,   285,   285,   285,   286,   286,
     287,   287,   288
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     1,     3,     2,     1,
       0,     5,     4,     2,     1,     1,     3,     2,     0,     4,
       2,     3,     3,     3,     3,     3,     4,     1,     3,     3,
       6,     5,     5,     5,     5,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     2,     1,     1,     1,
       1,     1,     4,     4,     0,     5,     2,     3,     4,     5,
       4,     5,     2,     2,     2,     2,     2,     1,     3,     1,
       3,     1,     2,     3,     5,     2,     4,     2,     4,     1,
       3,     1,     3,     2,     3,     1,     2,     1,     4,     3,
       3,     3,     3,     2,     1,     1,     4,     3,     3,     3,
       3,     2,     1,     1,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     5,
       3,     5,     6,     5,     5,     5,     5,     4,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     3,     3,     3,     3,
       6,     1,     1,     1,     2,     4,     2,     3,     1,     1,
       1,     1,     2,     4,     2,     1,     2,     2,     4,     1,
       0,     2,     2,     2,     1,     1,     2,     3,     4,     3,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       0,     4,     3,     3,     2,     3,     3,     1,     4,     3,
       1,     4,     3,     2,     1,     2,     0,     4,     6,     6,
       0,     0,     7,     0,     0,     7,     5,     4,     0,     0,
       9,     0,     6,     0,     0,     8,     0,     5,     0,     6,
       0,     0,     9,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     5,     1,     2,     1,     1,     1,
       3,     1,     3,     1,     4,     6,     3,     5,     2,     4,
       1,     3,     6,     8,     4,     6,     4,     2,     6,     2,
       4,     6,     2,     4,     2,     4,     1,     1,     1,     3,
       1,     4,     1,     2,     1,     3,     1,     1,     4,     1,
       3,     3,     0,     5,     2,     4,     4,     2,     4,     4,
       3,     3,     3,     2,     1,     4,     0,     5,     0,     5,
       5,     1,     1,     6,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     4,     2,     3,     2,     6,     8,
       4,     6,     4,     6,     2,     4,     6,     2,     4,     2,
       4,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     1,     0,
       4,     1,     2,     1,     3,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     0,     1,     2,     2,     0,     1,     1,     1,     1,
       1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     0,     1,     0,     0,     0,     0,     0,     0,
       0,     0,   499,   290,   293,     0,   313,   314,   315,   316,
     277,   280,   384,   425,   424,   426,   427,   501,     0,    10,
       0,   429,   428,   417,   268,   419,   418,   421,   420,   413,
     414,   405,   406,   404,   407,   430,   431,     0,     0,     0,
       0,     0,   512,   512,    79,   286,     0,     0,     0,     0,
       3,   499,     6,     9,    27,    39,    42,    50,    49,     0,
      67,     0,    71,    81,     0,    47,   231,     0,    51,   284,
     262,   263,   264,   265,   403,   402,   423,     0,   266,   267,
     250,     5,     8,   313,   314,   277,   280,   384,     0,   103,
     104,     0,     0,     0,     0,   106,     0,   317,     0,   423,
     267,     0,   306,   158,   168,   159,   181,   155,   174,   164,
     163,   184,   185,   179,   162,   161,   157,   182,   186,   187,
     166,   156,   169,   173,   175,   167,   160,   176,   183,   178,
     177,   170,   180,   165,   154,   172,   171,   153,   151,   152,
     148,   149,   150,   108,   110,   109,   143,   144,   140,   122,
     123,   124,   131,   128,   130,   125,   126,   145,   146,   132,
     133,   137,   127,   129,   119,   120,   121,   134,   135,   136,
     138,   139,   141,   142,   147,   479,   308,   111,   112,   478,
       0,   177,   170,   180,   165,   148,   149,   108,   109,   113,
     116,    20,   114,     0,     0,   512,   499,    15,    14,     0,
      48,     0,     0,     0,   423,     0,   267,     0,   508,   509,
     499,     0,   510,   500,     0,     0,     0,   328,   327,     0,
       0,   423,   267,     0,     0,     0,     0,   245,   232,   255,
      65,   249,   512,   512,   483,    66,    64,   501,    63,     0,
     512,   383,    62,   501,   502,     0,    18,     0,     0,   209,
       0,   210,   274,     0,     0,   501,    69,   270,     0,   505,
     505,   233,     0,     0,   505,   481,     0,     0,    77,     0,
      87,    94,   452,   411,   410,   412,   409,   408,   415,   416,
      46,   224,   225,     4,   500,     0,     0,     0,     0,     0,
       0,     0,   372,   374,     0,    83,     0,    75,    72,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   512,     0,     0,
       0,   388,   386,   285,     0,     0,   377,    56,   283,   303,
     103,   104,   105,   415,   416,     0,   433,   301,   432,     0,
     512,     0,     0,     0,   452,   498,   497,   310,   117,    17,
     269,   512,   512,   394,    13,   500,   274,   319,     0,   318,
       0,     0,   512,     0,     0,     0,     0,     0,     0,     0,
     511,     0,     0,   274,     0,   512,     0,   298,   486,   256,
     252,     0,     0,   246,   254,     0,   247,   501,     0,   279,
     251,   501,   241,   512,   512,   240,   501,   282,    45,     0,
       0,     0,     0,     0,     0,   501,   272,    68,   501,   275,
     507,   506,   234,   507,   236,   276,   482,    93,    85,     0,
      80,     0,     0,   512,     0,   458,   455,   454,   453,   456,
       0,   470,   474,   473,   469,   452,     0,   369,   457,   459,
     461,   512,   467,   512,   472,   512,     0,   451,     0,     0,
       7,    21,    22,    23,    24,    25,    43,    44,   512,     0,
      28,    37,     0,    38,   501,     0,    73,    84,    41,    40,
       0,   188,   255,    36,   206,   214,   219,   220,   221,   216,
     218,   228,   229,   222,   223,   199,   200,   226,   227,   501,
     215,   217,   211,   212,   213,   201,   202,   203,   204,   205,
     490,   495,   491,   496,   382,   250,   380,   501,   490,   492,
     491,   493,   381,   512,   490,   491,   250,   250,   512,   512,
      29,   190,    35,   198,    54,    57,     0,   435,     0,     0,
     103,   104,   107,     0,   501,   512,     0,   501,   452,     0,
       0,     0,     0,   395,   396,   512,   397,     0,   512,   325,
      16,   512,   320,   188,   494,   273,   501,   490,   491,   512,
       0,     0,   297,   322,   291,   321,   294,   494,   273,   501,
     490,   491,     0,   485,     0,   257,   253,   512,   484,   278,
     503,   237,   242,   244,   281,    19,     0,    26,   197,    70,
     271,   505,    86,    78,    90,    92,   501,   490,   491,     0,
     458,     0,   340,   331,   333,   501,   329,   512,     0,     0,
     287,     0,   444,   477,     0,   447,   471,     0,   449,   475,
     207,   208,   360,   512,     0,   358,   357,   261,     0,    82,
      76,     0,     0,     0,     0,     0,     0,   379,    60,     0,
     385,     0,     0,   239,   378,    58,   238,   376,    53,   375,
      52,     0,     0,     0,   512,   304,     0,     0,   385,   307,
     480,   501,     0,   437,   311,   115,   118,     0,     0,   399,
     326,     0,    12,   401,     0,     0,   323,     0,     0,   385,
       0,     0,     0,   296,     0,     0,     0,     0,   385,     0,
     258,   248,   512,    11,   235,    88,   463,   501,     0,   338,
       0,   460,     0,   501,   362,     0,     0,   462,   512,   512,
     476,   512,   468,   512,   512,   458,   512,     0,   512,   465,
     512,   512,   356,     0,     0,   259,    74,   189,     0,    34,
     195,    33,   196,    61,   504,     0,    31,   193,    32,   194,
      59,     0,     0,   191,     0,     0,   434,   302,   436,   309,
     452,     0,   398,     0,    95,   102,     0,   400,     0,   288,
       0,   289,   257,   512,     0,     0,   299,   243,   330,   341,
       0,   336,   332,   366,   363,   364,   367,   368,   371,   370,
       0,   440,     0,   442,     0,   448,     0,   445,   450,     0,
       0,   359,   347,   349,     0,   352,     0,   354,   373,   260,
     230,    30,   192,   389,   387,     0,     0,     0,   101,     0,
     512,     0,   512,     0,   391,   392,   390,   292,   295,     0,
       0,   339,     0,   334,     0,   512,   512,   512,   512,     0,
     464,   361,   512,   512,   512,   466,   512,   512,    55,   305,
       0,   494,   100,   501,   490,   491,   393,   512,     0,   337,
       0,   365,   441,     0,   438,   443,   446,   274,     0,     0,
     344,     0,   346,   353,     0,   350,   355,   312,   385,   324,
     300,   335,   512,   494,   273,   512,   512,   512,   512,   439,
     345,     0,   342,   348,   351,   512,   343
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    60,    61,    62,   257,   204,   205,   206,
     207,   419,    64,    65,   211,    66,    67,   545,   674,    68,
      69,   265,    70,    71,    72,   440,    73,   212,   105,   106,
     199,   200,   686,   201,   562,   531,   188,    75,   239,   268,
     524,   664,   411,   412,   248,   249,   241,   403,   413,   483,
      76,   428,   282,   224,   706,   225,   707,   592,   839,   549,
     546,   765,   362,   364,   561,   770,   260,   378,   584,   695,
     696,   230,   623,   624,   625,   736,   644,   645,   723,   794,
     795,   456,   630,   303,   478,    78,    79,   348,   539,   538,
     389,   836,   372,   565,   688,   692,    80,    81,    82,    83,
      84,   287,    85,   214,   215,    88,   216,   357,   548,   559,
     560,   458,   459,   460,   461,   462,   739,   740,   463,   464,
     465,   466,   730,   632,   190,   363,   273,   414,   244,   111,
     553,   526,   367,   221,   408,   409,   660,   432,   379,   223,
     208
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -727
static const yytype_int16 yypact[] =
{
    -727,   110,  2380,  -727,  6578,  8130,  8421,  4872,  6119,  2894,
    7839,  7839,  4370,  -727,  -727,  8227,  6772,  6772,  -727,  -727,
    6772,  5547,  5644,  -727,  -727,  -727,  -727,   170,  6119,  -727,
     -42,  -727,  -727,  5000,  5128,  -727,  -727,  5256,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  7936,  7936,    68,
    3709,  7839,  6966,  7257,  6384,  -727,  5979,   364,  8033,  7936,
    -727,   285,  -727,   728,  -727,   410,  -727,  -727,   103,    34,
    -727,   124,  8324,  -727,    45,  9729,    31,   184,    36,    40,
    -727,  -727,  -727,  -727,  -727,  -727,    47,    79,  -727,   356,
     169,  -727,  -727,  -727,  -727,  -727,    29,    38,   138,   140,
     331,  7839,   359,  3856,   421,  -727,    64,  -727,   203,  -727,
    -727,   169,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
      39,    52,    60,   225,  -727,  -727,  -727,  -727,  -727,  -727,
     252,   255,  -727,   287,  -727,   303,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
     322,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,   149,  -727,  6675,   159,   166,   285,   728,  -727,   237,
     410,   100,   148,   213,    23,   214,    63,   100,  -727,  -727,
     285,   310,  -727,   190,  7839,  7839,   292,  -727,  -727,   242,
     338,    50,    55,  7936,  7936,  7936,  7936,  -727,  9729,   277,
    -727,  -727,   234,   316,  -727,  -727,  -727,  4273,  -727,  6772,
    6772,  -727,  -727,  4502,  -727,  7839,  -727,   246,  4003,  -727,
     343,   327,   431,  3709,   289,   313,   355,   410,   324,   311,
     337,  -727,   277,   329,   337,  -727,   417,  8518,   346,   370,
     378,   389,   919,  -727,  -727,  -727,  -727,  -727,   422,   430,
    -727,  -727,  -727,  -727,  4599,  7839,  7839,  7839,  7839,  6675,
    7839,  7839,  -727,  -727,  7354,  -727,  3709,  6481,   374,  7354,
    7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,
    7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,  7936,
    7936,  7936,  7936,  7936,  7936,  7936,  8745,  6772,  8822,  2500,
    2500,  -727,  -727,  -727,  8033,  8033,  -727,   432,  -727,   410,
    -727,   409,  -727,  -727,  -727,   285,  -727,  -727,  -727,  8899,
    6772,  8976,  2894,  7839,  1076,  -727,  -727,  -727,  -727,   728,
    -727,  7451,   524,  -727,  -727,  4728,    80,  -727,  3032,   543,
    7936,  9053,  6772,  9130,  7936,  7936,  3298,   310,  7548,   547,
    -727,    58,    58,    71,  9207,  6772,  9284,  -727,  -727,  -727,
    -727,  7936,  6869,  -727,  -727,  7063,  -727,   313,   426,  -727,
    -727,   313,  -727,   444,   448,  -727,    70,  -727,  -727,  6119,
    3430,   450,  9053,  9130,  7936,   313,  -727,   453,   313,  -727,
    7160,  -727,  -727,  7257,  -727,  -727,  -727,   409,   124,  8518,
    -727,  8518,  9361,  6772,  9438,   481,  -727,  -727,  -727,  -727,
     711,  -727,  -727,  -727,  -727,   608,    57,  -727,  -727,  -727,
    -727,   455,  -727,   459,   550,   483,   559,  -727,  7936,  7936,
    -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,    14,  7936,
    -727,   486,   488,  -727,   313,  8518,   498,  -727,  -727,  -727,
     512,  1823,  -727,  -727,   327,  1314,  1314,  1314,  1314,   836,
     836,  2233,  1376,  1314,  1314,  9746,  9746,   536,   536,  1483,
     836,   836,   846,   846,   928,   265,   265,   327,   327,   327,
    2660,  5741,  2747,  5838,  -727,    38,  -727,   313,   435,  -727,
     473,  -727,  -727,  5644,  -727,  -727,  1837,  1837,    14,    14,
    -727,  1945,  -727,  9729,  -727,  -727,   285,  -727,  7839,  2894,
     447,    20,  -727,    38,   313,    38,   630,    70,   608,  2894,
     285,  6259,  6119,   486,  -727,   548,  -727,  3577,   633,  -727,
     728,   474,  -727,  2007,  5353,  5450,   313,   181,   227,   524,
     638,   115,  -727,  -727,  -727,  -727,  -727,    89,    95,   313,
      96,   101,  7839,  -727,  7936,   277,  -727,   316,  -727,  -727,
    -727,  -727,  6869,  7063,  -727,  -727,   505,  -727,  9729,   162,
    -727,   337,   374,  -727,   447,    20,   313,    87,   157,  7936,
    -727,   711,    94,  -727,   519,   313,  -727,   507,  4141,  4003,
    -727,   608,  -727,  -727,   608,  -727,  -727,   627,  -727,  -727,
     327,   327,  -727,   577,  4141,  -727,  -727,   534,  7645,  -727,
    -727,  8518,  8033,  7936,   553,  8033,  8033,  -727,   432,   531,
     510,  8033,  8033,  -727,  -727,   432,  -727,  -727,  -727,  -727,
    -727,  4141,  4003,  7936,    14,  -727,   285,   667,  -727,  -727,
    -727,   313,   675,  -727,  -727,  -727,  -727,  8615,   100,  -727,
    -727,  4141,  -727,  -727,  7839,   676,  -727,  7936,  7936,   230,
    7936,  7936,   677,  -727,  7742,  3165,  4141,  4141,   109,    58,
    -727,  -727,   549,  -727,  -727,   478,  -727,   313,   732,   552,
    1005,  -727,   615,   313,  -727,   679,   558,  -727,   560,   561,
    -727,   566,  -727,   567,   566,   581,   507,   585,   578,  -727,
     589,   592,  -727,   708,  7936,   594,  -727,  9729,  7936,  -727,
    9729,  -727,  9729,  -727,  -727,  8033,  -727,  9729,  -727,  9729,
    -727,   712,   602,  9729,  4003,  2894,  -727,  -727,  -727,  -727,
    1076,   686,  -727,   469,   378,   389,  2894,  -727,   100,  -727,
    7936,  -727,  -727,   141,   737,   738,  -727,  7063,  -727,   611,
     732,   295,  -727,  -727,   612,  -727,  -727,  -727,  -727,  -727,
     608,  -727,   627,  -727,   627,  -727,   627,  -727,  -727,  8712,
     640,  -727,   660,  -727,   660,  -727,   627,  -727,  -727,   617,
    9729,  -727,  9729,  -727,  -727,   622,   751,  2894,   409,  9515,
    6772,  9592,   166,  3032,  -727,  -727,  -727,  -727,  -727,  4141,
     732,   611,   732,   634,   615,   566,   635,   566,   566,   719,
     495,  -727,   637,   641,   566,  -727,   643,   566,  -727,  -727,
     753,    77,    20,   313,   117,   127,  -727,   474,   769,   611,
     732,  -727,  -727,   627,  -727,  -727,  -727,  -727,  9669,   660,
    -727,   627,  -727,  -727,   627,  -727,  -727,  -727,   129,  -727,
    -727,   611,   566,   646,   655,   566,   658,   566,   566,  -727,
    -727,   627,  -727,  -727,  -727,   566,  -727
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -727,  -727,  -727,   384,  -727,    28,  -727,  -350,  1096,  -727,
      26,  -727,  -288,   349,   -10,   -49,  -727,  -504,  -727,     2,
     791,  -154,    -9,   -32,  -214,  -392,    -7,   317,   -65,   802,
       6,   -20,  -727,  -727,  -727,    -3,  -727,  1939,   989,  -727,
       7,   -43,  -306,    82,   -11,  -727,  -359,  -220,    67,  -209,
       1,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
    -727,  -727,  -727,  -727,  -727,  -727,   496,  -207,  -365,   -58,
    -357,  -727,  -653,  -649,   191,  -727,  -461,  -727,  -561,  -727,
     -33,  -727,  -727,  -727,  -727,  -727,  -727,   734,  -727,  -727,
    -370,  -727,   -18,  -727,  -727,  -727,  -727,  -727,  -727,  -727,
      16,  -727,  -727,   814,  1366,   808,  1403,  -727,  -727,    54,
    -248,  -661,  -436,  -579,   290,  -592,  -726,     5,   194,  -727,
    -507,  -727,  -249,   173,  -727,  -727,  -727,    19,  -385,   983,
    -280,  -727,  -727,    -4,   -24,  -227,  -484,  -206,    33,    13,
      -2
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -513
static const yytype_int16 yytable[] =
{
      91,   217,   220,   255,   187,   187,   107,   107,   256,   290,
     386,   252,   556,   186,   626,   568,   107,   580,   237,   237,
     598,   488,   237,   406,   202,   187,   417,   586,    63,   251,
      63,   527,    92,   467,   457,   243,   243,   352,   427,   243,
     308,   266,   732,   596,   202,   222,   596,   278,   598,   613,
     271,   275,   727,   187,   554,   107,   525,   293,   533,   536,
     537,   796,   286,   439,   434,   355,   341,   792,   436,   789,
     678,   270,   274,   107,   294,   -95,   576,   671,   672,   347,
    -102,   555,   737,   242,   242,   583,   628,   242,   855,   589,
     -98,   642,   699,   650,   222,   258,  -101,   346,   240,   245,
     493,   525,   246,   533,   251,   708,  -273,   300,   301,   425,
       3,  -422,   -89,   377,   -98,   467,   555,  -317,   346,   269,
    -100,   -97,   339,   262,   729,  -425,   -99,   733,   377,   643,
     -97,   302,   715,   -95,   -96,  -422,   741,   616,  -424,   358,
     -99,   841,   -96,   555,   304,   620,  -426,   446,   447,   448,
     449,   385,   484,   855,   753,   309,   567,   -95,   388,  -273,
    -273,   760,   564,  -491,   555,   629,  -487,   344,   424,   370,
    -317,  -317,   247,  -102,   371,   810,   340,   342,   356,  -425,
     599,   250,   -91,   796,   601,   626,   719,   792,   -87,   604,
    -101,   -87,  -424,   869,   406,   341,   -94,   -89,   609,   677,
    -426,   610,   374,   373,   218,   219,   467,   627,   732,   682,
     218,   219,   -93,   764,   391,   392,   387,   254,   598,   375,
    -490,   891,   702,   -98,   -98,   727,  -417,   439,   -89,   369,
     -90,   -89,  -490,   727,   -89,   718,   -92,   -89,  -491,   222,
     404,   404,   -91,   596,   596,   438,   218,   219,   415,   237,
     -88,   237,   237,   222,   266,   480,   704,   649,   380,   746,
     489,   218,   219,   -97,   -97,   305,   243,   -91,   243,   700,
     336,   439,   -68,   -99,   -99,   -96,   -96,  -487,   107,  -417,
    -417,   253,   626,  -487,   626,   471,   472,   473,   474,   359,
     368,   -97,   376,   846,   552,   540,   542,   266,   -91,   381,
     486,   -91,   384,   -82,   -91,   853,   342,   856,   107,   467,
     681,  -427,   250,   253,   242,   701,   242,   254,   780,    74,
      63,    74,   470,   337,   338,   475,    74,   388,   394,   407,
     680,   410,   228,   523,   310,   415,   390,   -99,  -429,   237,
     -96,  -428,   360,   361,   786,   532,   620,   393,   446,   447,
     448,   449,   382,   383,   626,   843,   523,  -488,   415,   210,
     210,   210,   237,   397,   488,  -427,   401,    74,   532,   566,
     569,   482,   896,  -417,   705,   402,   482,   711,   523,   888,
     415,   395,   396,   420,   237,   333,   334,   335,   547,  -421,
     532,   523,  -429,   415,   742,  -428,   310,   237,   721,   605,
     267,   570,   598,   532,   626,   714,   626,   612,   365,   438,
     350,   404,   404,   835,   351,   826,   187,  -421,    91,   523,
      74,   597,   288,   289,   585,   585,   834,  -417,   596,   422,
     532,   218,   219,   426,   626,   202,   842,   439,   482,   523,
     107,   415,   107,  -421,   345,   237,    63,   300,   301,   611,
     349,   532,   430,   438,   768,   581,   442,   405,   431,   633,
     254,   633,   366,   633,  -423,   -67,  -102,   435,  -488,   429,
    -421,  -421,   437,  -494,  -488,  -267,   646,   860,   433,   353,
     354,   776,   382,   423,   431,   654,   107,   441,   694,   567,
     788,   468,   711,   667,   669,  -274,   797,   -94,    77,   469,
      77,   108,   108,   659,  -385,    77,   213,   213,   213,   443,
     444,   229,   213,   213,   658,   487,   213,  -423,  -423,   424,
      74,   467,   665,   661,   863,   668,   670,   544,  -267,  -267,
     659,   666,   657,  -494,   666,   666,   646,   646,   676,   567,
     663,  -101,   685,   663,   663,   -97,    77,   213,  -274,  -274,
     279,   555,   659,   666,   213,   829,   572,   582,   187,   187,
     657,   662,   663,   689,  -385,   659,   693,   684,   279,   569,
     600,   833,   -93,   210,   210,    74,   -89,   569,   202,   675,
      74,   878,   709,   -99,  -494,   602,  -494,  -494,   607,   603,
    -490,   619,   659,   683,   -82,   404,   631,   213,   755,    77,
     634,   636,   416,   489,   418,   310,   749,   751,   830,   831,
     639,    74,   756,   758,   -91,  -385,    74,  -385,  -385,   438,
     -96,   712,   652,    74,   637,   724,   490,  -255,   735,   648,
     446,   447,   448,   449,   360,   361,   635,   687,   638,   651,
     679,   724,   691,   713,   210,   210,   210,   210,   703,   476,
     477,   -88,   107,   722,   331,   332,   333,   334,   335,   445,
     720,   446,   447,   448,   449,   748,   793,   450,   446,   447,
     448,   449,   646,   451,   452,  -256,   754,   767,   620,    74,
     446,   447,   448,   449,   778,   769,   779,   781,   107,   798,
     787,   809,    74,   790,   453,    74,   799,   454,   450,    77,
     811,   800,   802,    74,   451,   452,   821,   804,   806,   766,
     404,   735,   557,   446,   447,   448,   449,   450,   818,   812,
     213,   213,   823,   722,   452,   453,   633,   633,   454,   633,
     814,   633,   633,   816,   724,  -257,   633,    74,   633,   633,
     824,   828,   585,   213,   453,   213,   213,   837,   838,   213,
     450,   213,   840,   844,    77,   851,   451,   452,  -258,    77,
     858,   859,   620,   887,   446,   447,   448,   449,   295,   296,
     297,   298,   299,   279,   877,   870,   873,   453,   879,   890,
     454,   569,   881,   620,   884,   446,   447,   448,   449,  -490,
      77,   213,   213,   213,   213,    77,   213,   213,  -491,   901,
     213,   621,    77,   279,   606,   213,   227,   622,   112,   889,
     107,   871,   717,   343,   866,   189,    86,   852,    86,   109,
     109,   109,   621,    86,   827,   728,   523,     0,   415,   231,
     373,     0,   237,   213,     0,     0,     0,     0,   532,   659,
     213,   213,     0,   633,   633,   633,   633,     0,     0,     0,
     633,   633,   633,     0,   633,   633,   213,     0,    77,   213,
       0,     0,     0,     0,    86,   569,    74,     0,   280,     0,
       0,    77,     0,     0,    77,   523,    74,     0,   213,     0,
       0,     0,    77,     0,    74,     0,   280,     0,     0,     0,
     633,   213,     0,   633,   633,   633,   633,   210,     0,     0,
       0,   801,   803,   633,   805,   310,   807,   808,     0,     0,
       0,   813,     0,   815,   817,   310,    77,    86,     0,     0,
     323,   324,     0,     0,   731,     0,     0,   734,     0,     0,
     323,   324,     0,   738,     0,   279,     0,   279,     0,   213,
       0,   210,     0,     0,     0,    74,    74,     0,     0,     0,
       0,   328,   329,   330,   331,   332,   333,   334,   335,     0,
       0,    74,     0,   330,   331,   332,   333,   334,   335,   490,
     445,     0,   446,   447,   448,   449,     0,     0,     0,     0,
       0,   279,     0,     0,     0,    90,     0,    90,    74,    74,
       0,     0,    90,    90,    90,    90,     0,   310,     0,    90,
      90,     0,     0,    90,   772,     0,     0,     0,    74,   450,
       0,     0,   323,   324,     0,   451,   452,    86,   872,   874,
     875,   876,    74,    74,    74,   880,   882,   883,     0,   885,
     886,     0,     0,    90,    90,     0,   453,     0,     0,   454,
       0,    90,   272,   210,   213,    77,   331,   332,   333,   334,
     335,     0,     0,     0,     0,    77,   620,     0,   446,   447,
     448,   449,   455,    77,     0,   899,     0,     0,   900,   902,
     903,   904,    86,     0,     0,     0,     0,    86,   906,     0,
       0,    74,    74,     0,    90,     0,    90,     0,   213,     0,
     845,   280,   847,    74,     0,   621,   848,     0,     0,     0,
       0,   791,     0,     0,   854,     0,   857,     0,    86,     0,
       0,     0,     0,    86,     0,     0,     0,     0,     0,     0,
      86,   280,     0,     0,    77,    77,     0,   445,     0,   446,
     447,   448,   449,     0,     0,     0,     0,     0,     0,     0,
      77,     0,     0,     0,    74,     0,   264,   279,   213,     0,
      74,   213,   213,     0,     0,     0,    74,   213,   213,     0,
       0,     0,     0,   892,     0,     0,   450,    77,    77,   895,
       0,   897,   451,   452,   898,     0,    86,     0,     0,     0,
       0,     0,     0,   773,     0,     0,    90,    77,     0,    86,
     213,   905,    86,   453,     0,     0,   454,     0,     0,   264,
      86,    77,    77,    77,     0,     0,     0,    90,    90,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   558,
       0,     0,   398,   399,   400,     0,     0,     0,     0,     0,
      90,     0,    90,    90,    86,     0,    90,     0,    90,     0,
       0,    90,     0,     0,     0,     0,    90,     0,     0,     0,
       0,   213,     0,   280,     0,   280,     0,     0,     0,     0,
      77,    77,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    77,     0,     0,     0,     0,    90,    90,    90,
      90,    90,    90,    90,    90,     0,     0,    90,     0,    90,
       0,     0,    90,   481,     0,     0,     0,     0,   492,   280,
       0,     0,     0,     0,     0,   850,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      90,     0,     0,    77,     0,     0,   213,    90,    90,    77,
       0,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,    90,     0,    90,    90,     0,     0,     0,
       0,     0,     0,     0,   421,     0,     0,     0,    90,   264,
     563,    90,     0,    86,     0,    90,     0,     0,    87,    90,
      87,     0,     0,    86,     0,    87,     0,   492,    90,     0,
       0,    86,     0,   310,  -513,  -513,  -513,  -513,   315,   316,
     593,   595,  -513,  -513,   272,     0,     0,     0,   323,   324,
       0,     0,   264,    90,     0,    89,     0,    89,   110,   110,
       0,     0,    89,     0,     0,     0,    87,     0,   232,   595,
       0,     0,   272,     0,     0,     0,    90,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,     0,     0,     0,
       0,     0,    86,    86,     0,   310,   311,   312,   313,   314,
     315,   316,   317,    89,   319,   320,     0,   281,    86,     0,
     323,   324,     0,     0,     0,   280,     0,     0,   647,    87,
       0,     0,     0,     0,   571,   281,     0,     0,     0,     0,
       0,     0,   579,     0,     0,    86,    86,     0,     0,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,     0,
       0,   774,     0,     0,     0,    86,    89,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    86,
      86,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    90,    90,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    90,     0,     0,     0,     0,     0,     0,     0,
      90,     0,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,     0,     0,   323,   324,    87,
       0,     0,     0,     0,     0,    90,     0,     0,    86,    86,
       0,     0,     0,   710,     0,     0,     0,     0,     0,     0,
      86,   595,   272,     0,   325,     0,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    89,     0,   716,     0,
       0,    90,    90,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   109,    87,     0,     0,    90,     0,    87,
     254,     0,     0,     0,     0,    90,     0,   745,    90,    90,
       0,    86,     0,     0,    90,    90,     0,    86,     0,     0,
       0,     0,     0,    86,    90,    90,     0,     0,     0,     0,
      87,    89,     0,   690,     0,    87,    89,     0,     0,     0,
       0,     0,    87,     0,    90,     0,     0,    90,     0,     0,
     281,     0,     0,     0,     0,     0,     0,     0,    90,    90,
      90,     0,     0,   782,     0,     0,     0,    89,     0,     0,
       0,     0,    89,     0,     0,     0,     0,     0,     0,    89,
     281,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   725,   726,     0,     0,    87,     0,
       0,     0,     0,   819,     0,     0,     0,     0,    90,     0,
     743,    87,     0,     0,    87,     0,     0,    90,    90,     0,
       0,     0,    87,     0,     0,     0,     0,     0,     0,    90,
       0,     0,     0,     0,     0,    89,     0,   761,   762,     0,
       0,     0,     0,     0,     0,     0,   272,     0,    89,     0,
       0,    89,     0,     0,     0,     0,    87,   777,     0,    89,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   783,   784,   785,     0,     0,     0,     0,     0,     0,
      90,     0,     0,    90,     0,     0,    90,     0,     0,     0,
       0,     0,    90,    89,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -512,     0,     0,
       0,     0,   281,     0,   281,  -512,  -512,  -512,     0,     0,
    -512,  -512,  -512,     0,  -512,     0,     0,     0,     0,     0,
     825,     0,     0,     0,  -512,     0,     0,   653,     0,     0,
       0,     0,   832,     0,  -512,  -512,     0,  -512,  -512,  -512,
    -512,  -512,     0,     0,     0,     0,     0,     0,   281,     0,
       0,     0,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,     0,     0,   323,   324,     0,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
       0,     0,     0,  -512,     0,    87,     0,     0,     0,   867,
       0,     0,     0,    87,   325,   868,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,     0,     0,     0,
       0,     0,    89,     0,     0,   238,   238,     0,     0,   238,
       0,     0,    89,     0,  -232,     0,     0,     0,     0,     0,
      89,     0,     0,     0,     0,  -512,     0,  -512,     0,     0,
     250,  -512,     0,  -512,  -512,     0,   259,   261,     0,   673,
       0,   238,   238,     0,    87,    87,     0,   291,   292,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      87,     0,     0,     0,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,     0,   323,
     324,    89,    89,     0,     0,     0,     0,    87,    87,     0,
       0,     0,     0,     0,     0,     0,     0,    89,     0,     0,
       0,   653,     0,     0,   281,     0,   325,    87,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,     0,     0,
       0,    87,    87,    87,    89,    89,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,     0,
     775,   323,   324,     0,    89,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    89,    89,
      89,     0,     0,     0,     0,     0,     0,     0,   325,     0,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      87,    87,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    87,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    89,    89,     0,
       0,     0,   238,   238,   238,   291,     0,     0,     0,    89,
       0,     0,     0,     0,     0,     0,   238,     0,   238,   238,
       0,     0,     0,    87,     0,     0,     0,     0,     0,    87,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     0,
       0,     0,   110,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      89,     0,     0,     0,     0,     0,    89,     0,     0,     0,
       0,     0,    89,   238,     0,     0,     0,     0,   491,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,     0,   238,     0,     0,     0,
       0,     0,     0,   541,   543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,   310,   311,   312,   313,   314,   315,   316,     0,
     238,   319,   320,     0,     0,     0,     0,   323,   324,   573,
       0,   238,     0,   541,   543,     0,     0,   238,     0,     0,
       0,     0,     0,     0,   238,     0,     0,     0,     0,     0,
     238,   238,     0,     0,   238,     0,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,     0,     0,     0,
       0,     0,     0,   608,     0,     0,     0,     0,     0,   238,
       0,     0,   238,     0,     0,     0,     0,     0,     0,     0,
    -512,     4,   238,     5,     6,     7,     8,     9,     0,     0,
       0,    10,    11,     0,     0,     0,    12,     0,    13,    14,
      15,    16,    17,    18,    19,     0,     0,   640,   641,     0,
      20,    21,    22,    23,    24,    25,    26,     0,   238,    27,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
       0,    33,    34,    35,    36,    37,    38,     0,    39,    40,
      41,    42,    43,    44,    45,    46,     0,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,     0,    54,     0,    55,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    58,    59,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -512,  -512,     0,     0,
       0,     0,     0,   238,     0,     0,     0,     0,     0,     0,
       0,   238,   238,     0,     0,     0,     0,     0,     0,     0,
       0,   534,   529,     0,     0,   535,     0,     0,   238,     0,
       0,     0,     0,     0,     0,     0,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,     0,     0,   165,   166,
       0,     0,   167,   168,   169,   170,     0,   238,     0,     0,
       0,   573,   747,     0,   750,   752,   171,     0,     0,     0,
     757,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   763,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,     0,   182,   183,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   750,   752,     0,   757,
     759,     0,   184,   238,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -494,     0,     0,     0,     0,     0,     0,     0,  -494,  -494,
    -494,     0,     0,     0,  -494,  -494,     0,  -494,     0,     0,
       0,     0,     0,   238,     0,     0,  -494,   820,     0,     0,
       0,     0,     0,     0,   822,     0,     0,  -494,  -494,     0,
    -494,  -494,  -494,  -494,  -494,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   822,
       0,     0,     0,     0,     0,     0,   238,     0,     0,  -494,
    -494,  -494,  -494,  -494,  -494,  -494,  -494,  -494,  -494,  -494,
    -494,  -494,     0,     0,  -494,  -494,  -494,  -273,   655,     0,
       0,     0,     0,     0,     0,  -273,  -273,  -273,     0,     0,
       0,  -273,  -273,     0,  -273,     0,     0,     0,     0,   238,
     -98,  -494,     0,  -494,  -494,  -494,  -494,  -494,  -494,  -494,
    -494,  -494,  -494,     0,  -273,  -273,     0,  -273,  -273,  -273,
    -273,  -273,     0,     0,     0,     0,     0,  -494,  -494,  -494,
    -494,   -90,     0,     0,  -494,     0,  -494,  -494,     0,     0,
       0,     0,     0,     0,     0,     0,  -273,  -273,  -273,  -273,
    -273,  -273,  -273,  -273,  -273,  -273,  -273,  -273,  -273,     0,
       0,  -273,  -273,  -273,     0,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -100,  -273,     0,
    -273,  -273,  -273,  -273,  -273,  -273,  -273,  -273,  -273,  -273,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -273,  -273,  -273,   -92,     0,
       0,  -273,     0,  -273,  -273,   203,     0,     5,     6,     7,
       8,     9,  -512,  -512,  -512,    10,    11,     0,     0,  -512,
      12,     0,    13,    14,    15,    16,    17,    18,    19,     0,
       0,     0,     0,     0,    20,    21,    22,    23,    24,    25,
      26,     0,     0,    27,     0,     0,     0,     0,     0,    28,
       0,    30,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,    42,    43,    44,    45,    46,
       0,    47,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,    50,    51,     0,    52,    53,     0,
      54,     0,    55,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,    58,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     5,     6,     7,     8,     9,
    -512,  -512,  -512,    10,    11,     0,  -512,  -512,    12,     0,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,    20,    21,    22,    23,    24,    25,    26,     0,
       0,    27,     0,     0,     0,     0,     0,    28,     0,    30,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,    45,    46,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,     0,    54,     0,
      55,    56,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,    58,    59,     0,     0,
       0,     0,     0,     0,     0,     0,   203,     0,     5,     6,
       7,     8,     9,     0,     0,  -512,    10,    11,  -512,  -512,
    -512,    12,  -512,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,    42,    43,    44,    45,
      46,     0,    47,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
       0,    54,     0,    55,    56,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,    58,
      59,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,     5,     6,     7,     8,     9,     0,     0,  -512,    10,
      11,  -512,  -512,  -512,    12,     0,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,    20,    21,
      22,    23,    24,    25,    26,     0,     0,    27,     0,     0,
       0,     0,     0,    28,     0,    30,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,     0,    54,     0,    55,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    57,    58,    59,     0,     0,     0,     0,     0,     0,
       0,     4,     0,     5,     6,     7,     8,     9,     0,     0,
       0,    10,    11,     0,  -512,  -512,    12,     0,    13,    14,
      15,    16,    17,    18,    19,     0,     0,     0,     0,     0,
      20,    21,    22,    23,    24,    25,    26,     0,     0,    27,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
       0,    33,    34,    35,    36,    37,    38,     0,    39,    40,
      41,    42,    43,    44,    45,    46,     0,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,     0,    54,     0,    55,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    58,    59,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -512,     0,
       0,     0,     0,     0,     0,     0,  -512,  -512,   203,     0,
       5,     6,     7,     8,     9,     0,  -512,  -512,    10,    11,
       0,     0,     0,    12,     0,    13,    14,    15,    16,    17,
      18,    19,     0,     0,     0,     0,     0,    20,    21,    22,
      23,    24,    25,    26,     0,     0,    27,     0,     0,     0,
       0,     0,    28,     0,    30,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,    42,    43,
      44,    45,    46,     0,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,     0,    54,     0,    55,    56,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,    58,    59,     0,     0,     0,     0,     0,     0,     0,
     203,     0,     5,     6,     7,     8,     9,     0,     0,     0,
      10,    11,     0,  -512,  -512,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,    28,     0,    30,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
      42,    43,    44,    45,    46,     0,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,   263,
      51,     0,    52,    53,     0,    54,     0,    55,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,    58,    59,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -512,     0,  -512,  -512,   203,     0,     5,
       6,     7,     8,     9,     0,     0,     0,    10,    11,     0,
       0,     0,    12,     0,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,    20,    21,    22,    23,
      24,    25,    26,     0,     0,    27,     0,     0,     0,     0,
       0,    28,     0,    30,    31,    32,     0,    33,    34,    35,
      36,    37,    38,     0,    39,    40,    41,    42,    43,    44,
      45,    46,     0,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,     0,    54,     0,    55,    56,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
      58,    59,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -512,     0,  -512,  -512,   203,     0,     5,     6,     7,     8,
       9,     0,     0,     0,    10,    11,     0,     0,     0,    12,
       0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,    20,    21,    22,    23,    24,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,    28,     0,
      30,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,    42,    43,    44,    45,    46,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,     0,    54,
       0,    55,    56,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,    58,    59,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -512,   203,     0,     5,     6,     7,     8,     9,  -512,
    -512,  -512,    10,    11,     0,     0,     0,    12,     0,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,    20,    21,    22,    23,    24,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,    28,     0,    30,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,    42,    43,    44,    45,    46,     0,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,     0,    54,     0,    55,
      56,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    57,    58,    59,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,     0,  -512,  -512,    12,
       0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,    20,    21,    22,    23,    24,    25,    26,
       0,     0,    98,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
     233,    39,    40,    41,    42,    43,    44,    45,    46,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     209,     0,     0,   103,    51,     0,    52,    53,     0,   234,
     235,    55,    56,     5,     6,     7,     0,     9,     0,     0,
       0,    10,    11,     0,     0,     0,    12,     0,    13,    14,
      15,    16,    17,    18,    19,     0,    57,   236,    59,     0,
      20,    21,    22,    23,    24,    25,    26,     0,     0,    27,
       0,     0,     0,     0,     0,     0,     0,     0,    31,    32,
     254,    33,    34,    35,    36,    37,    38,     0,    39,    40,
      41,    42,    43,    44,    45,    46,     0,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   209,     0,     0,
     103,    51,     0,    52,    53,     0,     0,     0,    55,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    58,    59,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,     6,     7,     0,     9,
       0,     0,     0,    10,    11,     0,   218,   219,    12,     0,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,     0,    20,    21,    22,    23,    24,    25,    26,     0,
       0,    27,     0,     0,     0,     0,     0,     0,     0,     0,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,    45,    46,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
       0,     0,   103,    51,     0,    52,    53,     0,     0,     0,
      55,    56,     5,     6,     7,     8,     9,     0,     0,     0,
      10,    11,     0,     0,     0,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,    57,    58,    59,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,    28,    29,    30,    31,    32,   254,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
      42,    43,    44,    45,    46,     0,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,     0,    54,     0,    55,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,    58,    59,     0,     0,     0,     0,     0,
       0,     5,     6,     7,     8,     9,     0,     0,     0,    10,
      11,     0,     0,     0,    12,   390,    13,    14,    15,    16,
      17,    18,    19,     0,     0,     0,     0,     0,    20,    21,
      22,    23,    24,    25,    26,     0,     0,    27,     0,     0,
       0,     0,     0,    28,     0,    30,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,     0,    54,     0,    55,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    57,    58,    59,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   390,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,     0,
       0,     0,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,     0,     0,     0,     0,     0,   147,   148,   149,
     150,   151,   152,   153,   154,    35,    36,   155,    38,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,     0,     0,
     165,   166,     0,     0,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,     0,   182,   183,     0,     0,
       0,     0,     0,  -487,  -487,  -487,     0,  -487,     0,     0,
       0,  -487,  -487,     0,   184,   185,  -487,     0,  -487,  -487,
    -487,  -487,  -487,  -487,  -487,     0,  -487,     0,     0,     0,
    -487,  -487,  -487,  -487,  -487,  -487,  -487,     0,     0,  -487,
       0,     0,     0,     0,     0,     0,     0,     0,  -487,  -487,
       0,  -487,  -487,  -487,  -487,  -487,  -487,  -487,  -487,  -487,
    -487,  -487,  -487,  -487,  -487,  -487,     0,  -487,  -487,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -487,     0,     0,
    -487,  -487,     0,  -487,  -487,     0,  -487,  -487,  -487,  -487,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -487,  -487,  -487,     0,     0,     0,     0,
       0,  -489,  -489,  -489,     0,  -489,     0,  -487,     0,  -489,
    -489,     0,     0,  -487,  -489,     0,  -489,  -489,  -489,  -489,
    -489,  -489,  -489,     0,  -489,     0,     0,     0,  -489,  -489,
    -489,  -489,  -489,  -489,  -489,     0,     0,  -489,     0,     0,
       0,     0,     0,     0,     0,     0,  -489,  -489,     0,  -489,
    -489,  -489,  -489,  -489,  -489,  -489,  -489,  -489,  -489,  -489,
    -489,  -489,  -489,  -489,     0,  -489,  -489,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -489,     0,     0,  -489,  -489,
       0,  -489,  -489,     0,  -489,  -489,  -489,  -489,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -489,  -489,  -489,     0,     0,     0,     0,     0,  -488,
    -488,  -488,     0,  -488,     0,  -489,     0,  -488,  -488,     0,
       0,  -489,  -488,     0,  -488,  -488,  -488,  -488,  -488,  -488,
    -488,     0,  -488,     0,     0,     0,  -488,  -488,  -488,  -488,
    -488,  -488,  -488,     0,     0,  -488,     0,     0,     0,     0,
       0,     0,     0,     0,  -488,  -488,     0,  -488,  -488,  -488,
    -488,  -488,  -488,  -488,  -488,  -488,  -488,  -488,  -488,  -488,
    -488,  -488,     0,  -488,  -488,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -488,     0,     0,  -488,  -488,     0,  -488,
    -488,     0,  -488,  -488,  -488,  -488,  -490,  -490,  -490,     0,
    -490,     0,     0,     0,  -490,  -490,     0,     0,     0,  -490,
       0,  -490,  -490,  -490,  -490,  -490,  -490,  -490,     0,  -488,
    -488,  -488,     0,  -490,  -490,  -490,  -490,  -490,  -490,  -490,
       0,     0,  -490,  -488,     0,     0,     0,     0,     0,  -488,
       0,  -490,  -490,     0,  -490,  -490,  -490,  -490,  -490,  -490,
    -490,  -490,  -490,  -490,  -490,  -490,  -490,  -490,  -490,     0,
    -490,  -490,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -490,   697,     0,  -490,  -490,     0,  -490,  -490,     0,  -490,
    -490,  -490,  -490,  -491,  -491,  -491,     0,  -491,     0,     0,
       0,  -491,  -491,   -98,     0,     0,  -491,     0,  -491,  -491,
    -491,  -491,  -491,  -491,  -491,     0,  -490,  -490,  -490,     0,
    -491,  -491,  -491,  -491,  -491,  -491,  -491,     0,     0,  -491,
       0,     0,     0,     0,     0,     0,  -490,     0,  -491,  -491,
       0,  -491,  -491,  -491,  -491,  -491,  -491,  -491,  -491,  -491,
    -491,  -491,  -491,  -491,  -491,  -491,     0,  -491,  -491,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -491,   698,     0,
    -491,  -491,     0,  -491,  -491,     0,  -491,  -491,  -491,  -491,
    -250,  -250,  -250,     0,  -250,     0,     0,     0,  -250,  -250,
    -100,     0,     0,  -250,     0,  -250,  -250,  -250,  -250,  -250,
    -250,  -250,     0,  -491,  -491,  -491,     0,  -250,  -250,  -250,
    -250,  -250,  -250,  -250,     0,     0,  -250,     0,     0,     0,
       0,     0,     0,  -491,     0,  -250,  -250,     0,  -250,  -250,
    -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,
    -250,  -250,  -250,     0,  -250,  -250,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -250,     0,     0,  -250,  -250,     0,
    -250,  -250,     0,  -250,  -250,  -250,  -250,  -250,  -250,  -250,
       0,  -250,     0,     0,     0,  -250,  -250,     0,     0,     0,
    -250,     0,  -250,  -250,  -250,  -250,  -250,  -250,  -250,     0,
    -250,  -250,  -250,     0,  -250,  -250,  -250,  -250,  -250,  -250,
    -250,     0,     0,  -250,     0,     0,     0,     0,     0,     0,
     247,     0,  -250,  -250,     0,  -250,  -250,  -250,  -250,  -250,
    -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,  -250,
       0,  -250,  -250,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -250,     0,     0,  -250,  -250,     0,  -250,  -250,     0,
    -250,  -250,  -250,  -250,  -492,  -492,  -492,     0,  -492,     0,
       0,     0,  -492,  -492,     0,     0,     0,  -492,     0,  -492,
    -492,  -492,  -492,  -492,  -492,  -492,     0,  -250,  -250,  -250,
       0,  -492,  -492,  -492,  -492,  -492,  -492,  -492,     0,     0,
    -492,     0,     0,     0,     0,     0,     0,   250,     0,  -492,
    -492,     0,  -492,  -492,  -492,  -492,  -492,  -492,  -492,  -492,
    -492,  -492,  -492,  -492,  -492,  -492,  -492,     0,  -492,  -492,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -492,     0,
       0,  -492,  -492,     0,  -492,  -492,     0,  -492,  -492,  -492,
    -492,  -493,  -493,  -493,     0,  -493,     0,     0,     0,  -493,
    -493,     0,     0,     0,  -493,     0,  -493,  -493,  -493,  -493,
    -493,  -493,  -493,     0,  -492,  -492,  -492,     0,  -493,  -493,
    -493,  -493,  -493,  -493,  -493,     0,     0,  -493,     0,     0,
       0,     0,     0,     0,  -492,     0,  -493,  -493,     0,  -493,
    -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,  -493,
    -493,  -493,  -493,  -493,     0,  -493,  -493,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -493,     0,     0,  -493,  -493,
       0,  -493,  -493,     0,  -493,  -493,  -493,  -493,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -493,  -493,  -493,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -493,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,     0,     0,     0,   137,
     138,   139,   191,   192,   193,   194,   144,   145,   146,     0,
       0,     0,     0,     0,   147,   148,   149,   195,   196,   152,
     197,   154,   283,   284,   198,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,     0,   165,   166,     0,
       0,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,     0,   182,   183,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   184,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,     0,     0,     0,   137,
     138,   139,   191,   192,   193,   194,   144,   145,   146,     0,
       0,     0,     0,     0,   147,   148,   149,   195,   196,   152,
     197,   154,     0,     0,   198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,     0,   165,   166,     0,
       0,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,     0,   182,   183,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   184,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,     0,     0,     0,   137,
     138,   139,   191,   192,   193,   194,   144,   145,   146,     0,
       0,     0,     0,     0,   147,   148,   149,   195,   196,   152,
     197,   154,     0,     0,   198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,     0,   165,   166,     0,
       0,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,     0,   182,   183,     0,     0,     5,     6,     7,
       0,     9,     0,     0,     0,    10,    11,     0,     0,     0,
      12,   184,    13,    14,    15,    93,    94,    18,    19,     0,
       0,     0,     0,     0,    95,    96,    97,    23,    24,    25,
      26,     0,     0,    98,     0,     0,     0,     0,     0,     0,
       0,     0,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,    42,    43,    44,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   276,     0,     0,   103,    51,     0,    52,    53,     0,
       0,     0,    55,    56,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,     0,     0,     0,    12,     0,    13,
      14,    15,    93,    94,    18,    19,     0,   104,     0,     0,
       0,    95,    96,    97,    23,    24,    25,    26,     0,     0,
      98,     0,     0,     0,     0,   277,     0,     0,     0,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,    42,    43,    44,    45,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   276,     0,
       0,   103,    51,     0,    52,    53,     0,     0,     0,    55,
      56,     5,     6,     7,     8,     9,     0,     0,     0,    10,
      11,     0,     0,     0,    12,     0,    13,    14,    15,    16,
      17,    18,    19,     0,   104,     0,     0,     0,    20,    21,
      22,    23,    24,    25,    26,     0,     0,    27,     0,     0,
       0,     0,   485,    28,    29,    30,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,     0,    54,     0,    55,    56,     5,     6,
       7,     8,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,     0,    13,    14,    15,    16,    17,    18,    19,
       0,    57,    58,    59,     0,    20,    21,    22,    23,    24,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,    42,    43,    44,    45,
      46,     0,    47,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
       0,    54,     0,    55,    56,     5,     6,     7,     0,     9,
       0,     0,     0,    10,    11,     0,     0,     0,    12,     0,
      13,    14,    15,    16,    17,    18,    19,     0,    57,    58,
      59,     0,    20,    21,    22,    23,    24,    25,    26,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
      31,    32,     0,    33,    34,    35,    36,    37,    38,   233,
      39,    40,    41,    42,    43,    44,    45,    46,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
       0,     0,   103,    51,     0,    52,    53,     0,   234,   235,
      55,    56,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,     0,     0,     0,    12,     0,    13,    14,    15,
      93,    94,    18,    19,     0,    57,   236,    59,     0,    95,
      96,    97,    23,    24,    25,    26,     0,     0,    98,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,   233,    39,    40,    41,
      42,    43,    44,    45,    46,     0,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   209,     0,     0,   103,
      51,     0,    52,    53,     0,   594,   235,    55,    56,     5,
       6,     7,     0,     9,     0,     0,     0,    10,    11,     0,
       0,     0,    12,     0,    13,    14,    15,    93,    94,    18,
      19,     0,    57,   236,    59,     0,    95,    96,    97,    23,
      24,    25,    26,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,    31,    32,     0,    33,    34,    35,
      36,    37,    38,   233,    39,    40,    41,    42,    43,    44,
      45,    46,     0,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   209,     0,     0,   103,    51,     0,    52,
      53,     0,   234,     0,    55,    56,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,     0,     0,     0,    12,
       0,    13,    14,    15,    93,    94,    18,    19,     0,    57,
     236,    59,     0,    95,    96,    97,    23,    24,    25,    26,
       0,     0,    98,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
     233,    39,    40,    41,    42,    43,    44,    45,    46,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     209,     0,     0,   103,    51,     0,    52,    53,     0,     0,
     235,    55,    56,     5,     6,     7,     0,     9,     0,     0,
       0,    10,    11,     0,     0,     0,    12,     0,    13,    14,
      15,    93,    94,    18,    19,     0,    57,   236,    59,     0,
      95,    96,    97,    23,    24,    25,    26,     0,     0,    98,
       0,     0,     0,     0,     0,     0,     0,     0,    31,    32,
       0,    33,    34,    35,    36,    37,    38,   233,    39,    40,
      41,    42,    43,    44,    45,    46,     0,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   209,     0,     0,
     103,    51,     0,    52,    53,     0,   594,     0,    55,    56,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
       0,     0,     0,    12,     0,    13,    14,    15,    93,    94,
      18,    19,     0,    57,   236,    59,     0,    95,    96,    97,
      23,    24,    25,    26,     0,     0,    98,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,   233,    39,    40,    41,    42,    43,
      44,    45,    46,     0,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,     0,     0,   103,    51,     0,
      52,    53,     0,     0,     0,    55,    56,     5,     6,     7,
       0,     9,     0,     0,     0,    10,    11,     0,     0,     0,
      12,     0,    13,    14,    15,    16,    17,    18,    19,     0,
      57,   236,    59,     0,    20,    21,    22,    23,    24,    25,
      26,     0,     0,    98,     0,     0,     0,     0,     0,     0,
       0,     0,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,    42,    43,    44,    45,    46,
       0,    47,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   209,     0,     0,   103,    51,     0,    52,    53,     0,
     479,     0,    55,    56,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,     0,     0,     0,    12,     0,    13,
      14,    15,    93,    94,    18,    19,     0,    57,   236,    59,
       0,    95,    96,    97,    23,    24,    25,    26,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,     0,    33,    34,    35,    36,    37,    38,     0,    39,
      40,    41,    42,    43,    44,    45,    46,     0,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   209,     0,
       0,   103,    51,     0,    52,    53,     0,   479,     0,    55,
      56,     5,     6,     7,     0,     9,     0,     0,     0,    10,
      11,     0,     0,     0,    12,     0,    13,    14,    15,    93,
      94,    18,    19,     0,    57,   236,    59,     0,    95,    96,
      97,    23,    24,    25,    26,     0,     0,    98,     0,     0,
       0,     0,     0,     0,     0,     0,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,     0,    47,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   209,     0,     0,   103,    51,
       0,    52,    53,     0,   234,     0,    55,    56,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,     0,    13,    14,    15,    93,    94,    18,    19,
       0,    57,   236,    59,     0,    95,    96,    97,    23,    24,
      25,    26,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,    42,    43,    44,    45,
      46,     0,    47,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   209,     0,     0,   103,    51,     0,    52,    53,
       0,   744,     0,    55,    56,     5,     6,     7,     0,     9,
       0,     0,     0,    10,    11,     0,     0,     0,    12,     0,
      13,    14,    15,    93,    94,    18,    19,     0,    57,   236,
      59,     0,    95,    96,    97,    23,    24,    25,    26,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,    45,    46,     0,    47,
      48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
       0,     0,   103,    51,     0,    52,    53,     0,   594,     0,
      55,    56,     5,     6,     7,     0,     9,     0,     0,     0,
      10,    11,     0,     0,     0,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,    57,   236,    59,     0,    20,
      21,    22,    23,    24,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,    31,    32,     0,
      33,    34,    35,    36,    37,    38,     0,    39,    40,    41,
      42,    43,    44,    45,    46,     0,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   209,     0,     0,   103,
      51,     0,    52,    53,     0,     0,     0,    55,    56,     5,
       6,     7,     0,     9,     0,     0,     0,    10,    11,     0,
       0,     0,    12,     0,    13,    14,    15,    93,    94,    18,
      19,     0,    57,    58,    59,     0,    95,    96,    97,    23,
      24,    25,    26,     0,     0,    98,     0,     0,     0,     0,
       0,     0,     0,     0,    31,    32,     0,    33,    34,    35,
      36,    37,    38,     0,    39,    40,    41,    42,    43,    44,
      45,    46,     0,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   209,     0,     0,   103,    51,     0,    52,
      53,     0,     0,     0,    55,    56,     5,     6,     7,     0,
       9,     0,     0,     0,    10,    11,     0,     0,     0,    12,
       0,    13,    14,    15,    16,    17,    18,    19,     0,    57,
     236,    59,     0,    20,    21,    22,    23,    24,    25,    26,
       0,     0,    98,     0,     0,     0,     0,     0,     0,     0,
       0,    31,    32,     0,    33,    34,    35,    36,    37,    38,
       0,    39,    40,    41,    42,    43,    44,    45,    46,     0,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     209,     0,     0,   103,    51,     0,    52,    53,     0,     0,
       0,    55,    56,     5,     6,     7,     0,     9,     0,     0,
       0,    10,    11,     0,     0,     0,    12,     0,    13,    14,
      15,    93,    94,    18,    19,     0,    57,   236,    59,     0,
      95,    96,    97,    23,    24,    25,    26,     0,     0,    98,
       0,     0,     0,     0,     0,     0,     0,     0,    31,    32,
       0,    99,    34,    35,    36,   100,    38,     0,    39,    40,
      41,    42,    43,    44,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   101,     0,     0,   102,     0,     0,
     103,    51,     0,    52,    53,     0,     0,     0,    55,    56,
       5,     6,     7,     0,     9,     0,     0,     0,    10,    11,
       0,     0,     0,    12,     0,    13,    14,    15,    93,    94,
      18,    19,     0,   104,     0,     0,     0,    95,    96,    97,
      23,    24,    25,    26,     0,     0,    98,     0,     0,     0,
       0,     0,     0,     0,     0,    31,    32,     0,    33,    34,
      35,    36,    37,    38,     0,    39,    40,    41,    42,    43,
      44,    45,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   226,     0,     0,    50,    51,     0,
      52,    53,     0,    54,     0,    55,    56,     5,     6,     7,
       0,     9,     0,     0,     0,    10,    11,     0,     0,     0,
      12,     0,    13,    14,    15,    93,    94,    18,    19,     0,
     104,     0,     0,     0,    95,    96,    97,    23,    24,    25,
      26,     0,     0,    98,     0,     0,     0,     0,     0,     0,
       0,     0,    31,    32,     0,    33,    34,    35,    36,    37,
      38,     0,    39,    40,    41,    42,    43,    44,    45,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   276,     0,     0,   306,    51,     0,    52,    53,     0,
     307,     0,    55,    56,     5,     6,     7,     0,     9,     0,
       0,     0,    10,    11,     0,     0,     0,    12,     0,    13,
      14,    15,    93,    94,    18,    19,     0,   104,     0,     0,
       0,    95,    96,    97,    23,    24,    25,    26,     0,     0,
      98,     0,     0,     0,     0,     0,     0,     0,     0,    31,
      32,     0,    99,    34,    35,    36,   100,    38,     0,    39,
      40,    41,    42,    43,    44,    45,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   102,     0,
       0,   103,    51,     0,    52,    53,     0,     0,     0,    55,
      56,     5,     6,     7,     0,     9,     0,     0,     0,    10,
      11,     0,     0,     0,    12,     0,    13,    14,    15,    93,
      94,    18,    19,     0,   104,     0,     0,     0,    95,    96,
      97,    23,    24,    25,    26,     0,     0,    98,     0,     0,
       0,     0,     0,     0,     0,     0,    31,    32,     0,    33,
      34,    35,    36,    37,    38,     0,    39,    40,    41,    42,
      43,    44,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   276,     0,     0,   306,    51,
       0,    52,    53,     0,     0,     0,    55,    56,     5,     6,
       7,     0,     9,     0,     0,     0,    10,    11,     0,     0,
       0,    12,     0,    13,    14,    15,    93,    94,    18,    19,
       0,   104,     0,     0,     0,    95,    96,    97,    23,    24,
      25,    26,     0,     0,    98,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    32,     0,    33,    34,    35,    36,
      37,    38,     0,    39,    40,    41,    42,    43,    44,    45,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   771,     0,     0,   103,    51,     0,    52,    53,
       0,     0,     0,    55,    56,     5,     6,     7,     0,     9,
       0,     0,     0,    10,    11,     0,     0,     0,    12,     0,
      13,    14,    15,    93,    94,    18,    19,     0,   104,     0,
       0,     0,    95,    96,    97,    23,    24,    25,    26,     0,
       0,    98,     0,     0,     0,     0,     0,     0,     0,     0,
      31,    32,     0,    33,    34,    35,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,    45,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   520,   521,     0,   849,
     522,     0,   103,    51,     0,    52,    53,     0,     0,     0,
      55,    56,   156,   157,   158,   159,   160,   161,   162,   163,
     164,     0,     0,   165,   166,     0,     0,   167,   168,   169,
     170,     0,     0,     0,     0,   104,     0,     0,     0,     0,
       0,   171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,     0,   182,
     183,     0,     0,   528,   529,     0,     0,   530,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   184,   250,   156,
     157,   158,   159,   160,   161,   162,   163,   164,     0,     0,
     165,   166,     0,     0,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,     0,   182,   183,     0,     0,
     550,   521,     0,     0,   551,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   250,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,     0,   165,   166,     0,
       0,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,     0,   182,   183,     0,     0,   534,   529,     0,
       0,   535,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   184,   250,   156,   157,   158,   159,   160,   161,   162,
     163,   164,     0,     0,   165,   166,     0,     0,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   171,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,     0,
     182,   183,     0,     0,   574,   521,     0,     0,   575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   184,   250,
     156,   157,   158,   159,   160,   161,   162,   163,   164,     0,
       0,   165,   166,     0,     0,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   171,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,     0,   182,   183,     0,
       0,   577,   529,     0,     0,   578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,   250,   156,   157,   158,
     159,   160,   161,   162,   163,   164,     0,     0,   165,   166,
       0,     0,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   171,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,     0,   182,   183,     0,     0,   587,   521,
       0,     0,   588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   184,   250,   156,   157,   158,   159,   160,   161,
     162,   163,   164,     0,     0,   165,   166,     0,     0,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
       0,   182,   183,     0,     0,   590,   529,     0,     0,   591,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   184,
     250,   156,   157,   158,   159,   160,   161,   162,   163,   164,
       0,     0,   165,   166,     0,     0,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,     0,   182,   183,
       0,     0,   614,   521,     0,     0,   615,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   184,   250,   156,   157,
     158,   159,   160,   161,   162,   163,   164,     0,     0,   165,
     166,     0,     0,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,     0,   182,   183,     0,     0,   617,
     529,     0,     0,   618,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   184,   250,   156,   157,   158,   159,   160,
     161,   162,   163,   164,     0,     0,   165,   166,     0,     0,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,     0,   182,   183,     0,     0,   861,   521,     0,     0,
     862,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     184,   250,   156,   157,   158,   159,   160,   161,   162,   163,
     164,     0,     0,   165,   166,     0,     0,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,     0,   182,
     183,     0,     0,   864,   529,     0,     0,   865,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   184,   250,   156,
     157,   158,   159,   160,   161,   162,   163,   164,     0,     0,
     165,   166,     0,     0,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,     0,   182,   183,     0,     0,
     893,   521,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   250,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,     0,   165,   166,     0,
       0,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,     0,   182,   183,     0,     0,     0,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   184,   250,   323,   324,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,  -513,  -513,     0,     0,
     323,   324,     0,     0,     0,     0,     0,     0,     0,     0,
     325,     0,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,     0,     0,     0,     0,     0,     0,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335
};

static const yytype_int16 yycheck[] =
{
       2,    11,    12,    27,     7,     8,     5,     6,    28,    58,
     217,    22,   362,     7,   450,   372,    15,   387,    16,    17,
     405,   309,    20,   243,     8,    28,   253,   392,     2,    22,
       4,   337,     4,   282,   282,    16,    17,   102,   265,    20,
      72,    50,   634,   402,    28,    12,   405,    54,   433,   441,
      52,    53,   631,    56,   360,    54,   336,    61,   338,   339,
     340,   722,    56,   277,   270,     1,    26,   720,   274,   718,
     554,    52,    53,    72,    61,    25,   382,   538,   539,    90,
      25,   361,   643,    16,    17,    27,    29,    20,   814,   395,
      13,    77,   576,   485,    61,   137,    25,    90,    16,    17,
     309,   381,    20,   383,    97,   589,    86,    37,    38,   263,
       0,    88,    25,    13,    25,   364,   396,    86,   111,    52,
      25,    25,    86,    55,   631,    86,    25,   634,    13,   115,
      13,    28,   616,   110,    25,    88,   643,   443,    86,   106,
      13,   790,    13,   423,   110,    51,    86,    53,    54,    55,
      56,    88,   306,   879,   658,   110,    15,   110,    17,   139,
     140,   665,   371,   143,   444,   108,    26,    88,    88,    10,
     139,   140,   143,   110,     8,   736,   140,   137,   114,   140,
     407,   143,    25,   844,   411,   621,   622,   840,   141,   416,
     110,   141,   140,   842,   414,    26,   141,   110,   425,   549,
     140,   428,   206,   205,   146,   147,   455,   455,   800,   559,
     146,   147,   141,   674,   224,   225,   220,   147,   603,   206,
     143,   870,   579,   146,   147,   804,    86,   441,   141,   203,
     141,   144,   143,   812,   147,   141,   141,   141,   143,   206,
     242,   243,   141,   602,   603,   277,   146,   147,   250,   247,
     141,   249,   250,   220,   263,   304,   141,   484,   110,   651,
     309,   146,   147,   146,   147,   141,   247,   110,   249,    88,
      86,   485,   110,   146,   147,   146,   147,   137,   277,   139,
     140,   143,   718,   143,   720,   295,   296,   297,   298,    86,
     141,   110,    55,   800,   359,   344,   345,   306,   141,    86,
     307,   144,    88,   141,   147,   812,   137,   814,   307,   558,
     558,    86,   143,   143,   247,    88,   249,   147,    88,     2,
     294,     4,   294,   139,   140,   299,     9,    17,    86,   247,
     557,   249,    15,   336,    69,   337,   146,   110,    86,   337,
     110,    86,   139,   140,   709,   338,    51,    55,    53,    54,
      55,    56,   139,   140,   790,   791,   359,    26,   360,    10,
      11,    12,   360,    25,   652,   140,    89,    50,   361,   371,
     372,   304,   879,    86,   581,   141,   309,   597,   381,   863,
     382,   139,   140,   137,   382,   120,   121,   122,   355,    86,
     383,   394,   140,   395,   643,   140,    69,   395,   625,   419,
      51,   375,   787,   396,   840,   611,   842,   439,    86,   441,
      51,   413,   414,   783,    55,   765,   419,    86,   420,   422,
     103,   402,    58,    59,   391,   392,   783,   140,   787,    86,
     423,   146,   147,   144,   870,   419,   141,   651,   371,   442,
     439,   443,   441,   140,    88,   443,   420,    37,    38,   430,
     101,   444,   141,   485,   681,   388,    86,   141,   147,   461,
     147,   463,   140,   465,    86,   110,   110,   138,   137,   145,
     139,   140,    55,    26,   143,    86,   478,   827,   141,    58,
      59,   688,   139,   140,   147,   509,   485,   141,    14,    15,
     717,    69,   712,   536,   537,    86,   723,   141,     2,    69,
       4,     5,     6,   527,    26,     9,    10,    11,    12,   139,
     140,    15,    16,    17,   525,   141,    20,   139,   140,    88,
     203,   770,   533,    88,   830,   536,   537,    95,   139,   140,
     554,   533,   525,    86,   536,   537,   538,   539,   548,    15,
     533,   110,   562,   536,   537,   110,    50,    51,   139,   140,
      54,   831,   576,   555,    58,    86,    13,    10,   561,   562,
     553,    88,   555,   565,    86,   589,   568,   561,    72,   571,
     144,   778,   141,   224,   225,   258,   141,   579,   562,   546,
     263,    86,   592,   110,   137,   141,   139,   140,   138,   141,
     143,   110,   616,   560,   141,   597,   141,   101,    88,   103,
     141,    51,   253,   652,   255,    69,   655,   656,   139,   140,
      51,   294,   661,   662,   141,   137,   299,   139,   140,   651,
     110,   602,   110,   306,   141,   627,   309,   141,    51,   141,
      53,    54,    55,    56,   139,   140,   463,    89,   465,   141,
      10,   643,     9,   138,   295,   296,   297,   298,    10,   300,
     301,   141,   651,   146,   118,   119,   120,   121,   122,    51,
     141,    53,    54,    55,    56,   112,    51,    90,    53,    54,
      55,    56,   674,    96,    97,   141,   145,    10,    51,   362,
      53,    54,    55,    56,   694,    10,    10,    10,   687,    10,
     141,   110,   375,   141,   117,   378,   138,   120,    90,   203,
     115,   141,   141,   386,    96,    97,   755,   141,   141,   676,
     712,    51,   363,    53,    54,    55,    56,    90,    10,   141,
     224,   225,    10,   146,    97,   117,   728,   729,   120,   731,
     141,   733,   734,   141,   736,   141,   738,   420,   740,   741,
     138,    55,   709,   247,   117,   249,   250,    10,    10,   253,
      90,   255,   141,   141,   258,   115,    96,    97,   141,   263,
     138,    10,    51,    10,    53,    54,    55,    56,    40,    41,
      42,    43,    44,   277,    55,   141,   141,   117,   141,    10,
     120,   783,   141,    51,   141,    53,    54,    55,    56,   143,
     294,   295,   296,   297,   298,   299,   300,   301,   143,   141,
     304,    90,   306,   307,   420,   309,    15,    96,     6,   867,
     809,   844,   621,    79,   832,     7,     2,   812,     4,     5,
       6,     7,    90,     9,   770,   631,   829,    -1,   830,    15,
     832,    -1,   830,   337,    -1,    -1,    -1,    -1,   831,   863,
     344,   345,    -1,   845,   846,   847,   848,    -1,    -1,    -1,
     852,   853,   854,    -1,   856,   857,   360,    -1,   362,   363,
      -1,    -1,    -1,    -1,    50,   867,   549,    -1,    54,    -1,
      -1,   375,    -1,    -1,   378,   878,   559,    -1,   382,    -1,
      -1,    -1,   386,    -1,   567,    -1,    72,    -1,    -1,    -1,
     892,   395,    -1,   895,   896,   897,   898,   548,    -1,    -1,
      -1,   728,   729,   905,   731,    69,   733,   734,    -1,    -1,
      -1,   738,    -1,   740,   741,    69,   420,   103,    -1,    -1,
      84,    85,    -1,    -1,   634,    -1,    -1,   637,    -1,    -1,
      84,    85,    -1,   643,    -1,   439,    -1,   441,    -1,   443,
      -1,   592,    -1,    -1,    -1,   628,   629,    -1,    -1,    -1,
      -1,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
      -1,   644,    -1,   117,   118,   119,   120,   121,   122,   652,
      51,    -1,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,   485,    -1,    -1,    -1,     2,    -1,     4,   671,   672,
      -1,    -1,     9,    10,    11,    12,    -1,    69,    -1,    16,
      17,    -1,    -1,    20,   687,    -1,    -1,    -1,   691,    90,
      -1,    -1,    84,    85,    -1,    96,    97,   203,   845,   846,
     847,   848,   705,   706,   707,   852,   853,   854,    -1,   856,
     857,    -1,    -1,    50,    51,    -1,   117,    -1,    -1,   120,
      -1,    58,    53,   694,   548,   549,   118,   119,   120,   121,
     122,    -1,    -1,    -1,    -1,   559,    51,    -1,    53,    54,
      55,    56,   143,   567,    -1,   892,    -1,    -1,   895,   896,
     897,   898,   258,    -1,    -1,    -1,    -1,   263,   905,    -1,
      -1,   764,   765,    -1,   101,    -1,   103,    -1,   592,    -1,
     800,   277,   802,   776,    -1,    90,   806,    -1,    -1,    -1,
      -1,    96,    -1,    -1,   814,    -1,   816,    -1,   294,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
     306,   307,    -1,    -1,   628,   629,    -1,    51,    -1,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     644,    -1,    -1,    -1,   827,    -1,    50,   651,   652,    -1,
     833,   655,   656,    -1,    -1,    -1,   839,   661,   662,    -1,
      -1,    -1,    -1,   873,    -1,    -1,    90,   671,   672,   879,
      -1,   881,    96,    97,   884,    -1,   362,    -1,    -1,    -1,
      -1,    -1,    -1,   687,    -1,    -1,   203,   691,    -1,   375,
     694,   901,   378,   117,    -1,    -1,   120,    -1,    -1,   103,
     386,   705,   706,   707,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,
      -1,    -1,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     247,    -1,   249,   250,   420,    -1,   253,    -1,   255,    -1,
      -1,   258,    -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,
      -1,   755,    -1,   439,    -1,   441,    -1,    -1,    -1,    -1,
     764,   765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   776,    -1,    -1,    -1,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,    -1,   304,    -1,   306,
      -1,    -1,   309,   304,    -1,    -1,    -1,    -1,   309,   485,
      -1,    -1,    -1,    -1,    -1,   809,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     337,    -1,    -1,   827,    -1,    -1,   830,   344,   345,   833,
      -1,    -1,    -1,    -1,    -1,   839,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   360,    -1,   362,   363,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,   375,   263,
     371,   378,    -1,   549,    -1,   382,    -1,    -1,     2,   386,
       4,    -1,    -1,   559,    -1,     9,    -1,   388,   395,    -1,
      -1,   567,    -1,    69,    70,    71,    72,    73,    74,    75,
     401,   402,    78,    79,   405,    -1,    -1,    -1,    84,    85,
      -1,    -1,   306,   420,    -1,     2,    -1,     4,     5,     6,
      -1,    -1,     9,    -1,    -1,    -1,    50,    -1,    15,   430,
      -1,    -1,   433,    -1,    -1,    -1,   443,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,    -1,    -1,
      -1,    -1,   628,   629,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    50,    78,    79,    -1,    54,   644,    -1,
      84,    85,    -1,    -1,    -1,   651,    -1,    -1,   479,   103,
      -1,    -1,    -1,    -1,   378,    72,    -1,    -1,    -1,    -1,
      -1,    -1,   386,    -1,    -1,   671,   672,    -1,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
      -1,   687,    -1,    -1,    -1,   691,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   705,
     706,   707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     567,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    -1,    -1,    84,    85,   203,
      -1,    -1,    -1,    -1,    -1,   592,    -1,    -1,   764,   765,
      -1,    -1,    -1,   594,    -1,    -1,    -1,    -1,    -1,    -1,
     776,   602,   603,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   203,    -1,   619,    -1,
      -1,   628,   629,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   809,   258,    -1,    -1,   644,    -1,   263,
     147,    -1,    -1,    -1,    -1,   652,    -1,   648,   655,   656,
      -1,   827,    -1,    -1,   661,   662,    -1,   833,    -1,    -1,
      -1,    -1,    -1,   839,   671,   672,    -1,    -1,    -1,    -1,
     294,   258,    -1,   567,    -1,   299,   263,    -1,    -1,    -1,
      -1,    -1,   306,    -1,   691,    -1,    -1,   694,    -1,    -1,
     277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   705,   706,
     707,    -1,    -1,   704,    -1,    -1,    -1,   294,    -1,    -1,
      -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,   306,
     307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   628,   629,    -1,    -1,   362,    -1,
      -1,    -1,    -1,   744,    -1,    -1,    -1,    -1,   755,    -1,
     644,   375,    -1,    -1,   378,    -1,    -1,   764,   765,    -1,
      -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,    -1,   776,
      -1,    -1,    -1,    -1,    -1,   362,    -1,   671,   672,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   787,    -1,   375,    -1,
      -1,   378,    -1,    -1,    -1,    -1,   420,   691,    -1,   386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   705,   706,   707,    -1,    -1,    -1,    -1,    -1,    -1,
     827,    -1,    -1,   830,    -1,    -1,   833,    -1,    -1,    -1,
      -1,    -1,   839,   420,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,    -1,    -1,
      -1,    -1,   439,    -1,   441,     8,     9,    10,    -1,    -1,
      13,    14,    15,    -1,    17,    -1,    -1,    -1,    -1,    -1,
     764,    -1,    -1,    -1,    27,    -1,    -1,    44,    -1,    -1,
      -1,    -1,   776,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,   485,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    -1,    -1,    84,    85,    -1,
      -1,    -1,    -1,    -1,    -1,   549,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    -1,   559,    -1,    -1,    -1,   833,
      -1,    -1,    -1,   567,   111,   839,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,   549,    -1,    -1,    16,    17,    -1,    -1,    20,
      -1,    -1,   559,    -1,   141,    -1,    -1,    -1,    -1,    -1,
     567,    -1,    -1,    -1,    -1,   138,    -1,   140,    -1,    -1,
     143,   144,    -1,   146,   147,    -1,    47,    48,    -1,    44,
      -1,    52,    53,    -1,   628,   629,    -1,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     644,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    -1,    -1,    84,
      85,   628,   629,    -1,    -1,    -1,    -1,   671,   672,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   644,    -1,    -1,
      -1,    44,    -1,    -1,   651,    -1,   111,   691,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,    -1,
      -1,   705,   706,   707,   671,   672,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    -1,
     687,    84,    85,    -1,   691,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   705,   706,
     707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     764,   765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   764,   765,    -1,
      -1,    -1,   233,   234,   235,   236,    -1,    -1,    -1,   776,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,   249,   250,
      -1,    -1,    -1,   827,    -1,    -1,    -1,    -1,    -1,   833,
      -1,    -1,    -1,    -1,    -1,   839,    -1,    -1,    -1,    -1,
      -1,    -1,   809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     827,    -1,    -1,    -1,    -1,    -1,   833,    -1,    -1,    -1,
      -1,    -1,   839,   304,    -1,    -1,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,    -1,    -1,    -1,
      -1,    -1,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
     371,    78,    79,    -1,    -1,    -1,    -1,    84,    85,   380,
      -1,   382,    -1,   384,   385,    -1,    -1,   388,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,
     401,   402,    -1,    -1,   405,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,   430,
      -1,    -1,   433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       0,     1,   443,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,   468,   469,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,   479,    39,
      -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    96,    -1,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,   147,    -1,    -1,
      -1,    -1,    -1,   594,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   602,   603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    52,    -1,    -1,    55,    -1,    -1,   619,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    78,    79,
      -1,    -1,    82,    83,    84,    85,    -1,   648,    -1,    -1,
      -1,   652,   653,    -1,   655,   656,    96,    -1,    -1,    -1,
     661,   662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   673,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   697,   698,    -1,   700,
     701,    -1,   142,   704,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    -1,    17,    -1,    -1,
      -1,    -1,    -1,   744,    -1,    -1,    26,   748,    -1,    -1,
      -1,    -1,    -1,    -1,   755,    -1,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   780,
      -1,    -1,    -1,    -1,    -1,    -1,   787,    -1,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    -1,    -1,    84,    85,    86,     0,    88,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    -1,    17,    -1,    -1,    -1,    -1,   830,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,    -1,   146,   147,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    -1,
      -1,    84,    85,    86,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,   139,   140,   141,    -1,
      -1,   144,    -1,   146,   147,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    -1,    15,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    47,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,
      96,    -1,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
     146,   147,    10,    11,    12,    -1,    14,    15,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    90,    91,    -1,    93,    94,    -1,    96,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   123,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    10,    11,    12,   146,   147,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,
      -1,    96,    -1,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    10,    11,
      12,   146,   147,    15,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    -1,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    11,    12,    -1,   146,   147,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    96,    -1,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,   147,     1,    -1,
       3,     4,     5,     6,     7,    -1,     9,    10,    11,    12,
      -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    47,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,
      93,    94,    -1,    96,    -1,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      11,    12,    -1,   146,   147,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    47,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,
      91,    -1,    93,    94,    -1,    96,    -1,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,   146,   147,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,
      -1,    -1,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    47,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,
      94,    -1,    96,    -1,    98,    99,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,    -1,   146,   147,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      47,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,    96,
      -1,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   123,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,     1,    -1,     3,     4,     5,     6,     7,   146,
     147,    10,    11,    12,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    91,    -1,    93,    94,    -1,    96,    -1,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,    -1,   146,   147,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,    96,
      97,    98,    99,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,   123,   124,   125,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
     147,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    -1,    -1,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,     7,
      -1,    -1,    -1,    11,    12,    -1,   146,   147,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    90,    91,    -1,    93,    94,    -1,    -1,    -1,
      98,    99,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,   123,   124,   125,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,   147,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,
      91,    -1,    93,    94,    -1,    96,    -1,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,   146,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    -1,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   146,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      78,    79,    -1,    -1,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,    -1,   142,   143,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,    26,    -1,    -1,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    96,    97,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,    -1,     7,    -1,   137,    -1,    11,
      12,    -1,    -1,   143,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,    26,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    97,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,     7,    -1,   137,    -1,    11,    12,    -1,
      -1,   143,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,
      94,    -1,    96,    97,    98,    99,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,   123,
     124,   125,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,   137,    -1,    -1,    -1,    -1,    -1,   143,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    90,    91,    -1,    93,    94,    -1,    96,
      97,    98,    99,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,   110,    -1,    -1,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,   123,   124,   125,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,
      90,    91,    -1,    93,    94,    -1,    96,    97,    98,    99,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
     110,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,   123,   124,   125,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,   143,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,
      93,    94,    -1,    96,    97,    98,    99,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
     123,   124,   125,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
     143,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,
      96,    97,    98,    99,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,   123,   124,   125,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    91,    -1,    93,    94,    -1,    96,    97,    98,
      99,     3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,   123,   124,   125,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,   143,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    97,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   143,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   142,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   142,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,    -1,    -1,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,
      16,   142,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,
      -1,    -1,    98,    99,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,   123,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    91,    -1,    93,    94,    -1,    -1,    -1,    98,
      99,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,   123,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,   141,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    -1,    98,    99,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,   123,   124,   125,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,
      -1,    96,    -1,    98,    99,     3,     4,     5,    -1,     7,
      -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,   123,   124,
     125,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    90,    91,    -1,    93,    94,    -1,    96,    97,
      98,    99,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,   123,   124,   125,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,
      91,    -1,    93,    94,    -1,    96,    97,    98,    99,     3,
       4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,
      -1,    -1,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,   123,   124,   125,    -1,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,
      94,    -1,    96,    -1,    98,    99,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,   123,
     124,   125,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,    -1,
      97,    98,    99,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,   123,   124,   125,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    96,    -1,    98,    99,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
      -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,   123,   124,   125,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,
      93,    94,    -1,    -1,    -1,    98,    99,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
     123,   124,   125,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,
      96,    -1,    98,    99,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,   123,   124,   125,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    91,    -1,    93,    94,    -1,    96,    -1,    98,
      99,     3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,   123,   124,   125,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    96,    -1,    98,    99,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,   123,   124,   125,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,
      -1,    96,    -1,    98,    99,     3,     4,     5,    -1,     7,
      -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,   123,   124,
     125,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    90,    91,    -1,    93,    94,    -1,    96,    -1,
      98,    99,     3,     4,     5,    -1,     7,    -1,    -1,    -1,
      11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,
      21,    22,    23,    24,    -1,   123,   124,   125,    -1,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,
      91,    -1,    93,    94,    -1,    -1,    -1,    98,    99,     3,
       4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,
      -1,    -1,    16,    -1,    18,    19,    20,    21,    22,    23,
      24,    -1,   123,   124,   125,    -1,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,
      94,    -1,    -1,    -1,    98,    99,     3,     4,     5,    -1,
       7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    24,    -1,   123,
     124,   125,    -1,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,    -1,
      -1,    98,    99,     3,     4,     5,    -1,     7,    -1,    -1,
      -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,    19,
      20,    21,    22,    23,    24,    -1,   123,   124,   125,    -1,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    87,    -1,    -1,
      90,    91,    -1,    93,    94,    -1,    -1,    -1,    98,    99,
       3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,    12,
      -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    24,    -1,   123,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,    -1,
      93,    94,    -1,    96,    -1,    98,    99,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    24,    -1,
     123,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,    -1,
      96,    -1,    98,    99,     3,     4,     5,    -1,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    24,    -1,   123,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    91,    -1,    93,    94,    -1,    -1,    -1,    98,
      99,     3,     4,     5,    -1,     7,    -1,    -1,    -1,    11,
      12,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    24,    -1,   123,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    91,
      -1,    93,    94,    -1,    -1,    -1,    98,    99,     3,     4,
       5,    -1,     7,    -1,    -1,    -1,    11,    12,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    24,
      -1,   123,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    90,    91,    -1,    93,    94,
      -1,    -1,    -1,    98,    99,     3,     4,     5,    -1,     7,
      -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    16,    -1,
      18,    19,    20,    21,    22,    23,    24,    -1,   123,    -1,
      -1,    -1,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    -1,    87,
      55,    -1,    90,    91,    -1,    93,    94,    -1,    -1,    -1,
      98,    99,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    78,    79,    -1,    -1,    82,    83,    84,
      85,    -1,    -1,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,    -1,    -1,    51,    52,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,   143,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      78,    79,    -1,    -1,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,    -1,    -1,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,   143,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,    -1,    -1,    51,    52,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   142,   143,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    78,    79,    -1,    -1,    82,    83,
      84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,    -1,    -1,    51,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,   143,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    78,    79,    -1,    -1,    82,    83,    84,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,    -1,
      -1,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   142,   143,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    78,    79,
      -1,    -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,    -1,    -1,    51,    52,
      -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   142,   143,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    78,    79,    -1,    -1,    82,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,    -1,    -1,    51,    52,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,
     143,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    78,    79,    -1,    -1,    82,    83,    84,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
      -1,    -1,    51,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   142,   143,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    78,
      79,    -1,    -1,    82,    83,    84,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,    -1,    -1,    51,
      52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   142,   143,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    78,    79,    -1,    -1,
      82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,    -1,    -1,    51,    52,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     142,   143,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    78,    79,    -1,    -1,    82,    83,    84,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,    -1,    -1,    51,    52,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,   143,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      78,    79,    -1,    -1,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,    -1,    -1,
      51,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,   143,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,    82,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,   142,   143,    84,    85,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    -1,    -1,
      84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   149,   150,     0,     1,     3,     4,     5,     6,     7,
      11,    12,    16,    18,    19,    20,    21,    22,    23,    24,
      30,    31,    32,    33,    34,    35,    36,    39,    45,    46,
      47,    48,    49,    51,    52,    53,    54,    55,    56,    58,
      59,    60,    61,    62,    63,    64,    65,    67,    68,    87,
      90,    91,    93,    94,    96,    98,    99,   123,   124,   125,
     151,   152,   153,   158,   160,   161,   163,   164,   167,   168,
     170,   171,   172,   174,   175,   185,   198,   214,   233,   234,
     244,   245,   246,   247,   248,   250,   251,   252,   253,   254,
     277,   288,   153,    21,    22,    30,    31,    32,    39,    51,
      55,    84,    87,    90,   123,   176,   177,   198,   214,   251,
     254,   277,   177,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    45,    46,    47,
      48,    49,    50,    51,    52,    55,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    78,    79,    82,    83,    84,
      85,    96,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   124,   125,   142,   143,   178,   183,   184,   253,
     272,    33,    34,    35,    36,    48,    49,    51,    55,   178,
     179,   181,   248,     1,   155,   156,   157,   158,   288,    87,
     161,   162,   175,   214,   251,   252,   254,   162,   146,   147,
     162,   281,   286,   287,   201,   203,    87,   168,   175,   214,
     219,   251,   254,    57,    96,    97,   124,   167,   185,   186,
     191,   194,   196,   275,   276,   191,   191,   143,   192,   193,
     143,   188,   192,   143,   147,   282,   179,   154,   137,   185,
     214,   185,    55,    90,   156,   169,   170,   161,   187,   196,
     275,   288,   186,   274,   275,   288,    87,   141,   174,   214,
     251,   254,   200,    53,    54,    56,   178,   249,    58,    59,
     163,   185,   185,   281,   287,    40,    41,    42,    43,    44,
      37,    38,    28,   231,   110,   141,    90,    96,   171,   110,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    84,    85,   111,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    86,   139,   140,    86,
     140,    26,   137,   235,    88,    88,   188,   192,   235,   161,
      51,    55,   176,    58,    59,     1,   114,   255,   286,    86,
     139,   140,   210,   273,   211,    86,   140,   280,   141,   158,
      10,     8,   240,   288,   281,   287,    55,    13,   215,   286,
     110,    86,   139,   140,    88,    88,   215,   281,    17,   238,
     146,   162,   162,    55,    86,   139,   140,    25,   186,   186,
     186,    89,   141,   195,   288,   141,   195,   191,   282,   283,
     191,   190,   191,   196,   275,   288,   161,   283,   161,   159,
     137,   156,    86,   140,    88,   169,   144,   283,   199,   145,
     141,   147,   285,   141,   285,   138,   285,    55,   171,   172,
     173,   141,    86,   139,   140,    51,    53,    54,    55,    56,
      90,    96,    97,   117,   120,   143,   229,   258,   259,   260,
     261,   262,   263,   266,   267,   268,   269,   270,    69,    69,
     153,   162,   162,   162,   162,   158,   161,   161,   232,    96,
     163,   186,   196,   197,   169,   141,   174,   141,   160,   163,
     175,   185,   186,   197,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
      51,    52,    55,   183,   188,   278,   279,   190,    51,    52,
      55,   183,   188,   278,    51,    55,   278,   278,   237,   236,
     163,   185,   163,   185,    95,   165,   208,   286,   256,   207,
      51,    55,   176,   278,   190,   278,   155,   161,   143,   257,
     258,   212,   182,   186,   197,   241,   288,    15,   218,   288,
     158,   156,    13,   185,    51,    55,   190,    51,    55,   156,
     238,   196,    10,    27,   216,   286,   216,    51,    55,   190,
      51,    55,   205,   186,    96,   186,   194,   275,   276,   283,
     144,   283,   141,   141,   283,   179,   151,   138,   185,   283,
     283,   275,   171,   173,    51,    55,   190,    51,    55,   110,
      51,    90,    96,   220,   221,   222,   260,   258,    29,   108,
     230,   141,   271,   288,   141,   271,    51,   141,   271,    51,
     185,   185,    77,   115,   224,   225,   288,   186,   141,   283,
     173,   141,   110,    44,   282,    88,    88,   188,   192,   282,
     284,    88,    88,   188,   189,   192,   288,   189,   192,   189,
     192,   224,   224,    44,   166,   286,   162,   155,   284,    10,
     283,   258,   155,   286,   178,   179,   180,    89,   242,   288,
     156,     9,   243,   288,    14,   217,   218,    88,    88,   284,
      88,    88,   218,    10,   141,   215,   202,   204,   284,   162,
     186,   195,   275,   138,   285,   284,   186,   222,   141,   260,
     141,   283,   146,   226,   288,   156,   156,   261,   266,   268,
     270,   262,   263,   268,   262,    51,   223,   226,   262,   264,
     265,   268,   270,   156,    96,   186,   173,   185,   112,   163,
     185,   163,   185,   165,   145,    88,   163,   185,   163,   185,
     165,   156,   156,   185,   224,   209,   286,    10,   283,    10,
     213,    87,   175,   214,   251,   254,   215,   156,   162,    10,
      88,    10,   186,   156,   156,   156,   216,   141,   283,   221,
     141,    96,   220,    51,   227,   228,   259,   283,    10,   138,
     141,   271,   141,   271,   141,   271,   141,   271,   271,   110,
     226,   115,   141,   271,   141,   271,   141,   271,    10,   186,
     185,   163,   185,    10,   138,   156,   155,   257,    55,    86,
     139,   140,   156,   215,   218,   238,   239,    10,    10,   206,
     141,   221,   141,   260,   141,   262,   268,   262,   262,    87,
     214,   115,   265,   268,   262,   264,   268,   262,   138,    10,
     155,    51,    55,   190,    51,    55,   240,   156,   156,   221,
     141,   228,   271,   141,   271,   271,   271,    55,    86,   141,
     271,   141,   271,   271,   141,   271,   271,    10,   284,   217,
      10,   221,   262,    51,    55,   262,   268,   262,   262,   271,
     271,   141,   271,   271,   271,   262,   271
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (p, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, p)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, p); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_state *p)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, p)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    parser_state *p;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (p);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_state *p)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, p)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    parser_state *p;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, parser_state *p)
#else
static void
yy_reduce_print (yyvsp, yyrule, p)
    YYSTYPE *yyvsp;
    int yyrule;
    parser_state *p;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , p);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, p); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_state *p)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, p)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    parser_state *p;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (p);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (parser_state *p);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (parser_state *p)
#else
int
yyparse (p)
    parser_state *p;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 952 "../parse.y"
    {
		     p->lstate = EXPR_BEG;
		     local_nest(p);
		   ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 957 "../parse.y"
    {
		      p->tree = new_scope(p, (yyvsp[(2) - (2)].node));
		     local_unnest(p);
		    ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 964 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 970 "../parse.y"
    {
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 974 "../parse.y"
    {
		      (yyval.node) = new_begin(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 978 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), newline_node((yyvsp[(3) - (3)].node)));
		    ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 982 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 989 "../parse.y"
    {
		      if (p->in_def || p->in_single) {
			yyerror(p, "BEGIN in method");
		      }
		      (yyval.node) = local_switch(p);
		    ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 996 "../parse.y"
    {
		      p->begin_tree = append(p->begin_tree, (yyvsp[(4) - (5)].node));
		      local_resume(p, (yyvsp[(2) - (5)].node));
		      (yyval.node) = 0;
		    ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 1007 "../parse.y"
    {
		      if ((yyvsp[(2) - (4)].node)) {
			(yyval.node) = new_rescue(p, (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node));
		      }
		      else if ((yyvsp[(3) - (4)].node)) {
			yywarn(p, "else without rescue is useless");
			(yyval.node) = append((yyval.node), (yyvsp[(3) - (4)].node));
		      }
		      else {
			(yyval.node) = (yyvsp[(1) - (4)].node);
		      }
		      if ((yyvsp[(4) - (4)].node)) {
			if ((yyval.node)) {
			  (yyval.node) = new_ensure(p, (yyval.node), (yyvsp[(4) - (4)].node));
			}
			else {
			  (yyval.node) = append((yyvsp[(4) - (4)].node), new_nil(p));
			}
		      }
		    ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 1030 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 1036 "../parse.y"
    {
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 1040 "../parse.y"
    {
		      (yyval.node) = new_begin(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 1044 "../parse.y"
    {
			(yyval.node) = append((yyvsp[(1) - (3)].node), newline_node((yyvsp[(3) - (3)].node)));
		    ;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 1048 "../parse.y"
    {
		      (yyval.node) = new_begin(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 1053 "../parse.y"
    {p->lstate = EXPR_FNAME;;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 1054 "../parse.y"
    {
		      (yyval.node) = new_alias(p, (yyvsp[(2) - (4)].id), (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 1058 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 1062 "../parse.y"
    {
			(yyval.node) = new_if(p, cond((yyvsp[(3) - (3)].node)), (yyvsp[(1) - (3)].node), 0);
		    ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 1066 "../parse.y"
    {
		      (yyval.node) = new_unless(p, cond((yyvsp[(3) - (3)].node)), (yyvsp[(1) - (3)].node), 0);
		    ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 1070 "../parse.y"
    {
		      (yyval.node) = new_while(p, cond((yyvsp[(3) - (3)].node)), (yyvsp[(1) - (3)].node));
		    ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 1074 "../parse.y"
    {
		      (yyval.node) = new_until(p, cond((yyvsp[(3) - (3)].node)), (yyvsp[(1) - (3)].node));
		    ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 1078 "../parse.y"
    {
		      (yyval.node) = new_rescue(p, (yyvsp[(1) - (3)].node), list1(list3(0, 0, (yyvsp[(3) - (3)].node))), 0);
		    ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 1082 "../parse.y"
    {
		      if (p->in_def || p->in_single) {
			yywarn(p, "END in method; use at_exit");
		      }
		      (yyval.node) = new_postexe(p, (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 1090 "../parse.y"
    {
		      (yyval.node) = new_masgn(p, (yyvsp[(1) - (3)].node), list1((yyvsp[(3) - (3)].node)));
		    ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 1094 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].id), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 1098 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (6)].node), intern("[]"), (yyvsp[(3) - (6)].node)), (yyvsp[(5) - (6)].id), (yyvsp[(6) - (6)].node));
		    ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 1102 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 1106 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 1110 "../parse.y"
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.node) = 0;
		    ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 1115 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 1119 "../parse.y"
    {
		      backref_error(p, (yyvsp[(1) - (3)].node));
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 1124 "../parse.y"
    {
		      (yyval.node) = new_asgn(p, (yyvsp[(1) - (3)].node), new_array(p, (yyvsp[(3) - (3)].node)));
		    ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 1128 "../parse.y"
    {
		      (yyval.node) = new_masgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 1132 "../parse.y"
    {
		      (yyval.node) = new_masgn(p, (yyvsp[(1) - (3)].node), new_array(p, (yyvsp[(3) - (3)].node)));
		    ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 1139 "../parse.y"
    {
		      (yyval.node) = new_asgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 1143 "../parse.y"
    {
		      (yyval.node) = new_asgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 1151 "../parse.y"
    {
		      (yyval.node) = new_and(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 1155 "../parse.y"
    {
		      (yyval.node) = new_or(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 1159 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, cond((yyvsp[(3) - (3)].node)), "!");
		    ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 1163 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, cond((yyvsp[(2) - (2)].node)), "!");
		    ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 1170 "../parse.y"
    {
		      if (!(yyvsp[(1) - (1)].node)) (yyval.node) = new_nil(p);
		      else (yyval.node) = (yyvsp[(1) - (1)].node);
		    ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 1182 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 1186 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 1192 "../parse.y"
    {
		      local_nest(p);
		    ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 1198 "../parse.y"
    {
		      (yyval.node) = new_block(p, (yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node));
		      local_unnest(p);
		    ;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 1205 "../parse.y"
    {
		      (yyval.node) = new_fcall(p, (yyvsp[(1) - (2)].id), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 1209 "../parse.y"
    {
		      args_with_block(p, (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
		      (yyval.node) = new_fcall(p, (yyvsp[(1) - (3)].id), (yyvsp[(2) - (3)].node));
		    ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 1214 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 1218 "../parse.y"
    {
		      args_with_block(p, (yyvsp[(4) - (5)].node), (yyvsp[(5) - (5)].node));
		      (yyval.node) = new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), (yyvsp[(4) - (5)].node));
		   ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 1223 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 1227 "../parse.y"
    {
		      args_with_block(p, (yyvsp[(4) - (5)].node), (yyvsp[(5) - (5)].node));
		      (yyval.node) = new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), (yyvsp[(4) - (5)].node));
		    ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 1232 "../parse.y"
    {
		      (yyval.node) = new_super(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 1236 "../parse.y"
    {
		      (yyval.node) = new_yield(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 1240 "../parse.y"
    {
		      (yyval.node) = new_return(p, ret_args(p, (yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 1244 "../parse.y"
    {
		      (yyval.node) = new_break(p, ret_args(p, (yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 1248 "../parse.y"
    {
		      (yyval.node) = new_next(p, ret_args(p, (yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 1254 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		    ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 1258 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 1265 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(2) - (3)].node));
		    ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 1271 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 1275 "../parse.y"
    {
		      (yyval.node) = list1(append((yyvsp[(1) - (2)].node),(yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 1279 "../parse.y"
    {
		      (yyval.node) = list2((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 1283 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 1287 "../parse.y"
    {
		      (yyval.node) = list2((yyvsp[(1) - (2)].node), new_nil(p));
		    ;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 1291 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (4)].node), new_nil(p), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 1295 "../parse.y"
    {
		      (yyval.node) = list2(0, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 1299 "../parse.y"
    {
		      (yyval.node) = list3(0, (yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 1303 "../parse.y"
    {
		      (yyval.node) = list2(0, new_nil(p));
		    ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 1307 "../parse.y"
    {
		      (yyval.node) = list3(0, new_nil(p), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 1314 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 1320 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (2)].node));
		    ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 1324 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node));
		    ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 1330 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 1334 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 1340 "../parse.y"
    {
		      assignable(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 1344 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), intern("[]"), (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 1348 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 1352 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 1356 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 1360 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.node) = new_colon2(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id));
		    ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 1366 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.node) = new_colon3(p, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 1372 "../parse.y"
    {
		      backref_error(p, (yyvsp[(1) - (1)].node));
		      (yyval.node) = 0;
		    ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 1379 "../parse.y"
    {
		      assignable(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 1383 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), intern("[]"), (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 1387 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 1391 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 1395 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 1399 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.node) = new_colon2(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id));
		    ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 1405 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "dynamic constant assignment");
		      (yyval.node) = new_colon3(p, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 1411 "../parse.y"
    {
		      backref_error(p, (yyvsp[(1) - (1)].node));
		      (yyval.node) = 0;
		    ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 1418 "../parse.y"
    {
		      yyerror(p, "class/module name must be CONSTANT");
		    ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 1425 "../parse.y"
    {
		      (yyval.node) = cons((node*)1, (node*)(yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 1429 "../parse.y"
    {
		      (yyval.node) = cons((node*)0, (node*)(yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 1433 "../parse.y"
    {
		      (yyval.node) = cons((yyvsp[(1) - (3)].node), (node*)(yyvsp[(3) - (3)].id));
		    ;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 1442 "../parse.y"
    {
		      p->lstate = EXPR_ENDFN;
		      (yyval.id) = (yyvsp[(1) - (1)].id);
		    ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 1447 "../parse.y"
    {
		      p->lstate = EXPR_ENDFN;
		      (yyval.id) = (yyvsp[(1) - (1)].id);
		    ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 1458 "../parse.y"
    {
		      (yyval.node) = new_sym(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 1464 "../parse.y"
    {
		      (yyval.node) = new_undef(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 1467 "../parse.y"
    {p->lstate = EXPR_FNAME;;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 1468 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (4)].node), (node*)(yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 1473 "../parse.y"
    { (yyval.id) = intern("|"); ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 1474 "../parse.y"
    { (yyval.id) = intern("^"); ;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 1475 "../parse.y"
    { (yyval.id) = intern("&"); ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 1476 "../parse.y"
    { (yyval.id) = intern("<=>"); ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 1477 "../parse.y"
    { (yyval.id) = intern("=="); ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 1478 "../parse.y"
    { (yyval.id) = intern("==="); ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 1479 "../parse.y"
    { (yyval.id) = intern("=~"); ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 1480 "../parse.y"
    { (yyval.id) = intern("!~"); ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 1481 "../parse.y"
    { (yyval.id) = intern(">"); ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 1482 "../parse.y"
    { (yyval.id) = intern(">="); ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 1483 "../parse.y"
    { (yyval.id) = intern("<"); ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 1484 "../parse.y"
    { (yyval.id) = intern("<="); ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 1485 "../parse.y"
    { (yyval.id) = intern("!="); ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 1486 "../parse.y"
    { (yyval.id) = intern("<<"); ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 1487 "../parse.y"
    { (yyval.id) = intern(">>"); ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 1488 "../parse.y"
    { (yyval.id) = intern("+"); ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 1489 "../parse.y"
    { (yyval.id) = intern("-"); ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 1490 "../parse.y"
    { (yyval.id) = intern("*"); ;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 1491 "../parse.y"
    { (yyval.id) = intern("*"); ;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 1492 "../parse.y"
    { (yyval.id) = intern("/"); ;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 1493 "../parse.y"
    { (yyval.id) = intern("%"); ;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 1494 "../parse.y"
    { (yyval.id) = intern("**"); ;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 1495 "../parse.y"
    { (yyval.id) = intern("!"); ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 1496 "../parse.y"
    { (yyval.id) = intern("~"); ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 1497 "../parse.y"
    { (yyval.id) = intern("+@"); ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 1498 "../parse.y"
    { (yyval.id) = intern("-@"); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 1499 "../parse.y"
    { (yyval.id) = intern("[]"); ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 1500 "../parse.y"
    { (yyval.id) = intern("[]="); ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 1501 "../parse.y"
    { (yyval.id) = intern("`"); ;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1519 "../parse.y"
    {
		      (yyval.node) = new_asgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1523 "../parse.y"
    {
		      (yyval.node) = new_asgn(p, (yyvsp[(1) - (5)].node), new_rescue(p, (yyvsp[(3) - (5)].node), list1(list3(0, 0, (yyvsp[(5) - (5)].node))), 0));
		    ;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1527 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, (yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].id), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1531 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, (yyvsp[(1) - (5)].node), (yyvsp[(2) - (5)].id), new_rescue(p, (yyvsp[(3) - (5)].node), list1(list3(0, 0, (yyvsp[(5) - (5)].node))), 0));
		    ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1535 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (6)].node), intern("[]"), (yyvsp[(3) - (6)].node)), (yyvsp[(5) - (6)].id), (yyvsp[(6) - (6)].node));
		    ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1539 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1543 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1547 "../parse.y"
    {
		      (yyval.node) = new_op_asgn(p, new_call(p, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].id), 0), (yyvsp[(4) - (5)].id), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1551 "../parse.y"
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1556 "../parse.y"
    {
		      yyerror(p, "constant re-assignment");
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1561 "../parse.y"
    {
		      backref_error(p, (yyvsp[(1) - (3)].node));
		      (yyval.node) = new_begin(p, 0);
		    ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1566 "../parse.y"
    {
		      (yyval.node) = new_dot2(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1570 "../parse.y"
    {
		      (yyval.node) = new_dot3(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1574 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "+", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1578 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "-", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1582 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "*", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1586 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "/", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1590 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "%", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1594 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "**", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1598 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, call_bin_op(p, (yyvsp[(2) - (4)].node), "**", (yyvsp[(4) - (4)].node)), "-@");
		    ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1602 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, call_bin_op(p, (yyvsp[(2) - (4)].node), "**", (yyvsp[(4) - (4)].node)), "-@");
		    ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1606 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, (yyvsp[(2) - (2)].node), "+@");
		    ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1610 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, (yyvsp[(2) - (2)].node), "-@");
		    ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1614 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "|", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1618 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "^", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1622 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "&", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1626 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "<=>", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1630 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), ">", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1634 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), ">=", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1638 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "<", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1642 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "<=", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1646 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "==", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1650 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "===", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1654 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "!=", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1658 "../parse.y"
    {
		      (yyval.node) = match_op(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
#if 0
		      if (nd_type((yyvsp[(1) - (3)].node)) == NODE_LIT && TYPE((yyvsp[(1) - (3)].node)->nd_lit) == T_REGEXP) {
			(yyval.node) = reg_named_capture_assign((yyvsp[(1) - (3)].node)->nd_lit, (yyval.node));
		      }
#endif
		    ;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1667 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "!~", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1671 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, cond((yyvsp[(2) - (2)].node)), "!");
		    ;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1675 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, cond((yyvsp[(2) - (2)].node)), "~");
		    ;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1679 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), "<<", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1683 "../parse.y"
    {
		      (yyval.node) = call_bin_op(p, (yyvsp[(1) - (3)].node), ">>", (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1687 "../parse.y"
    {
		      (yyval.node) = new_and(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1691 "../parse.y"
    {
		      (yyval.node) = new_or(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1695 "../parse.y"
    {
		      (yyval.node) = new_if(p, cond((yyvsp[(1) - (6)].node)), (yyvsp[(3) - (6)].node), (yyvsp[(6) - (6)].node));
		    ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1699 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		    ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1705 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		      if (!(yyval.node)) (yyval.node) = new_nil(p);
		    ;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1713 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1717 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (4)].node), new_hash(p, (yyvsp[(3) - (4)].node)));
		    ;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1721 "../parse.y"
    {
		      (yyval.node) = new_hash(p, (yyvsp[(1) - (2)].node));
		    ;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1727 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1739 "../parse.y"
    {
		      (yyval.node) = cons((yyvsp[(1) - (2)].node),0);
		    ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1743 "../parse.y"
    {
		      (yyval.node) = cons(append((yyvsp[(1) - (4)].node), new_hash(p, (yyvsp[(3) - (4)].node))), 0);
		    ;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1747 "../parse.y"
    {
		      (yyval.node) = cons(list1(new_hash(p, (yyvsp[(1) - (2)].node))), 0);
		    ;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1753 "../parse.y"
    {
		      (yyval.node) = cons(list1((yyvsp[(1) - (1)].node)), 0);
		    ;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1757 "../parse.y"
    {
		      (yyval.node) = cons((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1761 "../parse.y"
    {
		      (yyval.node) = cons(list1(new_hash(p, (yyvsp[(1) - (2)].node))), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1765 "../parse.y"
    {
		      (yyval.node) = cons(append((yyvsp[(1) - (4)].node), new_hash(p, (yyvsp[(3) - (4)].node))), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1769 "../parse.y"
    {
		      (yyval.node) = cons(0, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1774 "../parse.y"
    {
		      (yyval.num) = p->cmdarg_stack;
		      CMDARG_PUSH(1);
		    ;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1779 "../parse.y"
    {
		      /* CMDARG_POP() */
		      p->cmdarg_stack = (yyvsp[(1) - (2)].num);
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1787 "../parse.y"
    {
		      (yyval.node) = new_block_arg(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1793 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1797 "../parse.y"
    {
		      (yyval.node) = 0;
		    ;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1803 "../parse.y"
    {
		      (yyval.node) = cons((yyvsp[(1) - (1)].node), 0);
		    ;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1807 "../parse.y"
    {
		      (yyval.node) = cons(new_splat(p, (yyvsp[(2) - (2)].node)), 0);
		    ;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1811 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1815 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (4)].node), new_splat(p, (yyvsp[(4) - (4)].node)));
		    ;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1821 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1825 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (4)].node), new_splat(p, (yyvsp[(4) - (4)].node)));
		    ;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1829 "../parse.y"
    {
		      (yyval.node) = list1(new_splat(p, (yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1841 "../parse.y"
    {
		      (yyval.node) = new_fcall(p, (yyvsp[(1) - (1)].id), 0);
		    ;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1847 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1850 "../parse.y"
    {p->lstate = EXPR_ENDARG;;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1851 "../parse.y"
    {
		      yywarning(p, "(...) interpreted as grouped expression");
		      (yyval.node) = (yyvsp[(2) - (4)].node);
		    ;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1856 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1860 "../parse.y"
    {
		      (yyval.node) = new_colon2(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id));
		    ;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1864 "../parse.y"
    {
		      (yyval.node) = new_colon3(p, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1868 "../parse.y"
    {
		      (yyval.node) = new_array(p, (yyvsp[(2) - (3)].node));
		    ;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1872 "../parse.y"
    {
		      (yyval.node) = new_hash(p, (yyvsp[(2) - (3)].node));
		    ;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1876 "../parse.y"
    {
		      (yyval.node) = new_return(p, 0);
		    ;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1880 "../parse.y"
    {
		      (yyval.node) = new_yield(p, (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1884 "../parse.y"
    {
		      (yyval.node) = new_yield(p, 0);
		    ;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1888 "../parse.y"
    {
		      (yyval.node) = new_yield(p, 0);
		    ;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1892 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, cond((yyvsp[(3) - (4)].node)), "!");
		    ;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1896 "../parse.y"
    {
		      (yyval.node) = call_uni_op(p, new_nil(p), "!");
		    ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1900 "../parse.y"
    {
		      (yyval.node) = new_fcall(p, (yyvsp[(1) - (2)].id), cons(0, (yyvsp[(2) - (2)].node)));
		    ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1905 "../parse.y"
    {
		      call_with_block(p, (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1910 "../parse.y"
    {
		      local_nest(p);
		      (yyval.num) = p->lpar_beg;
		      p->lpar_beg = ++p->paren_nest;
		    ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1917 "../parse.y"
    {
		      p->lpar_beg = (yyvsp[(2) - (4)].num);
		      (yyval.node) = new_lambda(p, (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
		      local_unnest(p);
		    ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1926 "../parse.y"
    {
		      (yyval.node) = new_if(p, cond((yyvsp[(2) - (6)].node)), (yyvsp[(4) - (6)].node), (yyvsp[(5) - (6)].node));
		    ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1933 "../parse.y"
    {
		      (yyval.node) = new_unless(p, cond((yyvsp[(2) - (6)].node)), (yyvsp[(4) - (6)].node), (yyvsp[(5) - (6)].node));
		    ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1936 "../parse.y"
    {COND_PUSH(1);;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1936 "../parse.y"
    {COND_POP();;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1939 "../parse.y"
    {
		      (yyval.node) = new_while(p, cond((yyvsp[(3) - (7)].node)), (yyvsp[(6) - (7)].node));
		    ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1942 "../parse.y"
    {COND_PUSH(1);;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1942 "../parse.y"
    {COND_POP();;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1945 "../parse.y"
    {
		      (yyval.node) = new_until(p, cond((yyvsp[(3) - (7)].node)), (yyvsp[(6) - (7)].node));
		    ;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1951 "../parse.y"
    {
		      (yyval.node) = new_case(p, (yyvsp[(2) - (5)].node), (yyvsp[(4) - (5)].node));
		    ;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1955 "../parse.y"
    {
		      (yyval.node) = new_case(p, 0, (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1959 "../parse.y"
    {COND_PUSH(1);;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 1961 "../parse.y"
    {COND_POP();;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 1964 "../parse.y"
    {
		      (yyval.node) = new_for(p, (yyvsp[(2) - (9)].node), (yyvsp[(5) - (9)].node), (yyvsp[(8) - (9)].node));
		    ;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 1968 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "class definition in method body");
		      (yyval.node) = local_switch(p);
		    ;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 1975 "../parse.y"
    {
		      (yyval.node) = new_class(p, (yyvsp[(2) - (6)].node), (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node));
		      local_resume(p, (yyvsp[(4) - (6)].node));
		    ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 1980 "../parse.y"
    {
		      (yyval.num) = p->in_def;
		      p->in_def = 0;
		    ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 1985 "../parse.y"
    {
		      (yyval.node) = cons(local_switch(p), (node*)p->in_single);
		      p->in_single = 0;
		    ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 1991 "../parse.y"
    {
		      (yyval.node) = new_sclass(p, (yyvsp[(3) - (8)].node), (yyvsp[(7) - (8)].node));
		      local_resume(p, (yyvsp[(6) - (8)].node)->car);
		      p->in_def = (yyvsp[(4) - (8)].num);
		      p->in_single = (int)(yyvsp[(6) - (8)].node)->cdr;
		    ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 1998 "../parse.y"
    {
		      if (p->in_def || p->in_single)
			yyerror(p, "module definition in method body");
		      (yyval.node) = local_switch(p);
		    ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 2005 "../parse.y"
    {
		      (yyval.node) = new_module(p, (yyvsp[(2) - (5)].node), (yyvsp[(4) - (5)].node));
		      local_resume(p, (yyvsp[(3) - (5)].node));
		    ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 2010 "../parse.y"
    {
		      p->in_def++;
		      (yyval.node) = local_switch(p);
		    ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 2017 "../parse.y"
    {
		      (yyval.node) = new_def(p, (yyvsp[(2) - (6)].id), (yyvsp[(4) - (6)].node), (yyvsp[(5) - (6)].node));
		      local_resume(p, (yyvsp[(3) - (6)].node));
		      p->in_def--;
		    ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 2022 "../parse.y"
    {p->lstate = EXPR_FNAME;;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 2023 "../parse.y"
    {
		      p->in_single++;
		      p->lstate = EXPR_ENDFN; /* force for args */
		      (yyval.node) = local_switch(p);
		    ;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 2031 "../parse.y"
    {
		      (yyval.node) = new_sdef(p, (yyvsp[(2) - (9)].node), (yyvsp[(5) - (9)].id), (yyvsp[(7) - (9)].node), (yyvsp[(8) - (9)].node));
		      local_resume(p, (yyvsp[(6) - (9)].node));
		      p->in_single--;
		    ;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 2037 "../parse.y"
    {
		      (yyval.node) = new_break(p, 0);
		    ;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 2041 "../parse.y"
    {
		      (yyval.node) = new_next(p, 0);
		    ;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 2045 "../parse.y"
    {
		      (yyval.node) = new_redo(p);
		    ;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 2049 "../parse.y"
    {
		      (yyval.node) = new_retry(p);
		    ;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 2055 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		      if (!(yyval.node)) (yyval.node) = new_nil(p);
		    ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 2074 "../parse.y"
    {
		      (yyval.node) = new_if(p, cond((yyvsp[(2) - (5)].node)), (yyvsp[(4) - (5)].node), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 2081 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 2087 "../parse.y"
    {
		      (yyval.node) = list1(list1((yyvsp[(1) - (1)].node)));
		    ;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 2094 "../parse.y"
    {
		      (yyval.node) = new_arg(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 2098 "../parse.y"
    {
		      (yyval.node) = new_masgn(p, (yyvsp[(2) - (3)].node), 0);
		    ;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 2104 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 2108 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 2114 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (1)].node),0,0);
		    ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 2118 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (4)].node), new_arg(p, (yyvsp[(4) - (4)].id)), 0);
		    ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 2122 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (6)].node), new_arg(p, (yyvsp[(4) - (6)].id)), (yyvsp[(6) - (6)].node));
		    ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 2126 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (3)].node), (node*)-1, 0);
		    ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 2130 "../parse.y"
    {
		      (yyval.node) = list3((yyvsp[(1) - (5)].node), (node*)-1, (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 2134 "../parse.y"
    {
		      (yyval.node) = list3(0, new_arg(p, (yyvsp[(2) - (2)].id)), 0);
		    ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 2138 "../parse.y"
    {
		      (yyval.node) = list3(0, new_arg(p, (yyvsp[(2) - (4)].id)), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 2142 "../parse.y"
    {
		      (yyval.node) = list3(0, (node*)-1, 0);
		    ;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 2146 "../parse.y"
    {
		      (yyval.node) = list3(0, (node*)-1, (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 2152 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].id), 0, (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 2156 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (8)].node), (yyvsp[(3) - (8)].node), (yyvsp[(5) - (8)].id), (yyvsp[(7) - (8)].node), (yyvsp[(8) - (8)].id));
		    ;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 2160 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].node), 0, 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 2164 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node), 0, (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 2168 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (4)].node), 0, (yyvsp[(3) - (4)].id), 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 2172 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (2)].node), 0, 1, 0, 0);
		    ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 2176 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), 0, (yyvsp[(3) - (6)].id), (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 2180 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (2)].node), 0, 0, 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 2184 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 2188 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].id), (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 2192 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (2)].node), 0, 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 2196 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (4)].node), 0, (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 2200 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, (yyvsp[(1) - (2)].id), 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 2204 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, (yyvsp[(1) - (4)].id), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 2208 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, 0, 0, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 358:

/* Line 1464 of yacc.c  */
#line 2215 "../parse.y"
    {
		      p->cmd_start = TRUE;
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		    ;}
    break;

  case 359:

/* Line 1464 of yacc.c  */
#line 2222 "../parse.y"
    {
		      local_add_f(p, 0);
		      (yyval.node) = 0;
		    ;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 2227 "../parse.y"
    {
		      local_add_f(p, 0);
		      (yyval.node) = 0;
		    ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 2232 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (4)].node);
		    ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 2240 "../parse.y"
    {
		      (yyval.node) = 0;
		    ;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 2250 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(1) - (1)].id));
		      new_bv(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 2258 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (4)].node);
		    ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 2262 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		    ;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 2268 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 2272 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		    ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 2278 "../parse.y"
    {
		      local_nest(p);
		    ;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 2284 "../parse.y"
    {
		      (yyval.node) = new_block(p,(yyvsp[(3) - (5)].node),(yyvsp[(4) - (5)].node));
		      local_unnest(p);
		    ;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 2291 "../parse.y"
    {
		      if ((yyvsp[(1) - (2)].node)->car == (node*)NODE_YIELD) {
			yyerror(p, "block given to yield");
		      }
		      else {
		        call_with_block(p, (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
		      }
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 2301 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 2305 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 2311 "../parse.y"
    {
		      (yyval.node) = new_fcall(p, (yyvsp[(1) - (2)].id), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 2315 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 2319 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), (yyvsp[(4) - (4)].node));
		    ;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 2323 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].id), 0);
		    ;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 2327 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), intern("call"), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 2331 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (3)].node), intern("call"), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 2335 "../parse.y"
    {
		      (yyval.node) = new_super(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 2339 "../parse.y"
    {
		      (yyval.node) = new_zsuper(p);
		    ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 2343 "../parse.y"
    {
		      (yyval.node) = new_call(p, (yyvsp[(1) - (4)].node), intern("[]"), (yyvsp[(3) - (4)].node));
		    ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 2349 "../parse.y"
    {
		      local_nest(p);
		    ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 2354 "../parse.y"
    {
		      (yyval.node) = new_block(p,(yyvsp[(3) - (5)].node),(yyvsp[(4) - (5)].node));
		      local_unnest(p);
		    ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 2359 "../parse.y"
    {
		      local_nest(p);
		    ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 2364 "../parse.y"
    {
		      (yyval.node) = new_block(p,(yyvsp[(3) - (5)].node),(yyvsp[(4) - (5)].node));
		      local_unnest(p);
		    ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 2373 "../parse.y"
    {
		      (yyval.node) = cons(cons((yyvsp[(2) - (5)].node), (yyvsp[(4) - (5)].node)), (yyvsp[(5) - (5)].node));
		    ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 2379 "../parse.y"
    {
		      if ((yyvsp[(1) - (1)].node)) {
			(yyval.node) = cons(cons(0, (yyvsp[(1) - (1)].node)), 0);
		      }
		      else {
			(yyval.node) = 0;
		      }
		    ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 2393 "../parse.y"
    {
		      (yyval.node) = list1(list3((yyvsp[(2) - (6)].node), (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node)));
		      if ((yyvsp[(6) - (6)].node)) (yyval.node) = append((yyval.node), (yyvsp[(6) - (6)].node));
		    ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 2401 "../parse.y"
    {
			(yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 2409 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 2416 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (2)].node);
		    ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 2424 "../parse.y"
    {
		      (yyval.node) = new_sym(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 2440 "../parse.y"
    {
		      p->lstate = EXPR_END;
		      (yyval.id) = (yyvsp[(2) - (2)].id);
		    ;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 2455 "../parse.y"
    {
		      (yyval.node) = negate_lit(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 2459 "../parse.y"
    {
		      (yyval.node) = negate_lit(p, (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 2465 "../parse.y"
    {
		      (yyval.node) = new_lvar(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 2469 "../parse.y"
    {
		      (yyval.node) = new_ivar(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 2473 "../parse.y"
    {
		      (yyval.node) = new_gvar(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 2477 "../parse.y"
    {
		      (yyval.node) = new_cvar(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 2481 "../parse.y"
    {
		      (yyval.node) = new_const(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 2487 "../parse.y"
    {
		      assignable(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 2493 "../parse.y"
    {
		      (yyval.node) = var_reference(p, (yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 2497 "../parse.y"
    {
		      (yyval.node) = new_nil(p);
		    ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 2501 "../parse.y"
    {
		      (yyval.node) = new_self(p);
   		    ;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 2505 "../parse.y"
    {
		      (yyval.node) = new_true(p);
   		    ;}
    break;

  case 427:

/* Line 1464 of yacc.c  */
#line 2509 "../parse.y"
    {
		      (yyval.node) = new_false(p);
   		    ;}
    break;

  case 428:

/* Line 1464 of yacc.c  */
#line 2513 "../parse.y"
    {
		      if (!p->filename) {
			p->filename = "(null)";
		      }
		      (yyval.node) = new_str(p, p->filename, strlen(p->filename));
		    ;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 2520 "../parse.y"
    {
		      char buf[16];

		      snprintf(buf, 16, "%d", p->lineno);
		      (yyval.node) = new_int(p, buf, 10);
		    ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 2533 "../parse.y"
    {
		      (yyval.node) = 0;
		    ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 2537 "../parse.y"
    {
		      p->lstate = EXPR_BEG;
		    ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 2541 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(3) - (4)].node);
		    ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 2545 "../parse.y"
    {
		      yyerrok;
		      (yyval.node) = 0;
		    ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 2552 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(2) - (3)].node);
		      p->lstate = EXPR_BEG;
		      p->cmd_start = TRUE;
		    ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 2558 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 2564 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].id), 0, (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 2568 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (8)].node), (yyvsp[(3) - (8)].node), (yyvsp[(5) - (8)].id), (yyvsp[(7) - (8)].node), (yyvsp[(8) - (8)].id));
		    ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 2572 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].node), 0, 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 2576 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node), 0, (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 2580 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (4)].node), 0, (yyvsp[(3) - (4)].id), 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 2584 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (6)].node), 0, (yyvsp[(3) - (6)].id), (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 2588 "../parse.y"
    {
		      (yyval.node) = new_args(p, (yyvsp[(1) - (2)].node), 0, 0, 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 2592 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].id), 0, (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 2596 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].id), (yyvsp[(5) - (6)].node), (yyvsp[(6) - (6)].id));
		    ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 2600 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (2)].node), 0, 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 2604 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, (yyvsp[(1) - (4)].node), 0, (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 2608 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, (yyvsp[(1) - (2)].id), 0, (yyvsp[(2) - (2)].id));
		    ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 2612 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, (yyvsp[(1) - (4)].id), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].id));
		    ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 2616 "../parse.y"
    {
		      (yyval.node) = new_args(p, 0, 0, 0, 0, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 2620 "../parse.y"
    {
		      local_add_f(p, 0);
		      (yyval.node) = new_args(p, 0, 0, 0, 0, 0);
		    ;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 2627 "../parse.y"
    {
		      yyerror(p, "formal argument cannot be a constant");
		      (yyval.node) = 0;
		    ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 2632 "../parse.y"
    {
		      yyerror(p, "formal argument cannot be an instance variable");
		      (yyval.node) = 0;
		    ;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 2637 "../parse.y"
    {
		      yyerror(p, "formal argument cannot be a global variable");
		      (yyval.node) = 0;
		    ;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 2642 "../parse.y"
    {
		      yyerror(p, "formal argument cannot be a class variable");
		      (yyval.node) = 0;
		    ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 2649 "../parse.y"
    {
		      (yyval.id) = 0;
		    ;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 2653 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(1) - (1)].id));
		      (yyval.id) = (yyvsp[(1) - (1)].id);
		    ;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 2660 "../parse.y"
    {
		      (yyval.node) = new_arg(p, (yyvsp[(1) - (1)].id));
		    ;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 2664 "../parse.y"
    {
		      (yyval.node) = new_masgn(p, (yyvsp[(2) - (3)].node), 0);
		    ;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 2670 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 2674 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 2680 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(1) - (3)].id));
		      (yyval.node) = cons((node*)(yyvsp[(1) - (3)].id), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 2687 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(1) - (3)].id));
		      (yyval.node) = cons((node*)(yyvsp[(1) - (3)].id), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 2694 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 2698 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 2704 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 2708 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 2718 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(2) - (2)].id));
		      (yyval.id) = (yyvsp[(2) - (2)].id);
		    ;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 2723 "../parse.y"
    {
		      (yyval.id) = 0;
		    ;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 2733 "../parse.y"
    {
		      local_add_f(p, (yyvsp[(2) - (2)].id));
		      (yyval.id) = (yyvsp[(2) - (2)].id);
		    ;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 2740 "../parse.y"
    {
		      (yyval.id) = (yyvsp[(2) - (2)].id);
		    ;}
    break;

  case 477:

/* Line 1464 of yacc.c  */
#line 2744 "../parse.y"
    {
		      local_add_f(p, 0);
		      (yyval.id) = 0;
		    ;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 2751 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (1)].node);
		      if (!(yyval.node)) (yyval.node) = new_nil(p);
		    ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 2755 "../parse.y"
    {p->lstate = EXPR_BEG;;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 2756 "../parse.y"
    {
		      if ((yyvsp[(3) - (4)].node) == 0) {
			yyerror(p, "can't define singleton method for ().");
		      }
		      else {
			switch ((enum node_type)(yyvsp[(3) - (4)].node)->car) {
			case NODE_STR:
			case NODE_DSTR:
			case NODE_XSTR:
			case NODE_DXSTR:
			case NODE_DREGX:
			case NODE_MATCH:
			case NODE_FLOAT:
			case NODE_ARRAY:
			  yyerror(p, "can't define singleton method for literals");
			default:
			  break;
			}
		      }
		      (yyval.node) = (yyvsp[(3) - (4)].node);
		    ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 2781 "../parse.y"
    {
		      (yyval.node) = (yyvsp[(1) - (2)].node);
		    ;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 2787 "../parse.y"
    {
		      (yyval.node) = list1((yyvsp[(1) - (1)].node));
		    ;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 2791 "../parse.y"
    {
		      (yyval.node) = append((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 2797 "../parse.y"
    {
		      (yyval.node) = cons((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
		    ;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2801 "../parse.y"
    {
		      (yyval.node) = cons(new_sym(p, (yyvsp[(1) - (2)].id)), (yyvsp[(2) - (2)].node));
		    ;}
    break;

  case 508:

/* Line 1464 of yacc.c  */
#line 2845 "../parse.y"
    {yyerrok;;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 2850 "../parse.y"
    {yyerrok;;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 2854 "../parse.y"
    {
		      (yyval.node) = 0;
		    ;}
    break;



/* Line 1464 of yacc.c  */
#line 8452 "../y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (p, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (p, yymsg);
	  }
	else
	  {
	    yyerror (p, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, p);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, p);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (p, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, p);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, p);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2858 "../parse.y"

#define yylval  (*((YYSTYPE*)(p->ylval)))

static void
yyerror(parser_state *p, const char *s)
{
  fputs(s, stderr);
  fputs("\n", stderr);
  p->nerr++;
}

static void
yyerror_i(parser_state *p, const char *fmt, int i)
{
  char buf[256];

  snprintf(buf, 256, fmt, i);
  yyerror(p, buf);
}

static void
yywarn(parser_state *p, const char *s)
{
  fputs(s, stderr);
}

static void
yywarning(parser_state *p, const char *s)
{
  fputs(s, stderr);
  fputs("\n", stderr);
}

static void
yywarning_s(parser_state *p, const char *fmt, const char *s)
{
  char buf[256];

  snprintf(buf, 256, fmt, s);
  yywarning(p, buf);
}

static void
backref_error(parser_state *p, node *n)
{
  switch ((int)n->car) {
  case NODE_NTH_REF:
    yyerror_i(p, "can't set variable $%d", (int)n->cdr);
    break;
  case NODE_BACK_REF:
    yyerror_i(p, "can't set variable $%c", (int)n->cdr);
    break;
  }
}

static int peeks(parser_state *p, const char *s);
static int skips(parser_state *p, const char *s);

static inline int
nextc(parser_state *p)
{
  int c;

  if (p->pb) {
    node *tmp;

    c = (int)p->pb->car;
    tmp = p->pb;
    p->pb = p->pb->cdr;
    cons_free(tmp);
  }
  else if (p->f) {
    if (feof(p->f)) return -1;
    c = fgetc(p->f);
    if (c == EOF) return -1;
  }
  else if (!p->s || p->s >= p->send) {
    return -1;
  }
  else {
    c = *p->s++;
  }
  if (c == '\n') {
    p->lineno++;
    p->column = 0;
    // must understand heredoc
  }
  else {
    p->column++;
  }
  return c;
}

static void
pushback(parser_state *p, int c)
{
  if (c < 0) return;
  p->column--;
  p->pb = cons((node*)c, p->pb);
}

static void
skip(parser_state *p, char term)
{
  int c;

  while ((c = nextc(p)) != term)
    ;
}

static int
peek_n(parser_state *p, int c, int n)
{
  node *list = 0;
  int c0;

  n++;				/* must read 1 char */
  while (n--) {
    c0 = nextc(p);
    if (c0 < 0) return FALSE;
    list = append(list, (node*)c0);
  }
  if (p->pb) {
    p->pb = append(p->pb, (node*)list);
  }
  else {
    p->pb = list;
  }
  if (c0 == c) return TRUE;
  return FALSE;
}
#define peek(p,c) peek_n((p), (c), 0)

static int
peeks(parser_state *p, const char *s)
{
  int len = strlen(s);

  if (p->f) {
    int n = 0;
    while (*s) {
      if (!peek_n(p, *s++, n++)) return FALSE;
    }
    return TRUE;
  }
  else if (p->s && p->s + len >= p->send) {
    if (memcmp(p->s, s, len) == 0) return TRUE;
  }
  return FALSE;
}

static int
skips(parser_state *p, const char *s)
{
  int c;

  for (;;) {
    // skip until first char
    for (;;) {
      c = nextc(p);
      if (c < 0) return c;
      if (c == *s) break;
    }
    s++;
    if (peeks(p, s)) {
      int len = strlen(s);

      while (len--) {
	nextc(p);
      }
      return TRUE;
    }
  }
  return FALSE;
}

#define STR_FUNC_ESCAPE 0x01
#define STR_FUNC_EXPAND 0x02
#define STR_FUNC_REGEXP 0x04
#define STR_FUNC_QWORDS 0x08
#define STR_FUNC_SYMBOL 0x10
#define STR_FUNC_INDENT 0x20

enum string_type {
    str_squote = (0),
    str_dquote = (STR_FUNC_EXPAND),
    str_xquote = (STR_FUNC_EXPAND),
    str_regexp = (STR_FUNC_REGEXP|STR_FUNC_ESCAPE|STR_FUNC_EXPAND),
    str_sword  = (STR_FUNC_QWORDS),
    str_dword  = (STR_FUNC_QWORDS|STR_FUNC_EXPAND),
    str_ssym   = (STR_FUNC_SYMBOL),
    str_dsym   = (STR_FUNC_SYMBOL|STR_FUNC_EXPAND)
};

static void
newtok(parser_state *p)
{
  p->bidx = 0;
}

static void
tokadd(parser_state *p, int c)
{
  if (p->bidx < 1024) {
    p->buf[p->bidx++] = c;
  }
}

static int
toklast(parser_state *p)
{
  return p->buf[p->bidx-1];
}

static void
tokfix(parser_state *p)
{
  if (p->bidx >= 1024) {
    yyerror(p, "string too long (truncated)");
  }
  p->buf[p->bidx] = '\0';
}

static const char*
tok(parser_state *p)
{
  return p->buf;
}

static int
toklen(parser_state *p)
{
  return p->bidx;
}

#define IS_ARG() (p->lstate == EXPR_ARG || p->lstate == EXPR_CMDARG)
#define IS_END() (p->lstate == EXPR_END || p->lstate == EXPR_ENDARG || p->lstate == EXPR_ENDFN)
#define IS_BEG() (p->lstate == EXPR_BEG || p->lstate == EXPR_MID || p->lstate == EXPR_VALUE || p->lstate == EXPR_CLASS)
#define IS_SPCARG(c) (IS_ARG() && space_seen && !ISSPACE(c))
#define IS_LABEL_POSSIBLE() ((p->lstate == EXPR_BEG && !cmd_state) || IS_ARG())
#define IS_LABEL_SUFFIX(n) (peek_n(p, ':',(n)) && !peek_n(p, ':', (n)+1))

static unsigned long
scan_oct(const char *start, int len, int *retlen)
{
  const char *s = start;
  unsigned long retval = 0;

  while (len-- && *s >= '0' && *s <= '7') {
    retval <<= 3;
    retval |= *s++ - '0';
  }
  *retlen = s - start;
  return retval;
}

static unsigned long
scan_hex(const char *start, int len, int *retlen)
{
  static const char hexdigit[] = "0123456789abcdef0123456789ABCDEF";
  register const char *s = start;
  register unsigned long retval = 0;
  char *tmp;

  while (len-- && *s && (tmp = strchr(hexdigit, *s))) {
    retval <<= 4;
    retval |= (tmp - hexdigit) & 15;
    s++;
  }
  *retlen = s - start;
  return retval;
}

static int
read_escape(parser_state *p)
{
  int c;

  switch (c = nextc(p)) {
  case '\\':	/* Backslash */
    return c;

  case 'n':	/* newline */
    return '\n';

  case 't':	/* horizontal tab */
    return '\t';

  case 'r':	/* carriage-return */
    return '\r';

  case 'f':	/* form-feed */
    return '\f';

  case 'v':	/* vertical tab */
    return '\13';

  case 'a':	/* alarm(bell) */
    return '\007';

  case 'e':	/* escape */
    return 033;

  case '0': case '1': case '2': case '3': /* octal constant */
  case '4': case '5': case '6': case '7':
    {
       char buf[3];
       int i;

       for (i=0; i<3; i++) {
	 buf[i] = nextc(p);
	 if (buf[i] == -1) goto eof;
	 if (buf[i] < '0' || '7' < buf[i]) {
	   pushback(p, buf[i]);
	   break;
	 }
       }
       c = scan_oct(buf, i+1, &i);
    }
    return c;

  case 'x':	/* hex constant */
    {
      char buf[2];
      int i;

      for (i=0; i<2; i++) {
	buf[i] = nextc(p);
	if (buf[i] == -1) goto eof;
	if (!isxdigit(buf[i])) {
	  pushback(p, buf[i]);
	  break;
	}
      }
      c = scan_hex(buf, i+1, &i);
      if (i == 0) {
	yyerror(p, "Invalid escape character syntax");
	return 0;
      }
    }
    return c;

  case 'b':	/* backspace */
    return '\010';

  case 's':	/* space */
    return ' ';

  case 'M':
    if ((c = nextc(p)) != '-') {
      yyerror(p, "Invalid escape character syntax");
      pushback(p, c);
      return '\0';
    }
    if ((c = nextc(p)) == '\\') {
      return read_escape(p) | 0x80;
    }
    else if (c == -1) goto eof;
    else {
      return ((c & 0xff) | 0x80);
    }

  case 'C':
    if ((c = nextc(p)) != '-') {
      yyerror(p, "Invalid escape character syntax");
      pushback(p, c);
      return '\0';
    }
  case 'c':
    if ((c = nextc(p))== '\\') {
      c = read_escape(p);
    }
    else if (c == '?')
      return 0177;
    else if (c == -1) goto eof;
    return c & 0x9f;

  eof:
  case -1:
    yyerror(p, "Invalid escape character syntax");
    return '\0';

  default:
    return c;
  }
}

static int
parse_string(parser_state *p, int func, int term)
{
  int c;

  newtok(p);

  while ((c = nextc(p)) != term) {
    if (c  == -1) {
      yyerror(p, "unterminated string meets end of file");
      return 0;
    }
    else if (c == '\\') {
      c = nextc(p);
      if (c == term) {
	tokadd(p, c);
      }
      else {
	pushback(p, c);
	if (func != '"') tokadd(p, '\\');
	tokadd(p, read_escape(p));
      }
      continue;
    }
    tokadd(p, c);
  }

  tokfix(p);
  p->lstate = EXPR_END;
  yylval.node = new_str(p, tok(p), toklen(p));
  return (func == '`') ? tXSTRING : tSTRING;
}

static int
parse_qstring(parser_state *p, int term)
{
  int c;

  newtok(p);
  while ((c = nextc(p)) != term) {
    if (c  == -1)  {
      yyerror(p, "unterminated string meets end of file");
      return 0;
    }
    if (c == '\\') {
      c = nextc(p);
      switch (c) {
      case '\n':
	continue;

      case '\\':
	c = '\\';
	break;

      case '\'':
	if (term == '\'') {
	  c = '\'';
	  break;
	}
	/* fall through */
      default:
	tokadd(p, '\\');
      }
    }
    tokadd(p, c);
  }

  tokfix(p);
  yylval.node = new_str(p, tok(p), toklen(p));
  p->lstate = EXPR_END;
  return tSTRING;
}

static int
arg_ambiguous(parser_state *p)
{
  yywarning(p, "ambiguous first argument; put parentheses or even spaces");
  return 1;
}

#include "lex.def"

static int
parser_yylex(parser_state *p)
{
  register int c;
  int space_seen = 0;
  int cmd_state;
  enum mrb_lex_state_enum last_state;

  cmd_state = p->cmd_start;
  p->cmd_start = FALSE;
 retry:
  last_state = p->lstate;
  switch (c = nextc(p)) {
  case '\0':		/* NUL */
  case '\004':		/* ^D */
  case '\032':		/* ^Z */
  case -1:		/* end of script. */
    return 0;

    /* white spaces */
  case ' ': case '\t': case '\f': case '\r':
  case '\13': /* '\v' */
    space_seen = 1;
    goto retry;

  case '#':		/* it's a comment */
    skip(p, '\n');
    /* fall through */
  case '\n':
    switch (p->lstate) {
    case EXPR_BEG:
    case EXPR_FNAME:
    case EXPR_DOT:
    case EXPR_CLASS:
    case EXPR_VALUE:
      goto retry;
    default:
      break;
    }
    while ((c = nextc(p))) {
      switch (c) {
      case ' ': case '\t': case '\f': case '\r':
      case '\13': /* '\v' */
	space_seen = 1;
	break;
      case '.':
	if ((c = nextc(p)) != '.') {
	  pushback(p, c);
	  pushback(p, '.');
	  goto retry;
	}
      case -1:			/* EOF */
	goto normal_newline;
      default:
	pushback(p, c);
	goto normal_newline;
      }
    }
  normal_newline:
    p->lstate = EXPR_BEG;
    return '\n';

  case '*':
    if ((c = nextc(p)) == '*') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("**");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      c = tPOW;
    }
    else {
      if (c == '=') {
	yylval.id = intern("*");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      if (IS_SPCARG(c)) {
	yywarning(p, "`*' interpreted as argument prefix");
	c = tSTAR;
      }
      else if (IS_BEG()) {
	c = tSTAR;
      }
      else {
	c = '*';
      }
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    return c;

  case '!':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return '!';
      }
    }
    else {
      p->lstate = EXPR_BEG;
    }
    if (c == '=') {
      return tNEQ;
    }
    if (c == '~') {
      return tNMATCH;
    }
    pushback(p, c);
    return '!';

  case '=':
    if (p->column == 1) {
      if (peeks(p, "begin\n")) {
	skips(p, "\n=end\n");
      }
      goto retry;
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    if ((c = nextc(p)) == '=') {
      if ((c = nextc(p)) == '=') {
	return tEQQ;
      }
      pushback(p, c);
      return tEQ;
    }
    if (c == '~') {
      return tMATCH;
    }
    else if (c == '>') {
      return tASSOC;
    }
    pushback(p, c);
    return '=';

  case '<':
    last_state = p->lstate;
    c = nextc(p);
#if 0
    // no heredoc supported yet
    if (c == '<' &&
	p->lstate != EXPR_DOT &&
	p->lstate != EXPR_CLASS &&
	!IS_END() &&
	(!IS_ARG() || space_seen)) {
      int token = heredoc_identifier();
      if (token) return token;
    }
#endif
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    if (c == '=') {
      if ((c = nextc(p)) == '>') {
	return tCMP;
      }
      pushback(p, c);
      return tLEQ;
    }
    if (c == '<') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("<<");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tLSHFT;
    }
    pushback(p, c);
    return '<';

  case '>':
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    if ((c = nextc(p)) == '=') {
      return tGEQ;
    }
    if (c == '>') {
      if ((c = nextc(p)) == '=') {
	yylval.id = intern(">>");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tRSHFT;
    }
    pushback(p, c);
    return '>';

  case '"':
#if 0
    p->lex_strterm = new_strterm(p, str_dquote, '"', 0);
#else
    return parse_string(p, c,c);
#endif
    return tSTRING_BEG;

  case '`':
    if (p->lstate == EXPR_FNAME) {
      p->lstate = EXPR_ENDFN;
      return c;
    }
    if (p->lstate == EXPR_DOT) {
      if (cmd_state)
	p->lstate = EXPR_CMDARG;
      else
	p->lstate = EXPR_ARG;
      return c;
    }
#if 0
    p->lex_strterm = new_strterm(p, str_xquote, '`', 0);
#else
    return parse_string(p, c,c);
#endif
    return tXSTRING_BEG;

  case '\'':
#if 0
    p->lex_strterm = new_strterm(p, str_squote, '\'', 0);
#else
    return parse_qstring(p, c);
#endif

    return tSTRING_BEG;

  case '?':
    if (IS_END()) {
      p->lstate = EXPR_VALUE;
      return '?';
    }
    c = nextc(p);
    if (c == -1) {
      yyerror(p, "incomplete character syntax");
      return 0;
    }
    if (isspace(c)) {
      if (!IS_ARG()) {
	int c2 = 0;
	switch (c) {
	case ' ':
	  c2 = 's';
	  break;
	case '\n':
	  c2 = 'n';
	  break;
	case '\t':
	  c2 = 't';
	  break;
	case '\v':
	  c2 = 'v';
	  break;
	case '\r':
	  c2 = 'r';
	  break;
	case '\f':
	  c2 = 'f';
	  break;
	}
	if (c2) {
	  char buf[256];
	  snprintf(buf, 256, "invalid character syntax; use ?\\%c", c2);
	  yyerror(p, buf);
	}
      }
    ternary:
      pushback(p, c);
      p->lstate = EXPR_VALUE;
      return '?';
    }
    newtok(p);
    // need support UTF-8 if configured
    if ((isalnum(c) || c == '_')) {
      int c2 = nextc(p);
      pushback(p, c2);
      if ((isalnum(c2) || c2 == '_')) {
	goto ternary;
      }
    }
    if (c == '\\') {
      c = nextc(p);
      if (c == 'u') {
#if 0
	tokadd_utf8(p);
#endif
      }
      else {
	pushback(p, c);
	c = read_escape(p);
	tokadd(p, c);
      }
    }
    else {
      tokadd(p, c);
    }
    tokfix(p);
    yylval.node = new_str(p, tok(p), toklen(p));
    p->lstate = EXPR_END;
    return tCHAR;

  case '&':
    if ((c = nextc(p)) == '&') {
      p->lstate = EXPR_BEG;
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("&&");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tANDOP;
    }
    else if (c == '=') {
      yylval.id = intern("&");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    pushback(p, c);
    if (IS_SPCARG(c)) {
      yywarning(p, "`&' interpreted as argument prefix");
      c = tAMPER;
    }
    else if (IS_BEG()) {
      c = tAMPER;
    }
    else {
      c = '&';
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG;
    }
    return c;

  case '|':
    if ((c = nextc(p)) == '|') {
      p->lstate = EXPR_BEG;
      if ((c = nextc(p)) == '=') {
	yylval.id = intern("||");
	p->lstate = EXPR_BEG;
	return tOP_ASGN;
      }
      pushback(p, c);
      return tOROP;
    }
    if (c == '=') {
      yylval.id = intern("|");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
    }
    else {
      p->lstate = EXPR_BEG;
    }
    pushback(p, c);
    return '|';

  case '+':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return tUPLUS;
      }
      pushback(p, c);
      return '+';
    }
    if (c == '=') {
      yylval.id = intern("+");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (IS_BEG() || (IS_SPCARG(c) && arg_ambiguous(p))) {
      p->lstate = EXPR_BEG;
      pushback(p, c);
      if (c != -1 && ISDIGIT(c)) {
	c = '+';
	goto start_num;
      }
      return tUPLUS;
    }
    p->lstate = EXPR_BEG;
    pushback(p, c);
    return '+';

  case '-':
    c = nextc(p);
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if (c == '@') {
	return tUMINUS;
      }
      pushback(p, c);
      return '-';
    }
    if (c == '=') {
      yylval.id = intern("-");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (c == '>') {
      p->lstate = EXPR_ARG;
      return tLAMBDA;
    }
    if (IS_BEG() || (IS_SPCARG(c) && arg_ambiguous(p))) {
      p->lstate = EXPR_BEG;
      pushback(p, c);
      if (c != -1 && ISDIGIT(c)) {
	return tUMINUS_NUM;
      }
      return tUMINUS;
    }
    p->lstate = EXPR_BEG;
    pushback(p, c);
    return '-';

  case '.':
    p->lstate = EXPR_BEG;
    if ((c = nextc(p)) == '.') {
      if ((c = nextc(p)) == '.') {
	return tDOT3;
      }
      pushback(p, c);
      return tDOT2;
    }
    pushback(p, c);
    if (c != -1 && ISDIGIT(c)) {
      yyerror(p, "no .<digit> floating literal anymore; put 0 before dot");
    }
    p->lstate = EXPR_DOT;
    return '.';

  start_num:
  case '0': case '1': case '2': case '3': case '4':
  case '5': case '6': case '7': case '8': case '9':
    {
      int is_float, seen_point, seen_e, nondigit;
      
      is_float = seen_point = seen_e = nondigit = 0;
      p->lstate = EXPR_END;
      newtok(p);
      if (c == '-' || c == '+') {
	tokadd(p, c);
	c = nextc(p);
      }
      if (c == '0') {
#define no_digits() do {yyerror(p,"numeric literal without digits"); return 0;} while (0)
	int start = toklen(p);
	c = nextc(p);
	if (c == 'x' || c == 'X') {
	  /* hexadecimal */
	  c = nextc(p);
	  if (c != -1 && ISXDIGIT(c)) {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (!ISXDIGIT(c)) break;
	      nondigit = 0;
	      tokadd(p, c);
	    } while ((c = nextc(p)) != -1);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.node = new_int(p, tok(p), 16);
	  return tINTEGER;
	}
	if (c == 'b' || c == 'B') {
	  /* binary */
	  c = nextc(p);
	  if (c == '0' || c == '1') {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (c != '0' && c != '1') break;
	      nondigit = 0;
	      tokadd(p, c);
	    } while ((c = nextc(p)) != -1);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.node = new_int(p, tok(p), 2);
	  return tINTEGER;
	}
	if (c == 'd' || c == 'D') {
	  /* decimal */
	  c = nextc(p);
	  if (c != -1 && ISDIGIT(c)) {
	    do {
	      if (c == '_') {
		if (nondigit) break;
		nondigit = c;
		continue;
	      }
	      if (!ISDIGIT(c)) break;
	      nondigit = 0;
	      tokadd(p, c);
	    } while ((c = nextc(p)) != -1);
	  }
	  pushback(p, c);
	  tokfix(p);
	  if (toklen(p) == start) {
	    no_digits();
	  }
	  else if (nondigit) goto trailing_uc;
	  yylval.node = new_int(p, tok(p), 10);
	  return tINTEGER;
	}
	if (c == '_') {
	  /* 0_0 */
	  goto octal_number;
	}
	if (c == 'o' || c == 'O') {
	  /* prefixed octal */
	  c = nextc(p);
	  if (c == -1 || c == '_' || !ISDIGIT(c)) {
	    no_digits();
	  }
	}
	if (c >= '0' && c <= '7') {
	  /* octal */
	octal_number:
	  do {
	    if (c == '_') {
	      if (nondigit) break;
	      nondigit = c;
	      continue;
	    }
	    if (c < '0' || c > '9') break;
	    if (c > '7') goto invalid_octal;
	    nondigit = 0;
	    tokadd(p, c);
	  } while ((c = nextc(p)) != -1);

	  if (toklen(p) > start) {
	    pushback(p, c);
	    tokfix(p);
	    if (nondigit) goto trailing_uc;
	    yylval.node = new_int(p, tok(p), 8);
	    return tINTEGER;
	  }
	  if (nondigit) {
	    pushback(p, c);
	    goto trailing_uc;
	  }
	}
	if (c > '7' && c <= '9') {
	invalid_octal:
	  yyerror(p, "Invalid octal digit");
	}
	else if (c == '.' || c == 'e' || c == 'E') {
	  tokadd(p, '0');
	}
	else {
	  pushback(p, c);
	  yylval.node = new_int(p, "0", 10);
	  return tINTEGER;
	}
      }

      for (;;) {
	switch (c) {
	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
	  nondigit = 0;
	  tokadd(p, c);
	  break;

	case '.':
	  if (nondigit) goto trailing_uc;
	  if (seen_point || seen_e) {
	    goto decode_num;
	  }
	  else {
	    int c0 = nextc(p);
	    if (c0 == -1 || !ISDIGIT(c0)) {
	      pushback(p, c0);
	      goto decode_num;
	    }
	    c = c0;
	  }
	  tokadd(p, '.');
	  tokadd(p, c);
	  is_float++;
	  seen_point++;
	  nondigit = 0;
	  break;

	case 'e':
	case 'E':
	  if (nondigit) {
	    pushback(p, c);
	    c = nondigit;
	    goto decode_num;
	  }
	  if (seen_e) {
	    goto decode_num;
	  }
	  tokadd(p, c);
	  seen_e++;
	  is_float++;
	  nondigit = c;
	  c = nextc(p);
	  if (c != '-' && c != '+') continue;
	  tokadd(p, c);
	  nondigit = c;
	  break;

	case '_':	/* `_' in number just ignored */
	  if (nondigit) goto decode_num;
	  nondigit = c;
	  break;
	  
	default:
	  goto decode_num;
	}
	c = nextc(p);
      }

    decode_num:
      pushback(p, c);
      if (nondigit) {
      trailing_uc:
	yyerror_i(p, "trailing `%c' in number", nondigit);
      }
      tokfix(p);
      if (is_float) {
	strtod(tok(p), 0);
	if (errno == ERANGE) {
	  yywarning_s(p, "float %s out of range", tok(p));
	  errno = 0;
	}
	yylval.node = new_float(p, tok(p));
	return tFLOAT;
      }
      yylval.node = new_int(p, tok(p), 10);
      return tINTEGER;
    }

  case ')':
  case ']':
    p->paren_nest--;
  case '}':
    COND_LEXPOP();
    CMDARG_LEXPOP();
    if (c == ')')
      p->lstate = EXPR_ENDFN;
    else
      p->lstate = EXPR_ENDARG;
    return c;

  case ':':
    c = nextc(p);
    if (c == ':') {
      if (IS_BEG() || p->lstate == EXPR_CLASS || IS_SPCARG(-1)) {
	p->lstate = EXPR_BEG;
	return tCOLON3;
      }
      p->lstate = EXPR_DOT;
      return tCOLON2;
    }
    if (IS_END() || ISSPACE(c)) {
      pushback(p, c);
      p->lstate = EXPR_BEG;
      return ':';
    }
    switch (c) {
    case '\'':
#if 0
      p->lex_strterm = new_strterm(p, str_ssym, c, 0);
#endif
      break;
    case '"':
#if 0
      p->lex_strterm = new_strterm(p, str_dsym, c, 0);
#endif
      break;
    default:
      pushback(p, c);
      break;
    }
    p->lstate = EXPR_FNAME;
    return tSYMBEG;

  case '/':
    if (IS_BEG()) {
#if 0
      p->lex_strterm = new_strterm(p, str_regexp, '/', 0);
#endif
      return tREGEXP_BEG;
    }
    if ((c = nextc(p)) == '=') {
      yylval.id = intern("/");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    pushback(p, c);
    if (IS_SPCARG(c)) {
      arg_ambiguous(p);
#if 0
      p->lex_strterm = new_strterm(p, str_regexp, '/', 0);
#endif
      return tREGEXP_BEG;
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    return '/';

  case '^':
    if ((c = nextc(p)) == '=') {
      yylval.id = intern("^");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    pushback(p, c);
    return '^';

  case ';':
    p->lstate = EXPR_BEG;
    return ';';
    
  case ',':
    p->lstate = EXPR_BEG;
    return ',';

  case '~':
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      if ((c = nextc(p)) != '@') {
	pushback(p, c);
      }
      p->lstate = EXPR_ARG;
    }
    else {
      p->lstate = EXPR_BEG;
    }
    return '~';

  case '(':
    if (IS_BEG()) {
      c = tLPAREN;
    }
    else if (IS_SPCARG(-1)) {
      c = tLPAREN_ARG;
    }
    p->paren_nest++;
    COND_PUSH(0);
    CMDARG_PUSH(0);
    p->lstate = EXPR_BEG;
    return c;

  case '[':
    p->paren_nest++;
    if (p->lstate == EXPR_FNAME || p->lstate == EXPR_DOT) {
      p->lstate = EXPR_ARG;
      if ((c = nextc(p)) == ']') {
	if ((c = nextc(p)) == '=') {
	  return tASET;
	}
	pushback(p, c);
	return tAREF;
      }
      pushback(p, c);
      return '[';
    }
    else if (IS_BEG()) {
      c = tLBRACK;
    }
    else if (IS_ARG() && space_seen) {
      c = tLBRACK;
    }
    p->lstate = EXPR_BEG;
    COND_PUSH(0);
    CMDARG_PUSH(0);
    return c;

  case '{':
    if (p->lpar_beg && p->lpar_beg == p->paren_nest) {
      p->lstate = EXPR_BEG;
      p->lpar_beg = 0;
      p->paren_nest--;
      COND_PUSH(0);
      CMDARG_PUSH(0);
      return tLAMBEG;
    }
    if (IS_ARG() || p->lstate == EXPR_END || p->lstate == EXPR_ENDFN)
      c = '{';          /* block (primary) */
    else if (p->lstate == EXPR_ENDARG)
      c = tLBRACE_ARG;  /* block (expr) */
    else
      c = tLBRACE;      /* hash */
    COND_PUSH(0);
    CMDARG_PUSH(0);
    p->lstate = EXPR_BEG;
    return c;

  case '\\':
    c = nextc(p);
    if (c == '\n') {
      space_seen = 1;
      goto retry; /* skip \\n */
    }
    pushback(p, c);
    return '\\';

  case '%':
    if (IS_BEG()) {
      int term;
#if 0
      int paren;
#endif

      c = nextc(p);
    quotation:
      if (c == -1 || !ISALNUM(c)) {
	term = c;
	c = 'Q';
      }
      else {
	term = nextc(p);
	if (isalnum(term)) {
	  yyerror(p, "unknown type of %string");
	  return 0;
	}
      }
      if (c == -1 || term == -1) {
	yyerror(p, "unterminated quoted string meets end of file");
	return 0;
      }
#if 0
      paren = term;
#endif
      if (term == '(') term = ')';
      else if (term == '[') term = ']';
      else if (term == '{') term = '}';
      else if (term == '<') term = '>';
#if 0
      else paren = 0;
#endif

      switch (c) {
      case 'Q':
#if 0
	p->lex_strterm = new_strterm(p, str_dquote, term, paren);
#endif
	return tSTRING_BEG;

      case 'q':
#if 0
	p->lex_strterm = new_strterm(p, str_squote, term, paren);
#endif
	return tSTRING_BEG;

      case 'W':
#if 0
	p->lex_strterm = new_strterm(p, str_dword, term, paren);
#endif
	do {c = nextc(p);} while (isspace(c));
	pushback(p, c);
	return tWORDS_BEG;

      case 'w':
#if 0
	p->lex_strterm = new_strterm(p, str_sword, term, paren);
#endif
	do {c = nextc(p);} while (isspace(c));
	pushback(p, c);
	return tQWORDS_BEG;

      case 'x':
#if 0
	p->lex_strterm = new_strterm(p, str_xquote, term, paren);
#endif
	return tXSTRING_BEG;

      case 'r':
#if 0
	p->lex_strterm = new_strterm(p, str_regexp, term, paren);
#endif
	return tREGEXP_BEG;

      case 's':
#if 0
	p->lex_strterm = new_strterm(p, str_ssym, term, paren);
#endif
	p->lstate = EXPR_FNAME;
	return tSYMBEG;

      default:
	yyerror(p, "unknown type of %string");
	return 0;
      }
    }
    if ((c = nextc(p)) == '=') {
      yylval.id = intern("%");
      p->lstate = EXPR_BEG;
      return tOP_ASGN;
    }
    if (IS_SPCARG(c)) {
      goto quotation;
    }
    switch (p->lstate) {
    case EXPR_FNAME: case EXPR_DOT:
      p->lstate = EXPR_ARG; break;
    default:
      p->lstate = EXPR_BEG; break;
    }
    pushback(p, c);
    return '%';

  case '$':
    p->lstate = EXPR_END;
    newtok(p);
    c = nextc(p);
    switch (c) {
    case '_':		     /* $_: last read line string */
      c = nextc(p);
      pushback(p, c);
      c = '_';
      /* fall through */
    case '~':		   /* $~: match-data */
    case '*':		   /* $*: argv */
    case '$':		   /* $$: pid */
    case '?':		   /* $?: last status */
    case '!':		   /* $!: error string */
    case '@':		   /* $@: error position */
    case '/':		   /* $/: input record separator */
    case '\\':		   /* $\: output record separator */
    case ';':		   /* $;: field separator */
    case ',':		   /* $,: output field separator */
    case '.':		   /* $.: last read line number */
    case '=':		   /* $=: ignorecase */
    case ':':		   /* $:: load path */
    case '<':		   /* $<: reading filename */
    case '>':		   /* $>: default output handle */
    case '\"':		   /* $": already loaded files */
      tokadd(p, '$');
      tokadd(p, c);
      tokfix(p);
      yylval.id = intern(tok(p));
      return tGVAR;

    case '-':
      tokadd(p, '$');
      tokadd(p, c);
      c = nextc(p);
      pushback(p, c);
    gvar:
      tokfix(p);
      yylval.id = intern(tok(p));
      return tGVAR;

    case '&':		/* $&: last match */
    case '`':		/* $`: string before last match */
    case '\'':		/* $': string after last match */
    case '+':		/* $+: string matches last paren. */
      if (last_state == EXPR_FNAME) {
	tokadd(p, '$');
	tokadd(p, c);
	goto gvar;
      }
      yylval.node = new_back_ref(p, c);
      return tBACK_REF;

    case '1': case '2': case '3':
    case '4': case '5': case '6':
    case '7': case '8': case '9':
      tokadd(p, '$');
      do {
	tokadd(p, c);
	c = nextc(p);
      } while (c != -1 && isdigit(c));
      pushback(p, c);
      if (last_state == EXPR_FNAME) goto gvar;
      tokfix(p);
      yylval.node = new_nth_ref(p, atoi(tok(p)+1)); 
      return tNTH_REF;

    default:
      if (!identchar(c)) {
	pushback(p,  c);
	return '$';
      }
    case '0':
      tokadd(p, '$');
    }
    break;

  case '@':
    c = nextc(p);
    newtok(p);
    tokadd(p, '@');
    if (c == '@') {
      tokadd(p, '@');
      c = nextc(p);
    }
    if (c != -1 && isdigit(c)) {
      if (p->bidx == 1) {
	yyerror_i(p, "`@%c' is not allowed as an instance variable name", c);
      }
      else {
	yyerror_i(p, "`@@%c' is not allowed as a class variable name", c);
      }
      return 0;
    }
    if (!identchar(c)) {
      pushback(p, c);
      return '@';
    }
    break;

  case '_':
    newtok(p);
    break;

  default:
    if (!identchar(c)) {
      yyerror_i(p,  "Invalid char `\\x%02X' in expression", c);
      goto retry;
    }

    newtok(p);
    break;
  }

  do {
    tokadd(p, c);
    c = nextc(p);
    if (c < 0) break;
  } while (identchar(c));

  switch (tok(p)[0]) {
  case '@': case '$':
    pushback(p, c);
    break;
  default:
    if ((c == '!' || c == '?') && !peek(p, '=')) {
      tokadd(p, c);
    }
    else {
      pushback(p, c);
    }
  }
  tokfix(p);
  {
    int result = 0;

    last_state = p->lstate;
    switch (tok(p)[0]) {
    case '$':
      p->lstate = EXPR_END;
      result = tGVAR;
      break;
    case '@':
      p->lstate = EXPR_END;
      if (tok(p)[1] == '@')
	result = tCVAR;
      else
	result = tIVAR;
      break;

    default:
      if (toklast(p) == '!' || toklast(p) == '?') {
	result = tFID;
      }
      else {
	if (p->lstate == EXPR_FNAME) {
	  if ((c = nextc(p)) == '=' && !peek(p, '~') && !peek(p, '>') &&
	      (!peek(p, '=') || (peek_n(p, '>', 1)))) {
	    result = tIDENTIFIER;
	    tokadd(p, c);
	    tokfix(p);
	  }
	  else {
	    pushback(p, c);
	  }
	}
	if (result == 0 && isupper(tok(p)[0])) {
	  result = tCONSTANT;
	}
	else {
	  result = tIDENTIFIER;
	}
      }

      if (IS_LABEL_POSSIBLE()) {
	if (IS_LABEL_SUFFIX(0)) {
	  p->lstate = EXPR_BEG;
	  nextc(p);
	  tokfix(p);
	  yylval.id = intern(tok(p));
	  return tLABEL;
	}
      }
      if (p->lstate != EXPR_DOT) {
	const struct kwtable *kw;

	/* See if it is a reserved word.  */
	kw = mrb_reserved_word(tok(p), toklen(p));
	if (kw) {
	  enum mrb_lex_state_enum state = p->lstate;
	  p->lstate = kw->state;
	  if (state == EXPR_FNAME) {
	    yylval.id = intern(kw->name);
	    return kw->id[0];
	  }
	  if (kw->id[0] == keyword_do) {
	    if (p->lpar_beg && p->lpar_beg == p->paren_nest) {
	      p->lpar_beg = 0;
	      p->paren_nest--;
	      return keyword_do_LAMBDA;
	    }
	    if (COND_P()) return keyword_do_cond;
	    if (CMDARG_P() && state != EXPR_CMDARG)
	      return keyword_do_block;
	    if (state == EXPR_ENDARG || state == EXPR_BEG)
	      return keyword_do_block;
	    return keyword_do;
	  }
	  if (state == EXPR_BEG || state == EXPR_VALUE)
	    return kw->id[0];
	  else {
	    if (kw->id[0] != kw->id[1])
	      p->lstate = EXPR_BEG;
	    return kw->id[1];
	  }
	}
      }

      if (IS_BEG() ||
	  p->lstate == EXPR_DOT ||
	  IS_ARG()) {
	if (cmd_state) {
	  p->lstate = EXPR_CMDARG;
	}
	else {
	  p->lstate = EXPR_ARG;
	}
      }
      else if (p->lstate == EXPR_FNAME) {
	p->lstate = EXPR_ENDFN;
      }
      else {
	p->lstate = EXPR_END;
      }
    }
    {
      mrb_sym ident = intern(tok(p));

      yylval.id = ident;
#if 0
      if (last_state != EXPR_DOT && islower(tok(p)[0]) && lvar_defined(ident)) {
	p->lstate = EXPR_END;
      }
#endif
    }
    return result;
  }
}

static int
yylex(void *lval, parser_state *p)
{
    int t;

    p->ylval = lval;
    t = parser_yylex(p);

    return t;
}

static void
start_parser(parser_state *p)
{
  node *tree;

  if (setjmp(p->jmp) != 0) {
    yyerror(p, "memory allocation error");
    p->nerr++;
    p->tree = p->begin_tree = 0;
    return;
  }
  yyparse(p);
  tree = p->tree;
  if (!tree) {
    if (p->begin_tree) {
      tree = p->begin_tree;
    }
    else {
      tree = new_nil(p);
    }
  }
  else if (p->begin_tree) {
    tree = new_begin(p, p->begin_tree);
    append(tree, p->tree);
  }
}

static parser_state*
parser_new(mrb_state *mrb)
{
  mrb_pool *pool;
  parser_state *p;

  pool = mrb_pool_open(mrb);
  if (!pool) return 0;
  p = mrb_pool_alloc(pool, sizeof(parser_state));
  if (!p) return 0;

  memset(p, 0, sizeof(parser_state));
  p->mrb = mrb;
  p->pool = pool;
  p->in_def = p->in_single = 0;

  p->pb = 0;
  p->cells = 0;
  p->bidx = 0;
  p->cmd_start = TRUE;
  p->in_def = p->in_single = FALSE;

  p->filename = 0;
  p->lineno = 1;
  p->column = 0;
#if defined(PARSER_TEST) || defined(PARSER_DEBUG)
  yydebug = 1;
#endif

  return p;
}

parser_state*
mrb_parse_file(mrb_state *mrb, FILE *f)
{
  parser_state *p;
 
  p = parser_new(mrb);
  if (!p) return 0;
  p->s = p->send = NULL;
  p->f = f;

  start_parser(p);
  return p;
}

parser_state*
mrb_parse_nstring(mrb_state *mrb, char *s, size_t len)
{
  parser_state *p;

  p = parser_new(mrb);
  if (!p) return 0;
  p->s = s;
  p->send = s + len;
  p->f = NULL;

  start_parser(p);
  return p;
}

parser_state*
mrb_parse_string(mrb_state *mrb, char *s)
{
  return mrb_parse_nstring(mrb, s, strlen(s));
}

#define PARSER_DUMP

void parser_dump(mrb_state *mrb, node *tree, int offset);
int mrb_generate_code(mrb_state*, mrb_ast_node*);

int
mrb_compile_file(mrb_state * mrb, FILE *f)
{
  parser_state *p;
  int n;

  p = mrb_parse_file(mrb, f);
  if (!p) return -1;
  if (!p->tree) return -1;
  if (p->nerr) return -1;
#ifdef PARSER_DUMP
  parser_dump(mrb, p->tree, 0);
#endif
  n = mrb_generate_code(mrb, p->tree);
  mrb_pool_close(p->pool);

  return n;
}

const char*
mrb_parser_filename(parser_state *p, const char *s)
{
  if (s) {
    p->filename = strdup(s);
  }
  return p->filename;
}

int
mrb_parser_lineno(struct mrb_parser_state *p, int n)
{
  if (n <= 0) {
    return p->lineno;
  }
  return p->lineno = n;
}

int
mrb_compile_nstring(mrb_state *mrb, char *s, size_t len)
{
  parser_state *p;
  int n;

  p = mrb_parse_nstring(mrb, s, len);
  if (!p) return -1;
  if (!p->tree) return -1;
  if (p->nerr) return -1;
#ifdef PARSER_DUMP
  parser_dump(mrb, p->tree, 0);
#endif
  n = mrb_generate_code(mrb, p->tree);
  mrb_pool_close(p->pool);

  return n;
}

int
mrb_compile_string(mrb_state *mrb, char *s)
{
  return mrb_compile_nstring(mrb, s, strlen(s));
}

static void
dump_prefix(int offset)
{
  while (offset--) {
    putc(' ', stdout);
    putc(' ', stdout);
  }
}

static void
dump_recur(mrb_state *mrb, node *tree, int offset)
{
  while (tree) {
    parser_dump(mrb, tree->car, offset);
    tree = tree->cdr;
  }
}

void
parser_dump(mrb_state *mrb, node *tree, int offset)
{
  int n;

  if (!tree) return;
 again:
  dump_prefix(offset);
  n = (int)tree->car;
  tree = tree->cdr;
  switch (n) {
  case NODE_BEGIN:
    printf("NODE_BEGIN:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_RESCUE:
    printf("NODE_RESCUE:\n");
    if (tree->car) {
      dump_prefix(offset+1);
      printf("body:\n");
      parser_dump(mrb, tree->car, offset+2);
    }
    tree = tree->cdr;
    if (tree->car) {
      node *n2 = tree->car;

      dump_prefix(offset+1);
      printf("rescue:\n");
      while (n2) {
	node *n3 = n2->car;
	if (n3->car) {
	  dump_prefix(offset+2);
	  printf("handle classes:\n");
	  dump_recur(mrb, n3->car, offset+3);
	}
	if (n3->cdr->car) {
	  dump_prefix(offset+2);
	  printf("exc_var:\n");
	  parser_dump(mrb, n3->cdr->car, offset+3);
	}
	if (n3->cdr->cdr->car) {
	  dump_prefix(offset+2);
	  printf("rescue body:\n");
	  parser_dump(mrb, n3->cdr->cdr->car, offset+3);
	}
	n2 = n2->cdr;
      }
    }
    tree = tree->cdr;
    if (tree->car) {
      dump_prefix(offset+1);
      printf("else:\n");
      parser_dump(mrb, tree->car, offset+2);
    }
    break;

  case NODE_ENSURE:
    printf("NODE_ENSURE:\n");
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("ensure:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_LAMBDA:
    printf("NODE_BLOCK:\n");
    goto block;

  case NODE_BLOCK:
  block:
    printf("NODE_BLOCK:\n");
    tree = tree->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, (mrb_sym)n2->car->car));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, (mrb_sym)n->car));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, (mrb_sym)n));
      }
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car, offset+2);
    break;

  case NODE_IF:
    printf("NODE_IF:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("then:\n");
    parser_dump(mrb, tree->cdr->car, offset+2);
    if (tree->cdr->cdr->car) {
      dump_prefix(offset+1);
      printf("else:\n");
      parser_dump(mrb, tree->cdr->cdr->car, offset+2);
    }
    break;

  case NODE_AND:
    printf("NODE_AND:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_OR:
    printf("NODE_OR:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_CASE:
    printf("NODE_CASE:\n");
    if (tree->car) {
      parser_dump(mrb, tree->car, offset+1);
    }
    tree = tree->cdr;
    while (tree) {
      dump_prefix(offset+1);
      printf("case:\n");
      dump_recur(mrb, tree->car->car, offset+2);
      dump_prefix(offset+1);
      printf("body:\n");
      parser_dump(mrb, tree->car->cdr, offset+2);
      tree = tree->cdr;
    }
    break;

  case NODE_WHILE:
    printf("NODE_WHILE:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_UNTIL:
    printf("NODE_UNTIL:\n");
    dump_prefix(offset+1);
    printf("cond:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_FOR:
    printf("NODE_FOR:\n");
    dump_prefix(offset+1);
    printf("var:\n");
    {
      node *n2 = tree->car;

      if (n2->car) {
	dump_prefix(offset+2);
	printf("pre:\n");
	dump_recur(mrb, n2->car, offset+3);
      }
      n2 = n2->cdr;
      if (n2) {
	if (n2->car) {
	  dump_prefix(offset+2);
	  printf("rest:\n");
	  parser_dump(mrb, n2->car, offset+3);
	}
	n2 = n2->cdr;
	if (n2) {
	  if (n2->car) {
	    dump_prefix(offset+2);
	    printf("post:\n");
	    dump_recur(mrb, n2->car, offset+3);
	  }
	}
      }
    }
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("in:\n");
    parser_dump(mrb, tree->car, offset+2);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("do:\n");
    parser_dump(mrb, tree->car, offset+2);
    break;

  case NODE_SCOPE:
    printf("NODE_SCOPE:\n");
    dump_prefix(offset+1);
    printf("local variables:\n");
    {
      node *n2 = tree->car;

      while (n2) {
	dump_prefix(offset+2);
	printf("%s\n", mrb_sym2name(mrb, (mrb_sym)n2->car));
	n2 = n2->cdr;
      }
    }
    tree = tree->cdr;
    offset++;
    goto again;

  case NODE_FCALL:
  case NODE_CALL:
    printf("NODE_CALL:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("method='%s' (%d)\n", 
	   mrb_sym2name(mrb, (mrb_sym)tree->cdr->car),
	   (int)tree->cdr->car);
    tree = tree->cdr->cdr->car;
    if (tree) {
      dump_prefix(offset+1);
      printf("args:\n");
      dump_recur(mrb, tree->car, offset+2);
      if (tree->cdr) {
	dump_prefix(offset+1);
	printf("block:\n");
	parser_dump(mrb, tree->cdr, offset+2);
      }
    }
    break;

  case NODE_DOT2:
    printf("NODE_DOT2:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_DOT3:
    printf("NODE_DOT3:\n");
    parser_dump(mrb, tree->car, offset+1);
    parser_dump(mrb, tree->cdr, offset+1);
    break;

  case NODE_COLON2:
    printf("NODE_COLON2:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree->cdr));
    break;

  case NODE_COLON3:
    printf("NODE_COLON3:\n");
    dump_prefix(offset+1);
    printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_ARRAY:
    printf("NODE_ARRAY:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_HASH:
    printf("NODE_HASH:\n");
    while (tree) {
      dump_prefix(offset+1);
      printf("key:\n");
      parser_dump(mrb, tree->car->car, offset+2);
      dump_prefix(offset+1);
      printf("value:\n");
      parser_dump(mrb, tree->car->cdr, offset+2);
      tree = tree->cdr;
    }
    break;

  case NODE_SPLAT:
    printf("NODE_SPLAT:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_ASGN:
    printf("NODE_ASGN:\n");
    dump_prefix(offset+1);
    printf("lhs:\n");
    parser_dump(mrb, tree->car, offset+2);
    dump_prefix(offset+1);
    printf("rhs:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_MASGN:
    printf("NODE_MASGN:\n");
    dump_prefix(offset+1);
    printf("mlhs:\n");
    {
      node *n2 = tree->car;

      if (n2->car) {
	dump_prefix(offset+2);
	printf("pre:\n");
	dump_recur(mrb, n2->car, offset+3);
      }
      n2 = n2->cdr;
      if (n2) {
	if (n2->car) {
	  dump_prefix(offset+2);
	  printf("rest:\n");
	  parser_dump(mrb, n2->car, offset+3);
	}
	n2 = n2->cdr;
	if (n2) {
	  if (n2->car) {
	    dump_prefix(offset+2);
	    printf("post:\n");
	    dump_recur(mrb, n2->car, offset+3);
	  }
	}
      }
    }
    dump_prefix(offset+1);
    printf("rhs:\n");
    parser_dump(mrb, tree->cdr, offset+2);
    break;

  case NODE_OP_ASGN:
    printf("NODE_OP_ASGN:\n");
    dump_prefix(offset+1);
    printf("lhs:\n");
    parser_dump(mrb, tree->car, offset+2);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("op='%s' (%d)\n", mrb_sym2name(mrb, (mrb_sym)tree->car), (int)tree->car);
    tree = tree->cdr;
    parser_dump(mrb, tree->car, offset+1);
    break;

  case NODE_SUPER:
    printf("NODE_SUPER:\n");
    if (tree) {
      dump_prefix(offset+1);
      printf("args:\n");
      dump_recur(mrb, tree->car, offset+2);
      if (tree->cdr) {
	dump_prefix(offset+1);
	printf("block:\n");
	parser_dump(mrb, tree->cdr, offset+2);
      }
    }
    break;

  case NODE_ZSUPER:
    printf("NODE_ZSUPER\n");
    break;

  case NODE_RETURN:
    printf("NODE_RETURN:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_YIELD:
    printf("NODE_YIELD:\n");
    dump_recur(mrb, tree, offset+1);
    break;

  case NODE_BREAK:
    printf("NODE_BREAK:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_NEXT:
    printf("NODE_NEXT:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_REDO:
    printf("NODE_REDO\n");
    break;

  case NODE_RETRY:
    printf("NODE_RETRY\n");
    break;

  case NODE_LVAR:
    printf("NODE_LVAR %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_GVAR:
    printf("NODE_GVAR %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_IVAR:
    printf("NODE_IVAR %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_CVAR:
    printf("NODE_CVAR %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_CONST:
    printf("NODE_CONST %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_BACK_REF:
    printf("NODE_BACK_REF:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_NTH_REF:
    printf("NODE_NTH_REF:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_ARG:
    printf("NODE_ARG %s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_BLOCK_ARG:
    printf("NODE_BLOCK_ARG:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_INT:
    printf("NODE_INT %s base %d\n", (char*)tree->car, (int)tree->cdr->car);
    break;

  case NODE_FLOAT:
    printf("NODE_FLOAT %s\n", (char*)tree);
    break;

  case NODE_NEGATE:
    printf("NODE_NEGATE\n");
    parser_dump(mrb, tree, offset+1);
    break;

  case NODE_STR:
    printf("NODE_STR \"%s\" len %d\n", (char*)tree->car, (int)tree->cdr);
    break;

  case NODE_SYM:
    printf("NODE_SYM :%s\n", mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_SELF:
    printf("NODE_SELF\n");
    break;

  case NODE_NIL:
    printf("NODE_NIL\n");
    break;

  case NODE_TRUE:
    printf("NODE_TRUE\n");
    break;

  case NODE_FALSE:
    printf("NODE_FALSE\n");
    break;

  case NODE_ALIAS:
    printf("NODE_ALIAS %s %s:\n",
	   mrb_sym2name(mrb, (mrb_sym)tree->car),
	   mrb_sym2name(mrb, (mrb_sym)tree->cdr));
    break;

  case NODE_UNDEF:
    printf("NODE_UNDEF %s:\n",
	   mrb_sym2name(mrb, (mrb_sym)tree));
    break;

  case NODE_CLASS:
    printf("NODE_CLASS:\n");
    if (tree->car->car == (node*)0) {
      dump_prefix(offset+1);
      printf(":%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    else if (tree->car->car == (node*)1) {
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    else {
      parser_dump(mrb, tree->car->car, offset+1);
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    if (tree->cdr->car) {
      dump_prefix(offset+1);
      printf("super:\n");
      parser_dump(mrb, tree->cdr->car, offset+2);
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->cdr->car->cdr, offset+2);
    break;

  case NODE_MODULE:
    printf("NODE_MODULE:\n");
    if (tree->car->car == (node*)0) {
      dump_prefix(offset+1);
      printf(":%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    else if (tree->car->car == (node*)1) {
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    else {
      parser_dump(mrb, tree->car->car, offset+1);
      dump_prefix(offset+1);
      printf("::%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car->cdr));
    }
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car->cdr, offset+2);
    break;

  case NODE_SCLASS:
    printf("NODE_SCLASS:\n");
    parser_dump(mrb, tree->car, offset+1);
    dump_prefix(offset+1);
    printf("body:\n");
    parser_dump(mrb, tree->cdr->car->cdr, offset+2);
    break;

  case NODE_DEF:
    printf("NODE_DEF:\n");
    dump_prefix(offset+1);
    printf("%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car));
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf("local variables:\n");
    {
      node *n2 = tree->car;

      while (n2) {
	dump_prefix(offset+2);
	if (n2->car)
	  printf("%s\n", mrb_sym2name(mrb, (mrb_sym)n2->car));
	n2 = n2->cdr;
      }
    }
    tree = tree->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, (mrb_sym)n2->car->car));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, (mrb_sym)n->car));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, (mrb_sym)n));
      }
    }
    parser_dump(mrb, tree->cdr->car, offset+1);
    break;

  case NODE_SDEF:
    printf("NODE_SDEF:\n");
    parser_dump(mrb, tree->car, offset+1);
    tree = tree->cdr;
    dump_prefix(offset+1);
    printf(":%s\n", mrb_sym2name(mrb, (mrb_sym)tree->car));
    tree = tree->cdr->cdr;
    if (tree->car) {
      node *n = tree->car;

      if (n->car) {
	dump_prefix(offset+1);
	printf("mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("optional args:\n");
	{
	  node *n2 = n->car;

	  while (n2) {
	    dump_prefix(offset+2);
	    printf("%s=", mrb_sym2name(mrb, (mrb_sym)n2->car->car));
	    parser_dump(mrb, n2->car->cdr, 0);
	    n2 = n2->cdr;
	  }
	}
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("rest=*%s\n", mrb_sym2name(mrb, (mrb_sym)n->car));
      }
      n = n->cdr;
      if (n->car) {
	dump_prefix(offset+1);
	printf("post mandatory args:\n");
	dump_recur(mrb, n->car, offset+2);
      }
      n = n->cdr;
      if (n) {
	dump_prefix(offset+1);
	printf("blk=&%s\n", mrb_sym2name(mrb, (mrb_sym)n));
      }
    }
    tree = tree->cdr;
    parser_dump(mrb, tree->car, offset+1);
    break;

  case NODE_POSTEXE:
    printf("NODE_POSTEXE:\n");
    parser_dump(mrb, tree, offset+1);
    break;

  default:
    printf("node type: %d (0x%x)\n", (int)n, (int)n);
    break;
  }
  return;
}

#ifdef PARSER_TEST
int
main()
{
  mrb_state *mrb = mrb_open();
  int n;

  n = mrb_compile_string(mrb, "\
def fib(n)\n\
  if n<2\n\
    n\n\
  else\n\
    fib(n-2)+fib(n-1)\n\
  end\n\
end\n\
print(fib(20), \"\\n\")\n\
");
  printf("ret: %d\n", n);

  return 0;
}
#endif

